<?php
require_once(KT_LIB_DIR . '/authentication/authenticationprovider.inc.php');
require_once(KT_LIB_DIR . '/authentication/Authenticator.inc');
define('USER_GROUPS','/config/config_import.php');

class MyAuthenticationProvider extends KTAuthenticationProvider 
{
    var $sName = "My authentication provider";
    var $sNamespace = "my.authentication.provider";
    var $sRemoteURL = "http://localhost/absoauth/?url=integration_server/get4elib/%s/nodebug";
    var $sChipherKey = "w0izlyoiswnkdcuj5ke7h8cnliaex69zd1il4q10";
    
    
     /**
     * Decryptes an encrypted string specified by $encrypted using the mcrypt
     * module specified by $method
     *
     *    @param string $encrypted    
     *    @param string $method
     *    @return string                    Decrypted plain text.
    */
    function _decrypt($encrypted, $method='rijndael-256')
    {
        $td = mcrypt_module_open($method, '', 'ecb', '');
        $iv = mcrypt_create_iv(mcrypt_enc_get_iv_size($td), MCRYPT_RAND);
        $key_length = mcrypt_enc_get_key_size($td);
        
        // Chop the key to the correct size.
        $key = substr(md5($this->sChipherKey), 0, $key_length);
        
        mcrypt_generic_init($td, $key, $iv);
        return rtrim(mdecrypt_generic($td, $encrypted));
    }
    
	function &getAuthenticator($oSource) 
	{
        $oAuth = new MyAuthenticator($oSource);
        $oAuth->oAuthProvider = &$this;
        return $oAuth;
    }
    
    function getRemoteUserInfo($codbar) {
    	// initialise the session, this time with no URL
    	$ch = curl_init();

    	// Set the URL, which includes $word, and is of the dict protocol
    	curl_setopt($ch, CURLOPT_URL, sprintf($this->sRemoteURL, $codbar));

    	// Return the output from the cURL session rather than displaying in the browser.
    	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

    	//Execute the session, returning the results to $definition, and close.
    	$data = curl_exec($ch);
    	curl_close($ch);
		
    	return $data;
    }
    
    function updateUserExpiration($oUser) {
    	$_data   = json_decode($this->getRemoteUserInfo($oUser->getUserName()));
  		$data = json_decode($this->_decrypt(base64_decode($_data->encrypted)));

  		if (!is_a($data->Usager, 'StdClass') || is_null($data->Usager->id)) {
  			return false;
  		}
  		
  		$_oexpiry  = &$data->Usager->expiry;
  		$_expiry   = array($_oexpiry->year, $_oexpiry->month, $_oexpiry->day);
			
		$sExpiry   = (is_string($_oexpiry))? substr($_oexpiry,0,10) : implode('-', $_expiry);
		$oUser->updateFromArray(array( 
            'authenticationdetailsdate1' => $sExpiry
         ));
         return $oUser;
    }
      
    function autoSignup($sUsername, $sPassword, $aExtra, $oSource) 
    {   
    	$codbar = $sUsername;
  		$iCodbar = intval($codbar);
  		
  		// Deny signup if provided username is not valid codbar (NaN) or anyway converts to zero
  		if ($iCodbar == 0) return;
  		
  		$oUser =& User::getByUserName($iCodbar);
  		if($oUser->iId){
  			if(KTAuthenticationUtil::checkPassword($oUser, $sPassword)){
  				return $oUser;
  			} else {
  				return ;
  			}
  		}
        
  		$_data = json_decode($this->getRemoteUserInfo($codbar));
  		$data = json_decode($this->_decrypt(base64_decode($_data->encrypted)));

  		// Check usager data
  		// /* something wrong with integration server */ and /* user not found*/
  		if (!is_a($data->Usager, 'StdClass')  || is_null($data->Usager->id)  ){
  			return;
  		}
  		
  		// Deny auto signup if provided password is not equal to external password
  		if ($sPassword != $data->Usager->password) return; 
  		
  		// Determine auto signup user details
  		//
  		$sName = implode(' ', array($data->Usager->nom, $data->Usager->prenom));  		
  		$sPassword = $data->Usager->password;		
  		$_oexpiry  = &$data->Usager->expiry;
  		$_expiry   = array($_oexpiry->year, $_oexpiry->month, $_oexpiry->day);
		$sExpiry   = (is_string($_oexpiry))? substr($_oexpiry,0,10) : implode('-', $_expiry);	
		$_oin  = &$data->Usager->dateinscription;
		$_in  = array($_oin->year, $_oin->month, $_oin->day);
		$sIn   = implode('-', $_in);
  		
		$aUser = array( 
            'Username' => $iCodbar,
            'Name' => $sName,
            'EmailNotification' => true,
            'SmsNotification' => false,
            'MaxSessions' => 3,
            'email' => @$data->Usager->email,
            'authenticationsourceid' => $oSource->getId(),
            'authenticationdetails' => sha1($sPassword),
            'authenticationdetailsdate1' => $sExpiry,
            'authenticationdetailsdate2' => $sIn,
            'password'=>''
        );
	
        // automatically create a new user on the system
        $oUser = User::createFromArray($aUser);
        
        // Определим нового пользователя в нужную группу
        $this->getAuthenticator('')->_setUserGroup($oUser);
         
        return $oUser;
    }
}

class MyAuthenticator extends Authenticator 
{
	var $oAuthProvider;
		
    function _setUserGroup($oUser) {
    	
    	// get params
    	include_once(KT_DIR . USER_GROUPS);
		foreach ($params as $name => $ip_conf) {
			if($this->isIpInNetwork($_SERVER['HTTP_HOST'], $ip_conf['network'], $ip_conf['mask'])) {
				$ip[abs(ip2long($ip_conf['mask']))] = $name;
			}
    	}
    	
    	ksort($ip);
    	$default = array_shift($ip);
    	$group = array_shift($ip);
    	
    	$group = (strlen($group) > 0) ? $group : $default;
    	
    	$aGroups = KTEntityUtil::getByDict('Group', 
	    	array('is_sys_admin' => false,),
	    	array('multi' => 'true',)
	    );
        if(!PEAR::isError($aGroups) && !empty($aGroups)){
            foreach ($aGroups as $oGroup) {
		    	if($oGroup->getName() == $group){
		    		$oGroup->addMember($oUser);
		    	} else {
		    		$oGroup->removeMember($oUser);
	    		}
	    	}
        }
    	
    }
    
    function redirect($message) {
    	$redirect = strip_tags(KTUtil::arrayGet($_REQUEST, 'redirect'));
    	$url = $_SERVER["PHP_SELF"];
        $queryParams = array();
        
        if (!empty($redirect)) {
            $queryParams[] = 'redirect=' . urlencode($redirect);
        }
        
        LoginPageDispatcher::simpleRedirectToMain($message, $url, $queryParams);
    }
	
	function checkPassword($oUser, $sPassword) 
    {
    	if (empty($sPassword)) {
            $this->redirect(_kt('Please enter your password.'));
            exit(0);
        }
		
    	// get user password hash
        $info = $oUser->getAuthenticationDetails(); 
        $this->_setUserGroup($oUser);
        
        if (self::isExpired($oUser)) {
        	// Проверим, не продлен ли абонемент пользователя в АИБС
        	$oUser = $this->oAuthProvider->updateUserExpiration($oUser);
        	
        	// если абонемент все еще просрочен
        	if(self::isExpired($oUser)) {
        		$this->redirect(_kt('Ваш абонемент не продлён. Обратитесь в библиотеку.'));
            	exit(0);
        	}
        }      
 
        return (sha1($sPassword) == $info);
    }
    
    function isExpired($oUser) 
    {
        $expiry = $oUser->getAuthenticationDetailsDate1();
        return (strtotime($expiry) < time());
    }
    
    function isIpInNetwork($ip,$network,$mask){
		return ( (ip2long($ip) & ip2long($mask)) == ip2long($network)) ;
	}
}
?>