<?php

/**
 * Class to convert PDFs to Images
 *
 */

class PdfToImagesConverter
{
	
	public $resize = 800;
	public $quality = 100;
	public $colorspace = 'RGB';
	public $density = 300;
	public $repository_path;
	public $available_status = array(1,2,5,6);
	function __construct()
	{
		$this->repository_path = SECVIEW_REPOSITORY_PATH;
		$oJSON = new Services_JSON(); 
		$this->settings = $oJSON->decode(KTUtil::getSystemSetting("sec-view-plugin-settings"));
		//var_dump($this->settings->colorspace_small_slow);
		if(!$this->settings->convert_path)
		{
			die("An error occured: Invalid Image Magick convert path.");
		}
	}
	 
	/**
	 * Writes log to a log file
	 *
	 * @param string $txt log text
	 * @param file $logfile log file
	 */
	public function writeLog($txt,$logfile = null)
	{
		if($logfile == null)
		{
			$logfile = KT_DIR.SECVIEW_ODV_LOG_FILE;
		}
		if(@filesize($logfile) > 10000)
		{
			@unlink($logfile);
		}
		file_put_contents($logfile,date('r').":".$txt."\n",FILE_APPEND);
	}
	
	public function convertPdf($src, $id_document, $ext, $extra_props = array(), $byPage = true)
	{
		
		$tempname = time();
		if(!is_file($src) || filesize($src) == 0)
		{
			die("An error occured: Invalid source file (PDF conversion error - corrupt source file) ".$src);
		}
		
		$pdf_page_count = $this->getPDFPageCount($src);
		
		$this->ClearDocumentRepository($id_document);
		
		if($pdf_page_count && $byPage)
		{
			for($i=0;$i<$pdf_page_count ;$i++)
			{
				//var_dump(KT_DIR.'/plugins/secView/pdf2image/convert.lnk -quality '.$this->quality.' -colorspace '.$this->colorspace.' -density '.$this->density.' '.$src .'['.$i.'] -resize "'.$this->resize.'x800"'.' -quality '. $this->quality .' '.$this->repository_path.$id_document.'/'.$id_document.'-page-'.$i.'.'.$ext);
				
				$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_small_slow.
									' -colorspace '.$this->settings->colorspace_small_slow.
									' -density '.$this->settings->density_small_slow.' '.$src .'['.$i.'] -resize '.$this->settings->resize_small_slow.
									' -quality '. $this->settings->quality_small_slow .
									' '.$this->repository_path.$id_document.'/small/slow/'.$id_document.'-page-'.$i.'.'.$ext,$out,$err));
				$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_middle_slow.
									' -colorspace '.$this->settings->colorspace_middle_slow.
									' -density '.$this->settings->density_middle_slow.' '.$src .'['.$i.'] -resize '.$this->settings->resize_middle_slow.
									' -quality '. $this->settings->quality_middle_slow .
									' '.$this->repository_path.$id_document.'/middle/slow/'.$id_document.'-page-'.$i.'.'.$ext,$out,$err));
				$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_large_slow.
									' -colorspace '.$this->settings->colorspace_large_slow.
									' -density '.$this->settings->density_large_slow.' '.$src .'['.$i.'] -resize '.$this->settings->resize_large_slow.
									' -quality '. $this->settings->quality_large_slow .
									' '.$this->repository_path.$id_document.'/large/slow/'.$id_document.'-page-'.$i.'.'.$ext,$out,$err));										
				$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_small.
									' -colorspace '.$this->settings->colorspace_small.
									' -density '.$this->settings->density_small.' '.$src .'['.$i.'] -resize '.$this->settings->resize_small.
									' -quality '. $this->settings->quality_small .
									' '.$this->repository_path.$id_document.'/small/fast/'.$id_document.'-page-'.$i.'.'.$ext,$out,$err));
				$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_middle.
									' -colorspace '.$this->settings->colorspace_middle.
									' -density '.$this->settings->density_middle.' '.$src .'['.$i.'] -resize '.$this->settings->resize_middle.
									' -quality '. $this->settings->quality_middle .
									' '.$this->repository_path.$id_document.'/middle/fast/'.$id_document.'-page-'.$i.'.'.$ext,$out,$err));
				$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_large.
									' -colorspace '.$this->settings->colorspace_large.
									' -density '.$this->settings->density_large.' '.$src .'['.$i.'] -resize '.$this->settings->resize_large.
									' -quality '. $this->settings->quality_large .
									' '.$this->repository_path.$id_document.'/large/fast/'.$id_document.'-page-'.$i.'.'.$ext,$out,$err));					
				@set_time_limit(120);
			}
		}
		else
		{
			$this->writeLog(exec($this->settings->convert_path.' -verbose -quality '.$this->settings->quality_small_slow.
									' -colorspace '.$this->settings->colorspace_small_slow.
									' -density '.$this->settings->density_small_slow.' '.$src .' -resize '.$this->settings->resize_small_slow.
									' -quality '. $this->settings->quality_small_slow .
									' '.$this->repository_path.$id_document.'/small/slow/'.$id_document.'-page-%d.'.$ext,$out,$err));
			@set_time_limit(120);
			$pdf_page_count = count($out)/3;						
			$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_middle_slow.
									' -colorspace '.$this->settings->colorspace_middle_slow.
									' -density '.$this->settings->density_middle_slow.' '.$src .' -resize '.$this->settings->resize_middle_slow.
									' -quality '. $this->settings->quality_middle_slow .
									' '.$this->repository_path.$id_document.'/middle/slow/'.$id_document.'-page-%d.'.$ext,$out,$err));
			@set_time_limit(120);						
			$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_large_slow.
									' -colorspace '.$this->settings->colorspace_large_slow.
									' -density '.$this->settings->density_large_slow.' '.$src .' -resize '.$this->settings->resize_large_slow.
									' -quality '. $this->settings->quality_large_slow .
									' '.$this->repository_path.$id_document.'/large/slow/'.$id_document.'-page-%d.'.$ext,$out,$err));
			@set_time_limit(120);																
			$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_small.
									' -colorspace '.$this->settings->colorspace_small.
									' -density '.$this->settings->density_small.' '.$src .' -resize '.$this->settings->resize_small.
									' -quality '. $this->settings->quality_small .
									' '.$this->repository_path.$id_document.'/small/fast/'.$id_document.'-page-%d.'.$ext,$out,$err));
			@set_time_limit(120);						
			$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_middle.
									' -colorspace '.$this->settings->colorspace_middle.
									' -density '.$this->settings->density_middle.' '.$src .' -resize '.$this->settings->resize_middle.
									' -quality '. $this->settings->quality_middle .
									' '.$this->repository_path.$id_document.'/middle/fast/'.$id_document.'-page-%d.'.$ext,$out,$err));
			@set_time_limit(120);						
			$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_large.
									' -colorspace '.$this->settings->colorspace_large.
									' -density '.$this->settings->density_large.' '.$src .' -resize '.$this->settings->resize_large.
									' -quality '. $this->settings->quality_large .
									' '.$this->repository_path.$id_document.'/large/fast/'.$id_document.'-page-%d.'.$ext,$out,$err));
			@set_time_limit(120);						
		}
		$this->writeLog("\n========================================\n\n");

		//delete old property file
		//@unlink($this->repository_path.$id_document.'/'.$id_document.".prop");
		
		//write property file
		file_put_contents($this->repository_path.$id_document.'/'.$id_document.".prop",serialize(array_merge(array('page_count'=>$pdf_page_count),$extra_props)));
	}
	public function isHashExist($id_document, $page, $size, $quality)
	{
		if(file_exists($this->repository_path.$id_document.'/'.$size.'/'.$quality.'/'.$id_document.'-page-'.$page.'.jpg'))
		{
			return true;
		}
		return false;
	}
	public function convertPdfPage($src, $id_document, $page, $size, $quality)
	{
		
		$tempname = time();
		if(!is_file($src) || filesize($src) == 0)
		{
			die("An error occured: Invalid source file (PDF conversion error - corrupt source file) ".$src);
		}
		
		//$pdf_page_count = $this->getPDFPageCount($src);
		if(!is_dir($this->repository_path.$id_document.'/'.$size))
		{
			@mkdir($this->repository_path.$id_document.'/'.$size);
		}
		if(!is_dir($this->repository_path.$id_document.'/'.$size.'/'.$quality))
		{
			@mkdir($this->repository_path.$id_document.'/'.$size.'/'.$quality);
		}
		
		//if($page<$pdf_page_count)
		{
			if($size == "small" && $quality == "slow")
			{
				$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_small_slow.
									' -colorspace '.$this->settings->colorspace_small_slow.
									' -density '.$this->settings->density_small_slow.' '.$src .'['.$page.'] -resize '.$this->settings->resize_small_slow.
									' -quality '. $this->settings->quality_small_slow .
									' '.$this->repository_path.$id_document.'/small/slow/'.$id_document.'-page-'.$page.'.jpg',$out,$err));
			}
			elseif($size == "middle" && $quality == "slow")
			{					
				$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_middle_slow.
									' -colorspace '.$this->settings->colorspace_middle_slow.
									' -density '.$this->settings->density_middle_slow.' '.$src .'['.$page.'] -resize '.$this->settings->resize_middle_slow.
									' -quality '. $this->settings->quality_middle_slow .
									' '.$this->repository_path.$id_document.'/middle/slow/'.$id_document.'-page-'.$page.'.jpg',$out,$err));
			}
			elseif($size == "large" && $quality == "slow")
			{					
				$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_large_slow.
									' -colorspace '.$this->settings->colorspace_large_slow.
									' -density '.$this->settings->density_large_slow.' '.$src .'['.$page.'] -resize '.$this->settings->resize_large_slow.
									' -quality '. $this->settings->quality_large_slow .
									' '.$this->repository_path.$id_document.'/large/slow/'.$id_document.'-page-'.$page.'.jpg',$out,$err));
			}
			elseif($size == "small" && $quality == "fast")															
			{
				$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_small.
									' -colorspace '.$this->settings->colorspace_small.
									' -density '.$this->settings->density_small.' '.$src .'['.$page.'] -resize '.$this->settings->resize_small.
									' -quality '. $this->settings->quality_small .
									' '.$this->repository_path.$id_document.'/small/fast/'.$id_document.'-page-'.$page.'.jpg',$out,$err));
			}
			elseif($size == "middle" && $quality == "fast")
			{					
				$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_middle.
									' -colorspace '.$this->settings->colorspace_middle.
									' -density '.$this->settings->density_middle.' '.$src .'['.$page.'] -resize '.$this->settings->resize_middle.
									' -quality '. $this->settings->quality_middle .
									' '.$this->repository_path.$id_document.'/middle/fast/'.$id_document.'-page-'.$page.'.jpg',$out,$err));
			}
			elseif($size == "large" && $quality == "fast")
			{
				$this->writeLog(exec($this->settings->convert_path.' -quality '.$this->settings->quality_large.
									' -colorspace '.$this->settings->colorspace_large.
									' -density '.$this->settings->density_large.' '.$src .'['.$page.'] -resize '.$this->settings->resize_large.
									' -quality '. $this->settings->quality_large .
									' '.$this->repository_path.$id_document.'/large/fast/'.$id_document.'-page-'.$page.'.jpg',$out,$err));					
			}
			
		}
		
		$this->writeLog("\n========================================\n\n");
		
	}
	public function GetDirectory($name, $escape_arr = array(".","..")){
		$dir = $name;
		$dh  = opendir($dir);
		$files = array();
		while (false !== ($filename = readdir($dh))) {
		    $files[] = $filename;
		}
		$f = array();
		for ($i=0;$i<count($files);$i++)
			if (!in_array($files[$i],$escape_arr)) {
				$f[] = $files[$i];
			}
		$files = $f;
		rsort($files);
		return $files;
	}
	private function ClearDir($dir)
	{
		if(!is_dir($dir))
		{
			@mkdir($dir);
			return true;
		}
		$files = $this->GetDirectory($dir);
		foreach($files as $v)
		{
			if(is_file($dir.'/'.$v))
			{
				@unlink($dir.'/'.$v);
			}
		}
		return true;
	}
	public function ClearDocumentRepository($id_document)
	{
		$this->ClearDir($this->repository_path.$id_document.'/pdf');
		$this->ClearDir($this->repository_path.$id_document.'/small');
		$this->ClearDir($this->repository_path.$id_document.'/middle');
		$this->ClearDir($this->repository_path.$id_document.'/large');
		$this->ClearDir($this->repository_path.$id_document.'/small/slow');
		$this->ClearDir($this->repository_path.$id_document.'/small/fast');
		$this->ClearDir($this->repository_path.$id_document.'/middle/slow');
		$this->ClearDir($this->repository_path.$id_document.'/middle/fast');
		$this->ClearDir($this->repository_path.$id_document.'/large/slow');
		$this->ClearDir($this->repository_path.$id_document.'/large/fast');
		$this->ClearDir($this->repository_path.$id_document);
	}
	public function unlinkDocumentRepository($id_document, $try_again = true)
	{
		@rmdir($this->repository_path.$id_document.'/pdf');
		@rmdir($this->repository_path.$id_document.'/small/slow');
		@rmdir($this->repository_path.$id_document.'/small/fast');
		@rmdir($this->repository_path.$id_document.'/small');
		@rmdir($this->repository_path.$id_document.'/middle/slow');
		@rmdir($this->repository_path.$id_document.'/middle/fast');
		@rmdir($this->repository_path.$id_document.'/middle');
		@rmdir($this->repository_path.$id_document.'/large/slow');
		@rmdir($this->repository_path.$id_document.'/large/fast');
		@rmdir($this->repository_path.$id_document.'/large');
		var_dump(rmdir($this->repository_path.$id_document));
		var_dump($this->repository_path.$id_document);
		if(!rmdir($this->repository_path.$id_document) && $try_again)
		{
			$this->unlinkDocumentRepository($id_document, false);
		}
	}
	public function getPDFPageCount($file)
	{
		$page_count = $this->getPDFPageCountFast($file);
		if($page_count)
		{
			return $page_count;
		}
		$this->writeLog(exec($this->settings->identify_path.' '.$file,$out,$err));
		return count($out);
	}
	private function getPDFPageCountFast($file)
	{
		if(file_exists($file)) 
		{
			if($handle = @fopen($file, "rb")) 
			{
		        $count = 0;
		        $i=0;
		        while (!feof($handle)) 
				{
		            if($i > 0) 
					{
		                $contents .= fread($handle,8152);
		            }
		            else 
					{
						$contents = fread($handle, 1000);
		                //In some pdf files, there is an N tag containing the number of
		                //of pages. This doesn't seem to be a result of the PDF version.
		                //Saves reading the whole file.
		                if(preg_match("/\/N\s+([0-9]+)/", $contents, $found)) 
						{
		                    return $found[1];
		                }
		            }
		            $i++;
		        }
		        fclose($handle);
		
		        //get all the trees with 'pages' and 'count'. the biggest number
		        //is the total number of pages, if we couldn't find the /N switch above.                
		        if(preg_match_all("/\/Type\s*\/Pages\s*.*\s*\/Count\s+([0-9]+)/", $contents, $capture, PREG_SET_ORDER)) 
				{
		            foreach($capture as $c) 
					{
		                if($c[1] > $count)
		                    $count = $c[1];
		            }
		            return $count;            
		        }
		    }
		}
		return 0;
	}

}
?>
