<?php
require_once(KT_LIB_DIR . '/dispatcher.inc.php');

/**
 * Dispatches the the configuration page
 */
class ConfigureSecViewDispatcher extends KTAdminDispatcher {
	/**
	 * Show the configuration page
	 *
	 * @return the template data
	 */
	function do_main(){
		//set breadcrumbs
		$this->oPage->setBreadcrumbDetails(_kt('Online Viewer settings'));
		 
		if($_POST['saveSettings']){ //form submitted
			$this->form_submit();
		}
		$oJSON = new Services_JSON(); 
		$settings = $oJSON->decode(KTUtil::getSystemSetting("sec-view-plugin-settings"));
		
		$arr_of_ColorSpace = array(
					"CMY",
					"CMYK",
					"Gray",
					"HSB",
					"HSL",
					"HWB",
					"Lab",
					"Log",
					"OHTA",
					"Rec601Luma",
					"Rec601YCbCr",
					"Rec709Luma",
					"Rec709YCbCr",
					"RGB",
					"sRGB",
					"Transparent",
					"XYZ",
					"YCbCr",
					"YCC",
					"YIQ",
					"YPbPr",
					"YUV"
		);
		
		
		//render template
		$oTemplating =& KTTemplating::getSingleton();
		$oTemplate = $oTemplating->loadTemplate("secView/configure");
		$aTemplateData = array(
			'quality_small'=>$settings->quality_small,
			'resize_small'=>$settings->resize_small,
			'colorspace_small'=>$settings->colorspace_small,
			'density_small'=>$settings->density_small,
			
			'quality_middle'=>$settings->quality_middle,
			'resize_middle'=>$settings->resize_middle,
			'colorspace_middle'=>$settings->colorspace_middle,
			'density_middle'=>$settings->density_middle,
			
			'quality_large'=>$settings->quality_large,
			'resize_large'=>$settings->resize_large,
			'colorspace_large'=>$settings->colorspace_large,
			'density_large'=>$settings->density_large,
			
			'quality_small_slow'=>$settings->quality_small_slow,
			'resize_small_slow'=>$settings->resize_small_slow,
			'colorspace_small_slow'=>$settings->colorspace_small_slow,
			'density_small_slow'=>$settings->density_small_slow,
			
			'quality_middle_slow'=>$settings->quality_middle_slow,
			'resize_middle_slow'=>$settings->resize_middle_slow,
			'colorspace_middle_slow'=>$settings->colorspace_middle_slow,
			'density_middle_slow'=>$settings->density_middle_slow,
			
			'quality_large_slow'=>$settings->quality_large_slow,
			'resize_large_slow'=>$settings->resize_large_slow,
			'colorspace_large_slow'=>$settings->colorspace_large_slow,
			'density_large_slow'=>$settings->density_large_slow,
			
			'convert_path'=>$settings->convert_path,
			'identify_path'=>$settings->identify_path,
			
			'plugin_width'=>$settings->plugin_width,
			'plugin_height'=>$settings->plugin_height,
			'plugin_creation_possibility' => ($settings->plugin_creation_possibility)?"checked":"",
			
			'array_of_colorSpace'=>$arr_of_ColorSpace
		);
		$aTemplateData['i18n_domain'] ='plugins';
		return $oTemplate->render($aTemplateData);
	}

	/**
	 * Handle the form submit, and update settings
	 *
	 */
	function form_submit(){
		
		$this->checkChange();
		
		$oJSON = new Services_JSON();
		$settings = array(
			'quality_small' 		=> @$_POST['imagick_quality_small'],
			'resize_small' 			=> @$_POST['imagick_resize_small'],
			'colorspace_small' 		=> @$_POST['imagick_colorspace_small'],
			'density_small' 		=> @$_POST['imagick_density_small'],
			
			'quality_middle' 		=> @$_POST['imagick_quality_middle'],
			'resize_middle' 		=> @$_POST['imagick_resize_middle'],
			'colorspace_middle' 	=> @$_POST['imagick_colorspace_middle'],
			'density_middle' 		=> @$_POST['imagick_density_middle'],
			
			'quality_large' 		=> @$_POST['imagick_quality_large'],
			'resize_large' 			=> @$_POST['imagick_resize_large'],
			'colorspace_large' 		=> @$_POST['imagick_colorspace_large'],
			'density_large' 		=> @$_POST['imagick_density_large'],
			
			'quality_small_slow' 	=> @$_POST['imagick_quality_small_slow'],
			'resize_small_slow' 	=> @$_POST['imagick_resize_small_slow'],
			'colorspace_small_slow' => @$_POST['imagick_colorspace_small_slow'],
			'density_small_slow' 	=> @$_POST['imagick_density_small_slow'],
			
			'quality_middle_slow' 	=> @$_POST['imagick_quality_middle_slow'],
			'resize_middle_slow' 	=> @$_POST['imagick_resize_middle_slow'],
			'colorspace_middle_slow'=> @$_POST['imagick_colorspace_middle_slow'],
			'density_middle_slow' 	=> @$_POST['imagick_density_middle_slow'],
			
			'quality_large_slow' 	=> @$_POST['imagick_quality_large_slow'],
			'resize_large_slow' 	=> @$_POST['imagick_resize_large_slow'],
			'colorspace_large_slow' => @$_POST['imagick_colorspace_large_slow'],
			'density_large_slow' 	=> @$_POST['imagick_density_large_slow'],
			
			'convert_path'			=> @$_POST['imagick_convert_path'],
			'identify_path'			=> @$_POST['imagick_identify_path'],
			
			'plugin_width'			=>@$_POST['plugin_width'],
			'plugin_height'			=>@$_POST['plugin_height'],
			'plugin_creation_possibility'=>@$_POST['plugin_creation_possibility']
		);
		$state = $oJSON->encode($settings);
		KTUtil::setSystemSetting("sec-view-plugin-settings",$state);
		$this->addInfoMessage(_kt("Settings saved"));
		
	}
	function checkChange()
	{
		$oJSON = new Services_JSON(); 
		$settings = $oJSON->decode(KTUtil::getSystemSetting("sec-view-plugin-settings"));
		
		if(
		($settings->quality_small 		!= @$_POST['imagick_quality_small']) 		||
		($settings->resize_small 		!= @$_POST['imagick_resize_small']) 		||
		($settings->colorspace_small 	!= @$_POST['imagick_colorspace_small']) 	||
		($settings->density_small 		!= @$_POST['imagick_density_small']) 		||
		($settings->quality_middle 		!= @$_POST['imagick_quality_middle']) 		||
		($settings->resize_middle 		!= @$_POST['imagick_resize_middle']) 		||
		($settings->colorspace_middle 	!= @$_POST['imagick_colorspace_middle']) 	||
		($settings->density_middle 		!= @$_POST['imagick_density_middle']) 		||
		($settings->quality_large 		!= @$_POST['imagick_quality_large']) 		||
		($settings->resize_large 		!= @$_POST['imagick_resize_large']) 		||
		($settings->colorspace_large 	!= @$_POST['imagick_colorspace_large']) 	||
		($settings->density_large 		!= @$_POST['imagick_density_large']) 		||
		
		($settings->quality_small_slow 		!= @$_POST['imagick_quality_small_slow']) 		||
		($settings->resize_small_slow 		!= @$_POST['imagick_resize_small_slow']) 		||
		($settings->colorspace_small_slow 	!= @$_POST['imagick_colorspace_small_slow']) 	||
		($settings->density_small_slow 		!= @$_POST['imagick_density_small_slow']) 		||
		($settings->quality_middle_slow 	!= @$_POST['imagick_quality_middle_slow']) 		||
		($settings->resize_middle_slow 		!= @$_POST['imagick_resize_middle_slow']) 		||
		($settings->colorspace_middle_slow 	!= @$_POST['imagick_colorspace_middle_slow']) 	||
		($settings->density_middle_slow 	!= @$_POST['imagick_density_middle_slow']) 		||
		($settings->quality_large_slow 		!= @$_POST['imagick_quality_large_slow']) 		||
		($settings->resize_large_slow 		!= @$_POST['imagick_resize_large_slow']) 		||
		($settings->colorspace_large_slow 	!= @$_POST['imagick_colorspace_large_slow']) 	||
		($settings->density_large_slow 		!= @$_POST['imagick_density_large_slow'])
		)
		{
			$this->ClearHash();
		}
	}
	function clearHash()
	{
		$DocumentList = Document::getList();
		if(PEAR::isError($DocumentList))
		{
			die();
		}
		require_once(SECVIEW_PLUGIN_PATH."PdfToImagesConverter.php");
		$PdftoImagesConverter = new PdftoImagesConverter();

		foreach($DocumentList as $Doc)
		{
			$PdftoImagesConverter->ClearDocumentRepository($Doc->getId());	
		}
	}
}

?>