<?php
require_once(KT_LIB_DIR . '/dispatcher.inc.php');
require_once(KT_DIR.'/plugins/SecView/_config.php');
require_once(KT_DIR . '/plugins/ktcore/scheduler/schedulerUtil.php');
/**
 * Dispatches the the configuration page
 */
class DocumentsStatusSecViewDispatcher extends KTAdminDispatcher {
	/**
	 * Show the configuration page
	 *
	 * @return the template data
	 */
	function do_main(){
		global $main;
		$this->oPage->setBreadcrumbDetails(_kt('SecView Document Status'));
		
		
		
		require_once(KT_DIR . '/' . SECVIEW_PLUGIN_PATH."PdfToImagesConverter.php");
		$PdftoImagesConverter = new PdftoImagesConverter();

		
		
		$DocumentList = Document::getList();
		if(PEAR::isError($DocumentList)){
			return false;
		}
		$Document_Count = 0;
		foreach($DocumentList as $Doc){
			if(!in_array($Doc->getStatusID(),$PdftoImagesConverter->available_status)) continue;
			$Document_Count++;
		}
		
		$Documents = array();
		$Documents_Pages_Total = 0;
		$Hash_Pages_Total = 0;
		
		$CurrentPage = intval(@$_GET['page'])?intval(@$_GET['page']):1;
		$CurrentItem = 0;
		
		$FromItem = ($CurrentPage-1)*SECVIEW_DOCUMENTSTATUS_ITEMS_ON_PAGE;
		$ToItem = $CurrentPage*SECVIEW_DOCUMENTSTATUS_ITEMS_ON_PAGE;
		
		foreach($DocumentList as $Doc){
			if(!in_array($Doc->getStatusID(),$PdftoImagesConverter->available_status)){ continue;}
			if($CurrentItem<$FromItem){
				$CurrentItem++; 
				continue;
			}elseif($CurrentItem>=$ToItem){ 
				break;
			}else { 
				$CurrentItem++; 
			}
			$Documents['FullPath'][] = $Doc->getFullPath();
			$Documents['DocumentId'][] = $Doc->getId();
			$task = schedulerEntity::getByTaskName("SecView Cron ".$Doc->getId());
			
			if(PEAR::isError($task)){
				$Documents['DocumentShowRun'][] = true;
			}else{
				$Documents['DocumentShowRun'][] = false;
			}
			
			$clear_Hash = false;
			
			if(file_exists(SECVIEW_REPOSITORY_PATH.$Doc->getId()."/".$Doc->getId().".prop"))
			{
				$props = unserialize(file_get_contents(SECVIEW_REPOSITORY_PATH.$Doc->getId()."/".$Doc->getId().".prop"));
				if(isset($props['content_version']) && $props['content_version'] != $Doc->getContentVersionId()){
					$clear_Hash = true;
				}
			}else{
				$clear_Hash = true;
			}
			
			if($clear_Hash){
				$PdftoImagesConverter->ClearDocumentRepository($Doc->getId());
				$Documents['PageCount'][] = '?';
			} else {
				if(isset($props['page_count'])) {
					$Documents['PageCount'][] = $props['page_count'];
					$Documents_Pages_Total += $props['page_count'];			
				} else {
					$Documents['PageCount'][] = '?';
				}
			}
		}
		
		
		$main->requireCSSresource( SECVIEW_PLUGIN_PATH . "css/SecView-admin.css");
		
		$main->requireJSResource("thirdpartyjs/extjs/adapter/prototype/prototype.js");
        $main->requireJSResource(SECVIEW_PLUGIN_PATH . "js/SecViewPluginAdmin.js");
		
		
		$oTemplating =& KTTemplating::getSingleton();
		$oTemplate = $oTemplating->loadTemplate("secView/documentsStatus");
		$aTemplateData = array(	
			'FullPath'=>$Documents['FullPath'],
			'DocumentId'=>$Documents['DocumentId'],
			'PageCount'=>$Documents['PageCount'],
			'DocumentShowRun'=>$Documents['DocumentShowRun'],
			'PageTotal'=>$Documents_Pages_Total,
			'HashTotal'=>$Hash_Pages_Total,
			'plugin_path'=>SECVIEW_PLUGIN_PATH,
			'page_url'=>$_SERVER['PHP_SELF'],
			'currentPage' => $CurrentPage,
			'pages' => range(1,ceil($Document_Count/SECVIEW_DOCUMENTSTATUS_ITEMS_ON_PAGE)), 
			'documentstatus_next'=>($Document_Count>($CurrentPage*SECVIEW_DOCUMENTSTATUS_ITEMS_ON_PAGE)),
			'documentstatus_prev'=>($CurrentPage>1),
			'documentstatus_page'=>$CurrentPage,
			'i18n_domain' => 'plugins'
		);
		return $oTemplate->render($aTemplateData);	
	}

	function do_runCron()
	{
		$id = schedulerUtil::arrayGet($_REQUEST, 'id');
        schedulerUtil::registerBackgroundTask('SecView Cron '.$id, 'plugins/SecView/cron/cronSecView.php',array('id'=>$id));
        return '';
	}	
	function do_clearHash()
	{
		require_once(KT_DIR . '/' . SECVIEW_PLUGIN_PATH."PdfToImagesConverter.php");
		$PdftoImagesConverter = new PdftoImagesConverter();
		$PdftoImagesConverter->ClearDocumentRepository(schedulerUtil::arrayGet($_REQUEST, 'id'));
		return '';
	}
}

?>