var CSecViewPlugin = Class.create();
CSecViewPlugin.prototype = {

	initialize: function(config){
		
		this.size = ["small","middle","large"];
		this.sizeOnMenu = ["Малый","Средний","Крупный"];
		this.speed = ["slow","fast"];
		this.speedOnMenu = ["Среднее","Высокое"];
		this.options = {
				'Container' 			: config['container'],
				'InnerContainer' 		: config['InnerContainer'],
				'PageCountContainer' 	: config['PageCountContainer'],
				'CurrentPageContainer' 	: config['CurrentPageContainer'],
				'PageCount' 			: config['PageCount'],
				'CurrentPage' 			: config['CurrentPage'],
				'ConnectionType'		: (this.getCookie('Plugin-SecView-Quality'))?this.getCookie('Plugin-SecView-Quality'):config['ConnectionType'],
				'DocumentSize'			: (this.getCookie('Plugin-SecView-Size'))?this.getCookie('Plugin-SecView-Size'):config['DocumentSize'],
				'DocumentUrl'			: config['DocumentUrl'],
				'AvailabilityUrl'		: config['AvailabilityUrl'],
				'CreateUrl'				: config['CreateUrl'],
				'loadingEffectID' 		: 'loadingEffect',
				'loadingEffectCSS' 		: 'loadingArea',
				'menuID'				: 'Plugin-SecView-menu',
				'menuCSS'				: 'Plugin-SecView-menu',
				'confirmID'				: 'Plugin-SecView-confirm',
				'confirmCSS'			: 'Plugin-SecView-confirm',
				'showMenu'				: true
		};
		this.tool = '';
		this.mouseIsDown = false;
		this.startX = 0;
		this.startY = 0;
		this.startScrollTop = 0;
		this.startScrollLeft = 0;
		this.imgOptions = {};
		this.checkOptions = {};
		
	},
	init:function()
	{
		(window.opera)?this.options['showMenu'] = false:this.options['showMenu'] = true;
		this.resizeContainer();
		this.setDefaultVars();
		//this.ReloadPage();
	},
	initQualityButtons:function()
	{
		var font = $(this.options['Container']).getElementsBySelector('a[rel="'+this.speed[this.options['ConnectionType']]+'"]');
		if ( font )
		{
			font.each(function(el){el.className = 'hover'}); 
		}
		for( i = 0; i<this.speed.length;i++)
		{
			if((i != this.options['ConnectionType']))
			{
				font = $(this.options['Container']).getElementsBySelector('a[rel="'+this.speed[i]+'"]');
				if ( font )
				{
					font.each(function(el){el.className = ''}); 
				}
			}
		}
	},
	setDefaultVars:function()
	{
		$(this.options['PageCountContainer']).innerHTML = this.options['PageCount'];
		$(this.options['CurrentPageContainer']).value = this.options['CurrentPage'];
		var links = $(this.options['Container']).getElementsBySelector('a');
		if(links)
		{
			links.each(function(el) { el.onclick = function() { return false } } )
		}
		var FastFont = $(this.options['Container']).getElementsBySelector('a[rel="fast"]');
		if ( FastFont )
		{
			FastFont.invoke('observe', 'click', this.FastConnection.bindAsEventListener(this) ); 
		}
		var SlowFont = $(this.options['Container']).getElementsBySelector('a[rel="slow"]');
		if ( SlowFont )
		{
			SlowFont.invoke('observe', 'click', this.SlowConnection.bindAsEventListener(this) ); 
		}
		var hand = $(this.options['Container']).getElementsBySelector('a[rel="hand"]');
		if ( hand )
		{
			hand.invoke('observe', 'click', this.HandListener.bindAsEventListener(this) ); 
		}
		var loupe = $(this.options['Container']).getElementsBySelector('a[rel="loupe"]');
		if ( loupe )
		{
			loupe.invoke('observe', 'click', this.LoupeListener.bindAsEventListener(this) ); 
		}
		var zoomPlus = $(this.options['Container']).getElementsBySelector('a[rel="zoom-plus"]');
		if ( zoomPlus )
		{
			zoomPlus.invoke('observe', 'click', this.zoomPlus.bindAsEventListener(this) ); 
		}
		var zoomMinus = $(this.options['Container']).getElementsBySelector('a[rel="zoom-minus"]');
		if ( zoomMinus )
		{
			zoomMinus.invoke('observe', 'click', this.zoomMinus.bindAsEventListener(this) ); 
		}
		var input = $(this.options['Container']).getElementsBySelector('input');
		if ( input )
		{
			input.invoke('observe', 'keypress', this.OnKeyPress.bindAsEventListener(this) ); 
		}
		var nextPage = $(this.options['Container']).getElementsBySelector('a[rel="next-page"]');
		if ( nextPage )
		{
			nextPage.invoke('observe', 'click', this.GetNextPage.bindAsEventListener(this) ); 
		}
		var prevPage = $(this.options['Container']).getElementsBySelector('a[rel="prev-page"]');
		if ( prevPage )
		{
			prevPage.invoke('observe', 'click', this.GetPrevPage.bindAsEventListener(this) ); 
		}
		//this.initDocument();
		this.initQualityButtons();
	},
	initDocument:function()
	{
		var img = $(this.options['InnerContainer']).getElementsBySelector('img');
		
		if ( img )
		{
			img.each(function(el) { el.onclick = function() { return false } } )
			img.each(function(el) { el.onmousedown = function() { return false } } )
			img.each(function(el) { el.onmouseup = function() { return false } } )
			img.each(function(el) { el.onmousemove = function() { return false } } )
			img.each(function(el) { el.oncontextmenu = function() { return false } } )
			img.invoke('observe', 'click', this.DocumentMouseClick.bindAsEventListener(this) );
			img.invoke('observe', 'mousedown', this.DocumentMouseDown.bindAsEventListener(this) ); 
			img.invoke('observe', 'mouseup', this.DocumentMouseUp.bindAsEventListener(this) );
			img.invoke('observe', 'mousemove', this.DocumentMouseMove.bindAsEventListener(this) );
			
		}
	},
	
	resizeContainer:function()
	{
		var h = $(this.options['Container']).offsetHeight;
		h = h - 78;
		var w = $(this.options['Container']).offsetWidth;
		w = w - 30;
		$(this.options['InnerContainer']).style.height = h+'px';
		$(this.options['InnerContainer']).style.width  = w+'px';
	},
	HandListener:function(evt)
	{
		
		var el = Event.findElement(evt,'a');
		if(this.tool == 'loupe')
		{
			var loupe = $(this.options['Container']).getElementsBySelector('a[rel="loupe"]');
			if(loupe)
			{
				loupe.each(function(el){el.className = '';});
			}
			this.tool = '';
		}
		if(el.className == '' && this.tool == '')
		{
			el.className = 'hover';
			$(this.options['InnerContainer']).style.cursor = 'pointer';
			this.tool = 'hand';
		}
		else if(this.tool == '' || el.className != '')
		{
			el.className = '';
			$(this.options['InnerContainer']).style.cursor = 'default';
			this.tool = '';
		}
	},
	LoupeListener:function(evt)
	{
		var el = Event.findElement(evt,'a');
		if(this.tool == 'hand')
		{
			var hand = $(this.options['Container']).getElementsBySelector('a[rel="hand"]');
			if(hand)
			{
				hand.each(function(el){el.className = '';});
			}
			this.tool = '';
		}
		if(el.className == '' && this.tool == '')
		{
			el.className = 'hover';
			$(this.options['InnerContainer']).style.cursor = 'crosshair';
			this.tool = 'loupe';
		}
		else if(this.tool == '' || el.className != '')
		{
			el.className = '';
			$(this.options['InnerContainer']).style.cursor = 'default';
			this.tool = '';
		}
	},
	InitMenu:function()
	{
		var closeMenu = $(this.options['menuID']).getElementsBySelector('a[rel="menu-close"]');
		if ( closeMenu )
		{
			closeMenu.invoke('observe', 'click', this.removeMenu.bindAsEventListener(this) ); 
		}
		var nextPage = $(this.options['menuID']).getElementsBySelector('a[rel="menu-next"]');
		if ( nextPage )
		{
			nextPage.invoke('observe', 'click', this.GetNextPage.bindAsEventListener(this) ); 
		}
		var prevPage = $(this.options['menuID']).getElementsBySelector('a[rel="menu-prev"]');
		if ( prevPage )
		{
			prevPage.invoke('observe', 'click', this.GetPrevPage.bindAsEventListener(this) ); 
		}
		var sizeSmall = $(this.options['menuID']).getElementsBySelector('a[rel="menu-size-small"]');
		if ( sizeSmall )
		{
			sizeSmall.invoke('observe', 'click', this.setSizeSmall.bindAsEventListener(this) ); 
		}
		var middleSmall = $(this.options['menuID']).getElementsBySelector('a[rel="menu-size-middle"]');
		if ( middleSmall )
		{
			middleSmall.invoke('observe', 'click', this.setSizeMiddle.bindAsEventListener(this) ); 
		}
		var largeSmall = $(this.options['menuID']).getElementsBySelector('a[rel="menu-size-large"]');
		if ( largeSmall )
		{
			largeSmall.invoke('observe', 'click', this.setSizeLarge.bindAsEventListener(this) ); 
		}
		var lowQuality = $(this.options['menuID']).getElementsBySelector('a[rel="menu-quality-slow"]');
		if ( lowQuality )
		{
			lowQuality.invoke('observe', 'click', this.SlowConnection.bindAsEventListener(this) ); 
		}
		var highQuality = $(this.options['menuID']).getElementsBySelector('a[rel="menu-quality-fast"]');
		if ( highQuality )
		{
			highQuality.invoke('observe', 'click', this.FastConnection.bindAsEventListener(this) ); 
		}
	},
	
	setSizeLarge:function(evt)
	{
		for(i=0;i<this.size.length;i++)
		{
			if(this.size[i] == 'large')
			{
				this.options['DocumentSize'] = i;
				this.ReloadPage();
				break;
			}
		}
		this.setCookie('Plugin-SecView-Size',this.options['DocumentSize'],null,null,null,false);
	},
	setSizeMiddle:function(evt)
	{
		for(i=0;i<this.size.length;i++)
		{
			if(this.size[i] == 'middle')
			{
				this.options['DocumentSize'] = i;
				this.ReloadPage();
				break;
			}
		}
		this.setCookie('Plugin-SecView-Size',this.options['DocumentSize'],null,null,null,false);
	},
	setSizeSmall:function(evt)
	{
		for(i=0;i<this.size.length;i++)
		{
			if(this.size[i] == 'small')
			{
				this.options['DocumentSize'] = i;
				this.ReloadPage();
				break;
			}
		}
		this.setCookie('Plugin-SecView-Size',this.options['DocumentSize'],null,null,null,false);
	},
	createMenu:function()
	{
		var ul = document.createElement('ul');
		var li = document.createElement('li');
		li.onmouseover = function(){this.className = 'hover'};
		li.onmouseout = function(){this.className = ''};
		var nextpage = document.createElement('a');
		nextpage.innerHTML = 'Следующая страница';
		nextpage.rel = 'menu-next';
		li.appendChild(nextpage);
		ul.appendChild(li);
		var li2 = document.createElement('li');
		li2.onmouseover = function(){this.className = 'hover'};
		li2.onmouseout = function(){this.className = ''};
		var prevpage = document.createElement('a');
		prevpage.innerHTML = 'Предыдущая страница';
		prevpage.rel = 'menu-prev';
		li2.appendChild(prevpage);
		ul.appendChild(li2);
		var liSize = document.createElement('li');
		liSize.onmouseover = function(){this.className = 'hover'};
		liSize.onmouseout = function(){this.className = ''};
		var spanSize = document.createElement('span');
		spanSize.innerHTML = 'Масштаб';
		var ulSize = document.createElement('ul');
		
		for(i=0;i<this.size.length;i++)
		{
			sizeLi	= document.createElement('li');
			sizeLi.onmouseover = function(){this.className = 'hover'};
			sizeLi.onmouseout = function(){this.className = ''};
			sizeLink = document.createElement('a');
			sizeLink.rel = 'menu-size-'+this.size[i];
			sizeLink.innerHTML = this.sizeOnMenu[i];
			if(i == this.options['DocumentSize'])
			{
				sizeLink.className = 'cur';
			}
			sizeLi.appendChild(sizeLink);
			ulSize.appendChild(sizeLi);
		}
		liSize.appendChild(ulSize);
		liSize.appendChild(spanSize);
		ul.appendChild(liSize);
		var liQuality = document.createElement('li');
		liQuality.onmouseover = function(){this.className = 'hover'};
		liQuality.onmouseout = function(){this.className = ''};
		var spanQuality = document.createElement('span');
		spanQuality.innerHTML = 'Качество';
		var ulQuality = document.createElement('ul');
		
		for(i=0;i<this.speed.length;i++)
		{
			qualityLi	= document.createElement('li');
			qualityLi.onmouseover = function(){this.className = 'hover'};
			qualityLi.onmouseout = function(){this.className = ''};
			qualityLink = document.createElement('a');
			qualityLink.rel = 'menu-quality-'+this.speed[i];
			qualityLink.innerHTML = this.speedOnMenu[i];
			if(i == this.options['ConnectionType'])
			{
				qualityLink.className = 'cur';
			}
			qualityLi.appendChild(qualityLink);
			ulQuality.appendChild(qualityLi);
		}
		liQuality.appendChild(ulQuality);
		liQuality.appendChild(spanQuality);
		ul.appendChild(liQuality);
		var liclose = document.createElement('li');
		liclose.onmouseover = function(){this.className = 'hover'};
		liclose.onmouseout = function(){this.className = ''};
		
		var close = document.createElement('a');
		close.innerHTML = 'Закрыть';
		close.rel = 'menu-close';
		liclose.appendChild(close);
		ul.appendChild(liclose);
		return ul;
	},
	removeMenu:function()
	{
		var menu = $(this.options['menuID']);

        if ( menu )
        {
            menu.remove();
        }
	},
	DocumentMouseClick:function(evt)
	{
		this.removeMenu();
	},
	DocumentMouseDown:function(evt)
	{
		var img = Event.findElement(evt,'img');
		 
		if(evt.button == 2 && this.options['showMenu'])
		{
			this.removeMenu();
			var body = document.getElementsByTagName('body')[0];
			var div = document.createElement('div');
			if (div) {
				div.className = this.options['menuCSS'];
				div.id = this.options['menuID'];
				$(div).setStyle({
					'top': (evt.clientY+this.docScrollTop()) + 'px',
					'left': (evt.clientX+this.docScrollLeft()) + 'px'
				});
				div.oncontextmenu = function(){
					return false;
				};
				div.appendChild(this.createMenu());
				body.appendChild(div);
				this.InitMenu();
			}
			return false;
		}
		else if(this.tool == 'hand')
		{
			this.startX = evt.clientX;
			this.startY = evt.clientY;
			this.startScrollTop = $(this.options['InnerContainer']).scrollTop;
			this.startScrollLeft = $(this.options['InnerContainer']).scrollLeft;
			this.mouseIsDown = true;
		}
		else if(this.tool == 'loupe')
		{
			this.zoomPlus(evt,true);
		}
		return false;
	},
	

	DocumentMouseUp:function(evt)
	{
		if(this.tool == 'hand')
		{
			this.startX = 0;
			this.startY = 0;
			this.mouseIsDown = false;
		}
		return false;
	},
	DocumentMouseMove:function(evt)
	{	
		var img = Event.findElement(evt,'div');
		if(this.tool == 'hand' && this.mouseIsDown)
		{
			$(this.options['InnerContainer']).scrollTop = this.startScrollTop-evt.clientY+this.startY;
			$(this.options['InnerContainer']).scrollLeft =this.startScrollLeft-evt.clientX+this.startX;
		}
		return false;
	},
	initConfirm:function(confirm)
	{
		var buttonNo = $(this.options['confirmID']).getElementsBySelector('div[class="button-No"]');
		if(buttonNo)
		{
			buttonNo.each(function(el){el.onclick = function(){	return	false;	}})
			buttonNo.invoke('observe', 'click', this.removeConfirm.bindAsEventListener(this) );
			buttonNo.invoke('observe', 'click', this.removeLoadingEffect.bindAsEventListener(this) );
		}
		var buttonMiddle = $(this.options['confirmID']).getElementsBySelector('div[class="button-Middle"]');
		if(buttonMiddle)
		{
			buttonMiddle.each(function(el){el.onclick = function(){	return	false;	}})
			buttonMiddle.invoke('observe', 'click', this.removeConfirm.bindAsEventListener(this) );
		}
		var buttonYes = $(this.options['confirmID']).getElementsBySelector('div[class="button-Yes"]');
		if(buttonYes)
		{
			buttonYes.each(function(el){el.onclick = function(){	return	false;	}})
			buttonYes.invoke('observe', 'click', function(){
				confirm(this);
			}.bindAsEventListener(this) );
			buttonYes.invoke('observe', 'click', this.removeConfirm.bindAsEventListener(this) );
		}
		
	},
	removeConfirm: function()
	{
		var Confirm = $(this.options['confirmID']);
        if ( Confirm )
        {
            Confirm.remove();
        }
	},
	showConfirm: function(idWin,message, confirm, show_ok)
    {
		this.removeConfirm();
		var win = $(idWin);
        if ( win )
        {
            var body = document.getElementsByTagName('body')[0];
            var Confirm = document.createElement('div');
			var ConfirmOuter = document.createElement('div');
            ConfirmOuter.id = this.options['confirmID'];
            if ( Confirm  && ConfirmOuter)
            {
                $(ConfirmOuter).addClassName(this.options['confirmCSS']);
                
				var question = document.createElement('span');
				question.innerHTML = message;
				Confirm.appendChild(question);
				if (show_ok) {
					var buttonNo = document.createElement('div');
					var buttonNoOuter = document.createElement('div');
					buttonNoOuter.className = 'button-Middle';
					buttonNo.innerHTML = 'Ok';
					buttonNoOuter.appendChild(buttonNo);
					Confirm.appendChild(buttonNoOuter);
				}
				else {
					var buttonYes = document.createElement('div');
					var buttonYesOuter = document.createElement('div');
					buttonYesOuter.className = 'button-Yes';
					buttonYes.innerHTML = 'Yes';
					buttonYesOuter.appendChild(buttonYes);
					Confirm.appendChild(buttonYesOuter);
					var buttonNo = document.createElement('div');
					var buttonNoOuter = document.createElement('div');
					buttonNoOuter.className = 'button-No';
					buttonNo.innerHTML = 'No';
					buttonNoOuter.appendChild(buttonNo);
					Confirm.appendChild(buttonNoOuter);
				}
				$(ConfirmOuter).setStyle(
                    {
                        'left':(this.getLeftPos(win)+((win.offsetWidth-200)/2))+'px',
                        'top':(this.getTopPos(win)+((win.offsetHeight-400)/2))+'px'
                    }
                );
				ConfirmOuter.appendChild(Confirm);
				body.appendChild(ConfirmOuter);
				this.initConfirm(confirm);
            }
        }
    },
	setLoadingEffect: function(idWin)
    {
		this.removeLoadingEffect();
		var win = $(idWin);
        if ( win )
        {
            var body = document.getElementsByTagName('body')[0];
            var LoadingEffect = document.createElement('div');
            LoadingEffect.id = this.options['loadingEffectID'];
            if ( LoadingEffect )
            {
                $(LoadingEffect).addClassName(this.options['loadingEffectCSS']);
                $(LoadingEffect).setStyle(
                    {
                        'width':win.getWidth()+'px',
                        'height':win.getHeight()+'px',
                        'left':this.getLeftPos(win)+'px',
                        'top':this.getTopPos(win)+'px',
						'position':'absolute'
                    }
                );
				
				var rotate = document.createElement('div');
				
				if(rotate)
				{
					var rotate_text = document.createElement('img');
					rotate_text.src = '/plugins/SecView/img/rotate_text.png';
					rotate_text.className = 'png';
					var rotate_img = document.createElement('img');
					rotate_img.src = '/plugins/SecView/img/rotate.gif';
					rotate_img.style.padding = '0px 94px';
					rotate.style.margin = '-58px '+((win.getWidth()-288)/2)+'px 0';
					rotate.style.position = 'relative';
					rotate.textAlign = 'center';
					rotate.style.top = '50%';
					rotate.appendChild(rotate_text);
					rotate.appendChild(rotate_img);
					LoadingEffect.appendChild(rotate);
				}
				
                body.appendChild(LoadingEffect);
            }
        }
    },
	removeLoadingEffect: function()
    {
        var LoadingEffect = $(this.options['loadingEffectID']);

        if ( LoadingEffect )
        {
            LoadingEffect.remove();
        }
    },
	setCurrentPage:function()
	{
		$(this.options['CurrentPageContainer']).value = this.options['CurrentPage'];
		if (parseInt(this.options['CurrentPage']) >= parseInt(this.options['PageCount'])) {
			
		}	
	},
	GetNextPage:function(evt)
	{
		if (parseInt(this.options['CurrentPage']) < parseInt(this.options['PageCount'])) {
			this.options['CurrentPage'] = parseInt(this.options['CurrentPage']) + 1;
			this.ReloadPage(false);
		} 
	},
	GetPrevPage:function(evt)
	{
		if (parseInt(this.options['CurrentPage']) > 1) {
			this.options['CurrentPage'] = parseInt(this.options['CurrentPage']) - 1;
			this.ReloadPage(false);
		} 
	},
	savePosition:function(evt)
	{
		if (evt) {
			var img = Event.findElement(evt,'img'); 
			this.imgOptions['imgClickX'] = evt.clientX - this.getLeftPos($(this.options['InnerContainer'])) + this.docScrollLeft() + $(this.options['InnerContainer']).scrollLeft;
			this.imgOptions['imgClickY'] = evt.clientY - this.getTopPos($(this.options['InnerContainer'])) + this.docScrollTop() + $(this.options['InnerContainer']).scrollTop;
			this.imgOptions['imgClickToLeft'] = evt.clientX - this.getLeftPos($(this.options['InnerContainer'])) + this.docScrollLeft();
			this.imgOptions['imgClickToTop'] = evt.clientY - this.getTopPos($(this.options['InnerContainer'])) + this.docScrollTop();
			this.imgOptions['imgX'] = img.offsetWidth;
			this.imgOptions['imgY'] = img.offsetHeight;
		}
		else
		{
			this.imgOptions['imgClickX'] = this.getLeftPos($(this.options['InnerContainer'])) + this.docScrollLeft() + $(this.options['InnerContainer']).scrollLeft;
			this.imgOptions['imgClickY'] = this.getTopPos($(this.options['InnerContainer'])) + this.docScrollTop() + $(this.options['InnerContainer']).scrollTop;
			this.imgOptions['imgClickToLeft'] = this.getLeftPos($(this.options['InnerContainer'])) + this.docScrollLeft();
			this.imgOptions['imgClickToTop'] = this.getTopPos($(this.options['InnerContainer'])) + this.docScrollTop();
			if ($(this.options['InnerContainer']).down('img')) {
				this.imgOptions['imgX'] = $(this.options['InnerContainer']).down('img').offsetWidth;
				this.imgOptions['imgY'] = $(this.options['InnerContainer']).down('img').offsetHeight;
			}
			else
			{
				this.imgOptions['imgX'] = 0;
				this.imgOptions['imgY'] = 0;
			}
		}
	},
	createHash:function()
	{
		var url = this.options['CreateUrl'] + '&page=' + (parseInt(this.options['CurrentPage'])-1) + '&type=' + this.size[this.options['DocumentSize']] + '/' + this.speed[this.options['ConnectionType']];
		new Ajax.Request(url, {
                //onCreate: this.onCreateLoading.bind(this),
                'onFailure': this.CreateFailureLoading.bind(this),
                'onSuccess':this.CreateSuccessLoading.bind(this)
			});
	},
	CreateFailureLoading:function()
	{
		this.showConfirm(this.options['InnerContainer'], "Loading Failed. Try again?", function(obj){	obj.createHash()});
	},
	CreateSuccessLoading:function(response)
	{
		if (response.responseText != "OK") {
			this.showConfirm(this.options['InnerContainer'],response.responseText,false,true);
		}
		else {
			this.ReloadImage(this.checkOptions['save_scroll'], this.checkOptions['evt']);
		}
	},
	checkAvailability:function()
	{
		var url = this.options['AvailabilityUrl'] + '&page=' + (parseInt(this.options['CurrentPage'])-1) + '&type=' + this.size[this.options['DocumentSize']] + '/' + this.speed[this.options['ConnectionType']];
		new Ajax.Request(url, {
                'onSuccess':this.AvailabilitySuccessLoading.bind(this)
            });
	},
	AvailabilitySuccessLoading: function (response)
    {
		switch(response.responseText)
		{
			case "0":
			{
				this.ReloadImage(this.checkOptions['save_scroll'],this.checkOptions['evt']);
				break;
			}
			case "1":
			case "2":
			case "3":
			case "5":
			{
				document.location.href = "";
				break;
			}
			case "4":
			{
				this.showConfirm(this.options['InnerContainer'], "Hash Not Found. Create Hash?",function(obj){
					obj.createHash()
				});
				break;
			}
			default:
			{
				this.showConfirm(this.options['InnerContainer'],response.responseText ,function(obj){
				},true);
				this.removeLoadingEffect()
			}
		}
	},
	ReloadImage:function(save_scroll,evt)
	{
		var img = document.createElement('img');
		Event.observe(img, 'load', function(){
			if ($(this.options['InnerContainer']).down('img')) 
			{
				$(this.options['InnerContainer']).down('img').remove();
			}
			$(this.options['InnerContainer']).down('div').appendChild(img);
			this.setCurrentPage();
			this.initDocument();
			
			this.removeLoadingEffect();
		}.bindAsEventListener(this));
		if (save_scroll) {
			Event.observe(img, 'load', function(){
				var newImgClickX = parseInt($(this.options['InnerContainer']).down('img').offsetWidth*(this.imgOptions['imgClickX']/this.imgOptions['imgX']));
				var newImgClickY = parseInt($(this.options['InnerContainer']).down('img').offsetHeight*(this.imgOptions['imgClickY']/this.imgOptions['imgY']));
				$(this.options['InnerContainer']).scrollLeft = parseInt(newImgClickX-this.imgOptions['imgClickToLeft']); 
				$(this.options['InnerContainer']).scrollTop = parseInt(newImgClickY-this.imgOptions['imgClickToTop']);
			}.bindAsEventListener(this));
		}
		img.src = this.getDocumentUrl(-1);
		return false;
	},
	ReloadPage:function(save_scroll,evt)
	{
		if (save_scroll) 
		{
			this.savePosition(evt);
		}
		this.removeMenu();
		this.setLoadingEffect(this.options['InnerContainer']);
		this.checkOptions['save_scroll'] = save_scroll;
		this.checkOptions['evt'] = evt;
		this.checkAvailability();
		return false;	
	},
	OnKeyPress:function(evt)
	{
		var input = Event.findElement(evt,'input');
		if(evt.keyCode == 13)
		{
			this.options['CurrentPage'] = parseInt(input.value);
			if(parseInt(this.options['CurrentPage']) > parseInt(this.options['PageCount']))
			{
				this.options['CurrentPage'] = this.options['PageCount']; 
			}
			if(parseInt(this.options['CurrentPage']) < 1 )
			{
				this.options['CurrentPage'] = 1; 
			}
			this.ReloadPage();
		}
	},
	zoomPlus:function(evt, loupe)
	{
		for( i = 0; i<this.size.length;i++)
		{
			if((i == this.options['DocumentSize']) && ((i+1) != this.size.length))
			{
				this.options['DocumentSize'] = i+1;
				if (loupe) {
					this.ReloadPage(true,evt);
				}
				else
				{
					this.ReloadPage(true);
				}
				break;
			}
		}
		this.setCookie('Plugin-SecView-Size',this.options['DocumentSize'],null,null,null,false);
	},
	zoomMinus:function(evt)
	{
		for( i = this.size.length-1; i>=0;i--)
		{
			if((i == this.options['DocumentSize']) && (i != 0))
			{
				this.options['DocumentSize'] = i-1;
				this.ReloadPage(true);
				break;
			}
		}
		this.setCookie('Plugin-SecView-Size',this.options['DocumentSize'],null,null,null,false);
	},
	FastConnection:function(evt)
	{
		for( i = 0; i<this.speed.length;i++)
		{
			if((i == this.options['ConnectionType']) && ((i+1) != this.speed.length))
			{
				this.options['ConnectionType'] = i+1;
				this.ReloadPage(true);
				this.initQualityButtons();
				break;
			}
		}
		this.setCookie('Plugin-SecView-Quality',this.options['ConnectionType'],null,null,null,false);
	},
	SlowConnection:function(evt)
	{
		for( i = this.speed.length-1; i>=0;i--)
		{
			if((i == this.options['ConnectionType']) && (i != 0))
			{
				this.options['ConnectionType'] = i-1;
				this.ReloadPage(true);
				this.initQualityButtons();
				break;
			}
		}
		this.setCookie('Plugin-SecView-Quality',this.options['ConnectionType'],null,null,null,false);

	},
	docScrollLeft: function() {
	  if ( window.pageXOffset )
	     return window.pageXOffset;
	  else if ( document.documentElement && document.documentElement.scrollLeft )
	     return document.documentElement.scrollLeft;
	  else if ( document.body )
	     return document.body.scrollLeft;
	  else
	     return 0;
	},

	docScrollTop: function() {
	  if ( window.pageYOffset )
	     return window.pageYOffset;
	  else if ( document.documentElement && document.documentElement.scrollTop )
	     return document.documentElement.scrollTop;
	  else if ( document.body )
	     return document.body.scrollTop;
	  else
	     return 0;
	},
	getLeftPos: function(element)
	{
		var valueL = 0;
		try
		{
			do
			{
				valueL += element.offsetLeft || 0;
				element = element.offsetParent;
			} while (element);
		}
		catch( ex ) {
	}
	return valueL;
	},
	getTopPos: function(element)
	{
		var valueT = 0;
		try
		{
			do
			{
				valueT += element.offsetTop || 0;
				element = element.offsetParent;
			} while (element);
		}
		catch( ex ) {
		}
		return valueT;
	},
	setCookie: function (name, value, expires, path, domain, secure) 
	{
		var cookie=name+"="+escape(value);
        if (expires) {
            cookie+="; expires="+expires.toGMTString();
        }
        if (path) {
            cookie+="; path="+path;
        }
		else
		{
			cookie+="; path=/";
		}
        if (domain) {
            cookie+="; domain="+domain;
        }
		
        if (secure) {
                cookie+="; secure";
        }
        document.cookie=cookie;
	},
	getCookie: function ( name ) 
    {
        var prefix = name + "="
        var cookieStartIndex = document.cookie.indexOf(prefix)
        if (cookieStartIndex == -1)
                return null
        var cookieEndIndex = document.cookie.indexOf(";", cookieStartIndex + prefix.length)
        if (cookieEndIndex == -1)
                cookieEndIndex = document.cookie.length
        return unescape(document.cookie.substring(cookieStartIndex + prefix.length, cookieEndIndex))
    },
	getDocumentUrl:function(correct_page)
	{
		return this.options['DocumentUrl'] + '&page=' + (parseInt(this.options['CurrentPage'])+correct_page) + '&type=' + this.size[this.options['DocumentSize']] + '/' + this.speed[this.options['ConnectionType']];
	}
}