var CSecViewPluginAdmin = Class.create();
CSecViewPluginAdmin.prototype = {

	initialize: function(config){
		
		this.options = {
				'HashCountUrl'			: config['HashCountUrl'],
				'menuID'				: 'Plugin-SecView-menu',
				'menuCSS'				: 'Plugin-SecView-menu',
				'confirmID'				: 'Plugin-SecView-confirm',
				'confirmCSS'			: 'Plugin-SecView-confirm',
				'Loading'				: '...'
				
		};
		this.order = new Array;
		this.currentOrder = 0;
		this.TotalHashCount = 0;
		this.RefreshId = '';
	},
	
	init:function()
	{
		var refresh = $('SecView-DocumentsStatus').getElementsBySelector('a[rel="refresh"]');
		if(refresh)
		{
			refresh.each(function(el) { el.onclick = function() { return false } } )
			refresh.invoke('observe', 'click', this.RefreshHashCount.bindAsEventListener(this) );
		}
		
		var run = $('SecView-DocumentsStatus').getElementsBySelector('a[rel="run-cron"]');
		if(run)
		{
			run.each(function(el) { el.onclick = function() { return false } } )
			run.invoke('observe', 'click', this.runAction.bindAsEventListener(this) );
		}
		var clear = $('SecView-DocumentsStatus').getElementsBySelector('a[rel="clear-hash"]');
		if(clear)
		{
			clear.each(function(el) { el.onclick = function() { return false } } )
			clear.invoke('observe', 'click', this.clearAction.bindAsEventListener(this) );
		}
		if (this.order.length) 
		{
			this.StartOrder(this.order.first());
		}
	},
	AddOrder:function(val)
	{
		this.order[this.order.length] = val;
	},
	StartOrder:function(id)
	{
		this.currentOrder = id;
		var div = $('DocumentsStatus-'+this.currentOrder);
		if(div)
		{
			div.innerHTML = this.options['Loading'];
		}
		new Ajax.Request(this.options['HashCountUrl']+id, {
                'onSuccess':this.SuccessLoadingHashCount.bind(this)
			});
	},
	SuccessLoadingHashCount:function(response)
	{
		var div = $('DocumentsStatus-'+this.currentOrder);
		if(div)
		{
			this.TotalHashCount += parseInt(response.responseText);
			div.innerHTML = response.responseText;
		}
		
		this.order = this.order.without(this.currentOrder);
		
		if (this.order.length)
		{
			this.StartOrder(this.order.first());
		}
		else
		{
			if($('DocumentsStatus-Hash-Total'))
			{
				$('DocumentsStatus-Hash-Total').innerHTML = this.TotalHashCount; 
			}
		}
	},
	RefreshHashCount:function(evt)
	{
		var el = Event.findElement(evt,'a');
		if (el.up('tr').down('div')) 
		{
			this.RefreshId = el.up('tr').down('div').id;
			this.TotalHashCount -= parseInt(el.up('tr').down('div').innerHTML);
			el.up('tr').down('div').innerHTML = this.options['Loading'];
		}
		new Ajax.Request(el.href, {
                'onSuccess':this.SuccessLoadingHashCountRefresh.bind(this)
			});
	},
	SuccessLoadingHashCountRefresh:function(response)
	{
		var div = $(this.RefreshId);
		if(div)
		{
			this.TotalHashCount += parseInt(response.responseText);
			div.innerHTML = response.responseText;
		}
		
		if($('DocumentsStatus-Hash-Total'))
		{
			$('DocumentsStatus-Hash-Total').innerHTML = this.TotalHashCount; 
		}
		
	},
	clearAction:function(evt)
	{
		var el = Event.findElement(evt,'a');
		if (el.up('tr').down('div')) 
		{
			this.RefreshId = el.up('tr').down('div').id;
			this.TotalHashCount -= parseInt(el.up('tr').down('div').innerHTML);
			el.up('tr').down('div').innerHTML = '0';
		}
		if($('DocumentsStatus-Hash-Total'))
		{
			$('DocumentsStatus-Hash-Total').innerHTML = this.TotalHashCount; 
		}
		new Ajax.Request(el.href, {
                'onSuccess':this.SuccessLoading.bind(this)
			});
	},
	runAction:function(evt)
	{
		var el = Event.findElement(evt,'a');
		new Ajax.Request(el.href, {
                'onSuccess':this.SuccessRunLoading.bind(this)
			});
		el.remove();	
	},
	SuccessRunLoading:function(response)
	{
		
		return true;
	},
	SuccessLoading:function(response)
	{
		return true;
	}
}