<?php

/**
 * The contents of this file are subject to the KnowledgeTree Public
 * License Version 1.1 ("License"); You may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.ktdms.com/KPL
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 * 
 * The Original Code is: KnowledgeTree Open Source
 * 
 * The Initial Developer of the Original Code is The Jam Warehouse Software
 * (Pty) Ltd, trading as KnowledgeTree.
 * Portions created by The Jam Warehouse Software (Pty) Ltd are Copyright
 * (C) 2006 The Jam Warehouse Software (Pty) Ltd;
 * All Rights Reserved.
 * 
 * ********************************************
 * Для работы скрипта необходимо предварительно
 * создать ОБЩИЙ набор полей:
 * Имя       = "Поля Absotheque"
 * Namespace = "lm.fieldsets.absotheque" (только такое значение!!!)
 * Описание  = "Набор полей документа, соответствующих  аналогичным в АИБС Absotheque"
 * 
 * Fieldset member №1: 
 *   Имя      = "ID"
 *   Описание = "Идентификатор документа в АИБС Absotheque"
 *   Тип      = "Normal"
 *   Required = "false"
 * ********************************************
 * 
 * $Id: LMGetDocumentById.php 2007-01-03 12:17:43 isheep $
 * 
 * @version 0.2
 * 
 * История версий:
 * 
 * 0.1: первая версия 
 * 0.2: работа с учетом наличия рецензий на документы. 
 *      (рецензии имеют тот же absotheque.id что и документы)
 *      В результате скрипт перенаправляет именно на документ (если есть),
 *      рецензии игнорируются
 * 
 */

require_once('../../config/dmsDefaults.php');

require_once(KT_LIB_DIR . '/metadata/metadatautil.inc.php');
require_once(KT_LIB_DIR . '/authentication/authenticationsource.inc.php');
require_once(KT_LIB_DIR . '/authentication/authenticationutil.inc.php');
require_once('../../search2/search/search.inc.php');

if (!empty($_GET['id'])) {
    $givenID = (int) $_GET['id'];
} else {
    echo 'Error: No ID given!';
    exit(1);
}

if ( !is_a(User::get($_SESSION['userID']), 'User') ){
	redirect(KTUtil::ktLink('login.php','',sprintf("redirect=%s", urlencode($_SERVER['REQUEST_URI'])))); exit(0);
}
$docs = getResult(generateRequest($givenID));
$count = count($docs);

if ($count == 1) {
	redirect(generateControllerLink('viewDocument',sprintf(_kt('fDocumentId=%d'),current($docs)->getDocumentID())));
    exit(0);
} else if($count > 1) {
	for ($i=1; $i<=$count; $i++){
		$name = $docs[$i]->getFullPath() . " : " . $docs[$i]->getFilename();
    	echo '<a href='.generateControllerLink('viewDocument',sprintf(_kt('fDocumentId=%d'),$docs[$i]->getId())).'>'.$name.'</a><br>';
    }
    $default->log->error("LMGetDocumentById:: too many documents with Absoteque ID = ".$givenID);
    echo('Too many results');
} else {
    echo "Документ с ID = $givenID не найден!";
}

function generateRequest($id) {
	$query = '';
	$aFieldsets = KTEntityUtil::getByDict(
		'KTFieldset', 
		array('disabled' => false),
		KTUtil::meldOptions(null, array('multi' => true))
	);
	
	foreach ($aFieldsets as $oFieldset) {
		$aFields = $oFieldset->getFields();
		foreach ($aFields as $oField) {
			if (strtolower($oField->getName()) == 'id'){
				$query = "([\"{$oFieldset->getName()}\"][\"{$oField->getName()}\"] is \"$id\")";
				break 2;
			}
		}
	}
	return $query;
}

function getResult($expr_str) {
	$parser = new SearchCommandParser();
	$lexer = new SearchCommandLexer($expr_str);
	$use_internal=false;
	
	while ($lexer->yylex()){
		$parser->doParse($lexer->token, $lexer->value);
		if (!$parser->isExprOk()){
		    $use_internal=true;
		    $expr_str=getExpressionLocalityString($expr_str, $lexer->offset, 20);
		}
	}
	$parser->doParse(0, 0);
	
	if (!$parser->isExprOk()){
	    $use_internal=true;
	    $expr_str=getExpressionLocalityString($expr_str, $lexer->offset, 20);
	}
	
	$expr = $parser->getExprResult();
	return current($expr->evaluate(ExprContext::DOCUMENT));
}
?>
