<?php

/**
 * The contents of this file are subject to the KnowledgeTree Public
 * License Version 1.1 ("License"); You may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.ktdms.com/KPL
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 * 
 * The Original Code is: KnowledgeTree Open Source
 * 
 * The Initial Developer of the Original Code is The Jam Warehouse Software
 * (Pty) Ltd, trading as KnowledgeTree.
 * Portions created by The Jam Warehouse Software (Pty) Ltd are Copyright
 * (C) 2006 The Jam Warehouse Software (Pty) Ltd;
 * All Rights Reserved.
 * 
 * ********************************************
 * Для работы скрипта необходимо предварительно
 * создать ОБЩИЙ набор полей:
 * Имя       = "Поля Absotheque"
 * Namespace = "lm.fieldsets.absotheque" (только такое значение!!!)
 * Описание  = "Набор полей документа, соответствующих  аналогичным в АИБС Absotheque"
 * 
 * Fieldset member №1: 
 *   Имя      = "ID"
 *   Описание = "Идентификатор документа в АИБС Absotheque"
 *   Тип      = "Normal"
 *   Required = "false"
 * ********************************************
 * 
 * $Id: LMGetDocumentById.php 2007-01-03 12:17:43 isheep $
 * 
 * @version 0.1
 * 
 * История версий:
 * 
 * 0.1: первая версия 
 * 
 */

require_once('../../config/dmsDefaults.php');

require_once(KT_LIB_DIR . '/metadata/metadatautil.inc.php');
require_once(KT_LIB_DIR . '/authentication/authenticationsource.inc.php');
require_once(KT_LIB_DIR . '/authentication/authenticationutil.inc.php');

if (!empty($_GET['id']))
{
	$givenID = KTUtil::arrayGet($_REQUEST, 'id');
} else {
	echo 'Error: No ID given!';
	exit(1);
}

//$sSourceName = "ActiveDirectory";
$sFieldsetNamespace = "lm.fieldsets.absotheque";
$sFieldName = "ID";
$sReviewFieldName = "Рецензия";

$oFieldset =& KTFieldset::getByNamespace($sFieldsetNamespace);
if (PEAR::isError($oFieldset)) {
	printf("No fieldset named %s found\n", $sFieldsetNamespace);
	exit(1);
}

$oField = DocumentField::getByFieldsetAndName($oFieldset, $sFieldName);
if (PEAR::isError($oField)) {
	printf("No field named %s found in fieldset %s\n", $sFieldName, $sFieldsetNamespace);
	exit(1);
}

$fieldID = $oField->getID();

$oReviewField = DocumentField::getByFieldsetAndName($oFieldset, $sReviewFieldName);
if (PEAR::isError($oReviewField)) {
	printf("No field named %s found in fieldset %s\n", $sReviewFieldName, $sFieldsetNamespace);
	exit(1);
}

$reviewFieldID = $oReviewField->getID();

//echo $fieldID;

$sql = $default->db;

$sql->query(array(
"SELECT * FROM $default->documents_table d
WHERE d.metadata_version_id IN 
(
  SELECT df.metadata_version_id
  FROM $default->document_fields_link_table df 
  WHERE 
    df.document_field_id = $fieldID AND TRIM(df.value) = ?
    AND
    df.metadata_version_id IN 
    (
    SELECT df.metadata_version_id
    FROM $default->document_fields_link_table df 
    WHERE 
      df.document_field_id = $reviewFieldID AND TRIM(df.value) <> ''
    )
  
)", trim($givenID))
);

$count = $sql->num_rows();

if (PEAR::isError($count)) {
	// var_dump($this->lastResult);
	/* @var count PEAR_Error */
	echo($count->getMessage());
	echo('<pre>'.$count->getUserInfo().'</pre>');
	exit;
}

if ($count == 1) {
	// Redirect
	$sql->next_record();
	$knId = $sql->f("id");

	$oDocument = Document::get($knId);

	$oStorage  = KTStorageManagerUtil::getSingleton();
	$oDocument -> setFileName($sReviewFieldName . ' - ' . $oDocument -> getFileName());
	$res = $oStorage  -> download($oDocument);

	$oDocumentTransaction = & new DocumentTransaction($oDocument, "Document downloaded", 'ktcore.transactions.download', array());
	$oDocumentTransaction->create();
	
	echo $res;

	//redirect(generateControllerLink('viewDocument',sprintf(_kt('fDocumentId=%d'),$knId)));

	//exit(0);
} elseif ($count > 1) {
	/** @todo Если вдруг почему-то несколько рецензий с таким ИД,
    *   вывести сообщение об этом, записать в лог,
    *   выдать пользователю список ссылок для выбора нужной рецензии
    *   
    */
	$default->log->error("LMGetReviewById:: too many reviews with Absotheque ID = ".$givenID);
	echo('Много рецензий');
} else {
	echo "Рецензия для документа с ID = $givenID не найдена!";
}

// execute and get documentID, then generate redirect

?>
