<?php 

/**
 * $Id: LMImportFieldsPlugin.php 5758 2006-07-27 10:17:43Z ivsorokin $
 *
 * @todo Создание полей вынести на страницу администрирования
 */

require_once('Marc.php');
require_once(KT_LIB_DIR . '/plugins/plugin.inc.php');
require_once(KT_DIR . "/config/dmsDefaults.php");
require_once(KT_LIB_DIR . "/documentmanagement/observers.inc.php");

class LMImportFieldsPlugin extends KTPlugin {
	var $sNamespace = "lm.import.fields.plugin";
	var $autoRegister = false;
	var $sFriendlyName = null;
	var $rVersion = 0.5;
	var $settings_key = 'import-fields-plugin-settings';

	function LMImportFieldsPlugin($sFilename = null) {
		$res = parent::KTPlugin($sFilename);
		$this->sFriendlyName = _kt('LiberMedia Fields Import Plugin v'.$this->rVersion);
		return $res;
	}

	function setup() {
		$oTemplating =& KTTemplating::getSingleton();
		$oTemplating->addLocation('libermedia', 'plugins/libermedia/templates');

		$this->registerAction('documentaction', 'LMImportFieldsAction',
		'lm.import.fields');

		$this->registerAdminPage('importfields', 'LMImportFieldsAdminDispatcher', 'documents',
		_kt('Настройки импорта полей'),
		_kt('Настройки параметров импорта полей поисания из различных АБИС и форматов'),
		'admin/importFields.php', null);
	}


}

// {{{ LMImportFieldsAction
class LMImportFieldsAction extends KTDocumentAction {
	var $sName = 'lm.import.fields';
	var $_sShowPermission = "ktcore.permissions.write";
	var $settings_key = 'import-fields-plugin-settings';
	var $settings;

	function getDisplayName() {
		return _kt('Импорт полей описания');
	}

	function getInfo() {
		return parent::getInfo();
	}

	function form_rusmarc_initialdata() {
		$oForm = new KTForm;
		//$old_search = KTUtil::arrayGet($_REQUEST, 'old_search');
		//$group_id = KTUtil::arrayGet($_REQUEST, 'group_id');
		$doc_id = KTUtil::arrayGet($_REQUEST, 'fDocumentId', 0);

		$oForm->setOptions(array(
		'label' => _kt("Загрузка метаданных из MARC формата"),
		'action' => 'processInitialDataRusmarc',
		'actionparams' => 'fDocumentId='.intval($doc_id),
		// 'cancel_action' => KTBrowseUtil::getUrlForDocument($this->oDocument),
		'fail_action' => 'main',
		'context' => &$this,
		'extraargs' => $this->meldPersistQuery("","",true),
		'submit_label' => _kt("Import"),
		'file_upload' => true,
		));

		$oForm->setWidgets(array(
		array('ktcore.widgets.file',array(
		'label' => _kt('Файл RUSMARC'),
		'description' => _kt('Файл, содержащий описание в формате RUSMARC'),
		'name' => 'file',
		'required' => true,
		'onchange' => $sFileOnchange,
		))
		));

		$oForm->setValidators(array(
		array('ktcore.validators.file', array(
		'test' => 'file',
		'output' => 'file',
		)),
		array('ktcore.validators.fileillegalchar', array(
		'test' => 'file',
		'output' => 'file',
		))
		));

		return $oForm;
	}
	
	function _saveFieldsetData(&$oDocument, &$oFieldset, $aFields) {
		
		$iMetadataVersionId = $oDocument -> GetMetadataVersionId();
		$iDocumentId        = KTUtil::GetId($oDocument);
	
		// объединим авторов в одно поле
		$sep = (is_array($aFields['200']['g']) && is_array($aFields['200']['f'])) ? "; " : '';
		$aFields['200']['f'][0] = implode('; ', $aFields['200']['f']) .$sep.implode('; ', $aFields['200']['g']);

		// заполнение полей для документа
		foreach ($aFields as $field=>$aField) {
			foreach ($aField as $subfield=>$values){
				
				$oField = null;
				
				foreach ($oFieldset->getFields() as $_oField){
					if ($_oField->getDescription() == 'u'.$field.'_'.$subfield) {
						$oField = $_oField; 
						break;
					}
				}
				
				$sValue = implode('; ', $values);

				$oFieldsLink = DocumentFieldLink::getByDocumentAndField($oDocument, $oField);
				// если объект поле есть - то обновить, иначе - создать новое
				if (!is_a($oFieldsLink, 'ktentitynoobjects')){
					$oFieldsLink -> setValue($sValue);
					$oFieldsLink -> update();
				} else if (is_a($oField, 'DocumentField')){
					$iFieldId = KTUtil::GetId($oField);
					$oFieldsLink = new DocumentFieldLink($iDocumentId, $iFieldId, $sValue);
					$oFieldsLink -> setMetadataVersionId($iMetadataVersionId);
					$oFieldsLink -> create();
				}
			}
		}
	}

	function do_processInitialDataRusmarc() {
		if (!class_exists('Import')) {
			$this->errorRedirectToMain('Import not exists');
		}

		if (!class_exists('iso2709_record')) {
			$this->errorRedirectToMain('iso2709_record not exists');
		}


		$upload_manager = new KTUploadManager();
		$upload_manager->cleanup();

		$this->persistParams(array('group_id'));
		$failed = 0;
		$added=array();
		$lastMessage='';
		foreach($_FILES as $key =>$file){
			$filename=$file['name'];
			$tempfile=$file['tmp_name'];

			$error=$file['error'];
			if ($error == UPLOAD_ERR_OK){
				$result = $upload_manager->uploaded($filename, $tempfile, 'loadUsers');
				if (PEAR::isError($result)){
					$lastMessage=$result->getMessage();
					$default->log->error("Cannot upload file '$filename'. Temp location: '$tempfile'. " . $lastMessage);
					$failed++;
					continue;
				}
				
				if ($result !== false){
					$file['tmp_name'] = $result;
					$added[$key]=$file;
				}else{
					$failed++;
				}
			}
		}

		if ($failed){
			return PEAR::raiseError(_kt('Could not add files to the system. Please inspect the log file. ' . $lastMessage));
		}else{
			$sMarkText = $this->_readMarcFromFile($file['tmp_name']);
			$aFields = $this->_parseMarc($sMarkText);
		}

		$oDocument = Document::get(
			KTUtil::arrayGet($_REQUEST, 'fDocumentId', 0)
		);

		$iDocumentId = KTUtil::GetId($oDocument);
		$iMetadataVersionId = $oDocument -> GetMetadataVersionId();

		$oFieldSet = KTFieldset::getByNamespace('lm.fieldsets.absotheque');

		$this->_saveFieldsetData($oDocument, $oFieldSet, $aFields);

		$sMessage = 'Значения полей успешно импортированы';
		// $this->successRedirectToMain('<pre>'.$info.'</pre>',sprintf('fDocumentId=%d', $this->oDocument->getId()));
		$this->successRedirectToMain($sMessage,sprintf('fDocumentId=%d', $this->oDocument->getId()));
		return '';
	}

	function form_confirmimport($action = 'confirmImportRusmarc') {
		$oForm = new KTForm;
		$old_search = KTUtil::arrayGet($_REQUEST, 'old_search');
		$group_id = KTUtil::arrayGet($_REQUEST, 'group_id');

		$oForm->setOptions(array(
			'label' => _kt("Начало импорта"),
			'action' => $action,
			'actionparams' => 'group_id='.intval($group_id).'&old_search='.$old_search,
			//    'cancel_action' => KTBrowseUtil::getUrlForFolder($this->oFolder),
			'cancel_action' => 'manageUsers',
			'context' => &$this,
			'extraargs' => $this->meldPersistQuery("","",true),
			'submit_label' => _kt("Подтвердить и начать импорт"),
		));

		return $oForm;
	}

	function do_confirmImportRusmarc() {
		$group_id = KTUtil::arrayGet($_REQUEST, 'group_id');
		$oGroup = Group::get($group_id);
		$i_new = 0;
		$i_added = 0;

		$liber_users_file = KTUtil::arrayGet($_SESSION, 'liber_users_file');
		if (!empty($liber_users_file)) {
			$lines = file($_SESSION['liber_users_file']); // $lines is an array of all file lines;
			if (is_array($lines)) {
				foreach ($lines as $line) {
					list($username, $name, $password/*, $email_address*/) = explode(' ', $line);
					mb_internal_encoding('UTF-8');
					$name = implode(' ', array($name, $password));
					$password = md5(mb_strtolower($password));

					// Ищем пользователя с таким именем в базе
					$oUser = User::getByUserName($username);

					// Если не найден - то это будет новый пользователь
					if (is_a($oUser, 'ktentitynoobjects')) {
						$oUser = new User();
						$oUser->loadFromArray(array(
						"sUsername" => $username,
						"sName" => $name,
						"sPassword" => $password,
						"iQuotaMax" => 0,
						"iQuotaCurrent" => 0,
						//"sEmail" => $email_address
						));
						$oUser->create();
						$i_new++;
					}
					if (!($oGroup->hasMember($oUser))) {
						$i_added++;
					}
					$oGroup->addMember($oUser);
				} // end foreach $line


				$example_users[] = $oUser;
			}
		}

		$this->successRedirectToMain(sprintf(_kt('Пользователи добавлены из файла. Новых: %d. Добавлено в группу: %d'), $i_new, $i_added));

		return '<pre>'.print_r($lines, true).'</pre>';
	}


	function do_main() {
		
		$oTemplate =& $this->oValidator->validateTemplate('importFields');
		$this->oPage->setBreadcrumbDetails(_kt("Импорт полей описания"));
		$this->oPage->setTitle(_kt("Импорт полей описания"));

		$oDocument = Document::get(
		KTUtil::arrayGet($_REQUEST, 'fDocumentId', 0)
		);

		
		$oFieldSet = KTFieldset::getByNamespace('lm.fieldsets.absotheque');

		if (is_a($oFieldSet, 'ktentitynoobjects')) {
			return $this->errorRedirectToBrowse(_kt('Не создан необходимый набор полей.
            Создайте набор полей через интерфейс администрированя: 
            см. "Метаданные по Документу и Настройки Документооборота"->"Настройки импорта полей"'));
		}

		$oField = DocumentField::getByFieldsetAndName($oFieldSet, 'id');
		$oFieldsLink = DocumentFieldLink::getByDocumentAndField($oDocument, $oField);

		if (is_a($oFieldsLink, 'DocumentFieldLink')) {
			$sValue = $oFieldsLink->getValue();
		} else {
			$sValue = '';
		}

		$add_fields = array();
		$aOptions = array('width' => '45');
		$add_fields[] = new KTStringWidget('id', _kt('Идентификатор документа в АИБС'), 'id', $sValue, $this->oPage, true, null, null, $aOptions);

		$oFormRusmarc = $this->form_rusmarc_initialdata();

		$aTemplateData = array('context' => &$this, 'add_fields' => $add_fields, 'oform_rusmarc' => $oFormRusmarc);

		return $oTemplate->render($aTemplateData);
	}
	
	function _getSettings() {
		$oJSON = new Services_JSON();
		$o = $oJSON->decode(KTUtil::getSystemSetting($this->settings_key));
		$settings = (array)$o;
		if(!is_array($settings)) {
			return null;
		};
		return $settings;
	}

	/**
	 * Enter description here...
	 *
	 * @param Document $oDocument
	 * @return unknown
	 */
	function _generateIlsExportURL(&$oDocument, &$settings) {
		$isl_id = $this->oValidator->validateInteger(KTUtil::arrayGet($_REQUEST, 'id', 0), $aErrorOptions);
		$elib_name = $oDocument->getName();
		$elib_id   = $oDocument->getId();

		$doc_export_url = str_replace(array('#ILS_ID#', '#ELIB_NAME#', '#ELIB_ID#'), array($isl_id, $elib_name, $elib_id), $settings['export_script_url']);
		return $settings['ils_server_url'].'/'.$doc_export_url;
	}
	
	function _getArrayContentType($headers) {
		/* Get the MIME type and character set */
		preg_match( '@([\w/+]+)(;\s+charset=(\S+))?@i', $headers['content_type'], $matches );
		if ( isset( $matches[1] ) )	$mime = $matches[1];
		if ( isset( $matches[3] ) )	$charset = $matches[3];
		return compact('mime', 'charset');
	}

	function do_importFields() {
		$aErrorOptions = array(
			'redirect_to' => array('main', sprintf('fDocumentId=%d', $this->oDocument->getId())),
			'max_str_len' => 200,
		);
		
		$sErrorMessage = "Ошибка импорта полей, URL = %s \n Доп. информация: %s";
		$sMessage = "Значения полей будут импортированы, URL = %s \n Доп. информация: %s";

		$iAbsoId = $this->oValidator->validateInteger(KTUtil::arrayGet($_REQUEST, 'id',0), $aErrorOptions);

		$oDocument = Document::get(
		KTUtil::arrayGet($_REQUEST, 'fDocumentId', 0)
		);
		
		$this->settings = $this->_getSettings();

		$req = $this->_generateIlsExportURL($oDocument, $this->settings);
		if (is_null($req) || empty($req)) {
			return $this->errorRedirectToBrowse(_kt('Не настроен адрес URL скрипта экспорат данных из АИБС. Задайте необходимые настройки через интерфейс администрированя:
        	см. "Метаданные по Документу и Настройки Документооборота"->"Настройки импорта полей"'));
		}
		
		require_once('Net/Curl.php');
		
		$curl = & new Net_Curl($req);
		$result = $curl->execute();
		if (!PEAR::isError($result)) {
			$text = $result;
			$result_headers = $curl->getInfo();
			$aContentType = $this->_getArrayContentType($result_headers);
		} else {
			$text = $result->getMessage();
			$this->errorRedirectToMain(sprintf($sErrorMessage, $req, $text));
		}
		
		// now check against required format (json or binary)
		// json and Content-type == text/html 
		// binary and Content-type == text/html 
		list($type, $subtype) = explode('/', $aContentType['mime']);
		
		list($assumedType, $assumedSubtype) = explode('/', $this->settings['export_sctipt_format']);
		
		switch ($assumedType) {
			case 'json':
				$oJSON = new Services_JSON(SERVICES_JSON_LOOSE_TYPE);
				$a = $oJSON->decode($result);
				$marc_text = $a[$assumedSubtype];	
				break;
			case 'binary':
				if (empty($result)) {
					$this->errorRedirectToMain(sprintf($sErrorMessage, $req, 'Ответ сервера не содержит информации для импорта'));
					return;
				} elseif (strtolower(substr(trim(strip_tags($result)), 0, 5)) == 'error') {
					$this->errorRedirectToMain(sprintf($sErrorMessage, $req, 'сервер сообщает об ошибке.'));
					return;
				}
				$marc_text = $result;
			default:
				break;
		}
		
		$aFields = $this->_parseMarc($marc_text, $assumedSubtype);
		$aFields['001']['a'][0] = $iAbsoId;
		
		//$oFieldSet = KTFieldset::getByNamespace('lm.fieldsets.absotheque');
		
		$iDocumentId = KTUtil::GetId($oDocument);
		$fieldSets = KTMetadataUtil::fieldsetsForDocument($oDocument, $oDocument->getDocumentTypeID());
		
		foreach ($fieldSets as &$oFieldSet) {
			$this->_saveFieldsetData($oDocument, $oFieldSet, $aFields);
		}
		
		$sMessage = 'Значения полей успешно импортированы';
		$this->successRedirectToMain($sMessage,sprintf('fDocumentId=%d', $this->oDocument->getId()));
		return;
	}


	function _readMarcFromFile($fname, $recNumber = 0) {
		// подключение файла
		$text = file_get_contents($fname);
		$text = explode(chr(0x1D),$text);
		return $text[$recNumber];
	}

	function _parseMarc($text, $format='rusmarc') {
		if (empty($text)) return null;
		$Notice = new iso2709_record($text);

		// include from ohter page
		// разбиение записи по полям
		$TblNotice="";
		if ($Notice->valid()) {
			foreach($Notice->inner_directory as $field) {
				$current_field = $field['label'];
				$result = $Notice->get_subfield($field['label']);

				if(is_array($TblNotice[$current_field])){
					continue ;
				}

				for($k=0;$k<count($result);$k++){
					$content = $result[$k];

					if(preg_match('/^.{2}'.$Notice->rgx_subfield_begin.'/', $content)) {
						$ind1 = $content[0];
						$ind2 = $content[1];
						$content = substr($content, 2);
					} else {
						$ind1 = '&nbsp;';
						$ind2 = '&nbsp;';
					}
					if(preg_match('/'.$Notice->rgx_subfield_begin.'/', $content)) {
						$subField = preg_split('/'.$Notice->rgx_subfield_begin.'/', $content, -1, PREG_SPLIT_NO_EMPTY);
						$hasSub = TRUE;
					} else {
						$subField = array($content);
						$hasSub = FALSE;
					}

					$counter46X = -1;
					while(list($key, $value) = each($subField)) {
						$value = $Notice->ISO_decode($value);

						$Valeur="";
						$SZone="";
						if($key) {
							if ($hasSub) {
								$SZone=$value[0];
								$Valeur=substr($value, 1);
							} else {
								$Valeur=$value;
							}
						} else {
							if ($hasSub) {
								$SZone=$value[0];
								$Valeur=substr($value, 1);
							} else {
								$Valeur=$value;
							}
						}

						if ($SZone=="") {$SZone="a";}

						if($current_field == '463'){
							if($SZone == '1'){
								$counter46X++;
							}
							$TblNotice[$current_field][$SZone][$counter46X]=$Valeur;
						}else{
							$TblNotice[$current_field][$SZone][]=$Valeur;
						}
					}
				}
			}
		}
		// формирование полей
		$oFields = new Import($TblNotice,$Notice->inner_guide,$format);
		return $oFields->Notice;
	}


	function _parseMarcFields($aFields){
		foreach ($aFields as $field=>$subfields){
			foreach ($subfields as $subfield=>$values){
				foreach ($values as $value){
					$key = $field.'_'.$subfield;
					if($aOutputFields[$key]){
						$aOutputFields[$key] .= "<br>$key: ".$value;
					}else{
						$aOutputFields[$key] = $value;
					}
				}
			}
		}
		return $aOutputFields;
	}
}
// }}}

$oPluginRegistry =& KTPluginRegistry::getSingleton();
$oPluginRegistry->registerPlugin('LMImportFieldsPlugin', 'lm.import.fields.plugin', __FILE__);

?>