<?php

require_once('LMCommon.inc');
require_once('LMDocumentTransaction.inc');
require_once(KT_LIB_DIR . '/actions/documentaction.inc.php');
require_once(KT_LIB_DIR . '/actions/folderaction.inc.php');

class LMStatPlugin extends KTPlugin {
    var $sNamespace = "lm.statistics.plugin";
    var $iOrder = 50;
    var $rVersion = 0.2;

    function LMStatPlugin($sFilename = null) {
        $res = parent::KTPlugin($sFilename);
        $this->sFriendlyName = _kt('LiberMedia Statistics Plugin v'.$this->rVersion);
        return $res;
    }

    function setup() {
        $this->registerAction('documentaction', 'LMDocumentStatisticsAction',
        'lm.statistics.documentstatistics');
        $this->registerAction('folderaction', 'LMFolderStatisticsAction',
        'lm.statistics.folderstatistics');
        $this->registerAction('folderaction', 'LMFolderStatisticsDetailedAction',
        'lm.statistics.folderstatistics.detailed');

        // FIXME trigger for view doc
        //$this->registerTrigger('view', null, 'LMOnViewTrigger', 'lm.statistics.triggers.onview');
        //  $this->registerI18nLang('knowledgeTree', "ru_RU", 'translations/');
        //  $this->registerLanguage("ru_RU", "Russian");

        // FIXME use template location like this:
        //
        /*
        $oTemplating =& KTTemplating::getSingleton();
        $oTemplating->addLocation('libermedia', '/plugins/libermedia/templates');
        */
    }

    function generateText(&$res) {
        $TransactionsText = array(
        'ktcore.transactions.create'=>'Создание',
        'ktcore.transactions.update'=>'Обновление',
        'ktcore.transactions.delete'=>'Удаление',
        'ktcore.transactions.rename'=>'Переименование',
        'ktcore.transactions.move'=>'Перемещение',
        'ktcore.transactions.download'=>'Загрузка',
        'ktcore.transactions.view'=>'Просмотр',
        'ktcore.transactions.secview'=>'Защищенный просмотр');

        $new_res = array();

        foreach ($res as $row) {
            $text = $TransactionsText[$row['transaction_namespace']];

            if (!empty($text)){
                $row['text'] = $text;
            } else {
                $row['text'] = $row['comment'];
            }
            $new_res[] = $row;
        }
        return $new_res;
    }
}

$oRegistry =& KTPluginRegistry::getSingleton();
$oRegistry->registerPlugin('LMStatPlugin', 'lm.statistics.plugin', __FILE__);

class LMOnViewTrigger {
    function setInfo($data) {
        print_r($data);
    }
}

// {{{ LMDocumentStatisticsAction
class LMDocumentStatisticsAction extends KTDocumentAction {
    var $sName = 'lm.statistics.documentstatistics';
    var $_sShowPermission = "ktcore.permissions.read";

    function getDisplayName() {
        if (!Permission::userIsSystemAdministrator()) return '';
        return _kt('Статистика документа');
    }

    function getInfo() {
        return parent::getInfo();
    }

    // display existing links
    function old_do_main() {
        $oTemplate =& $this->oValidator->validateTemplate('libermedia/document_statistics');
        //$this->oPage->setBreadcrumbDetails(_kt("Statistics"));
        $this->oPage->setBreadcrumbDetails(_kt("Статистика"));
        //$this->oPage->setTitle(_kt("Statistics"));
        $this->oPage->setTitle(_kt("Статистика"));

        $oDocument = Document::get(
        KTUtil::arrayGet($_REQUEST, 'fDocumentId', 0)
        );

        //$oReadPermission =& KTPermission::getByName('ktcore.permissions.read');
        //$oWritePermission =& KTPermission::getByName('ktcore.permissions.write');

        /*
        $aTemplateData = array(
        'context' => $this,
        'links_from' => DocumentLink::getLinksFromDocument($oDocument->getId()),
        'links_to' => DocumentLink::getLinksToDocument($oDocument->getId()),
        'read_permission' => KTPermissionUtil::userHasPermissionOnItem($this->oUser, $oReadPermission, $this->oDocument),
        'write_permission' => KTPermissionUtil::userHasPermissionOnItem($this->oUser, $oWritePermission, $this->oDocument),
        );
        */

        $transactions = LMDocumentTransaction::getStatByDocument($oDocument->getId());

        foreach ($transactions as $item) {
            if (is_object($item)) {
                //$item -> sComment =  _kt($item -> sComment);
                $transactions2[] = $item;
            }
        }

        $aTemplateData = array(
        'name' => $oDocument->getName(),
        'context' => $this,
        'transactions' => $transactions2,
        );

        return $oTemplate->render($aTemplateData);
    }

    function do_main() {
    	if (!Permission::userIsSystemAdministrator()) return '';
        $oTemplate =& $this->oValidator->validateTemplate('libermedia/document_statistics');
        //$this->oPage->setBreadcrumbDetails(_kt("Statistics"));
        $this->oPage->setBreadcrumbDetails(_kt("Статистика"));
        //$this->oPage->setTitle(_kt("Statistics"));
        $this->oPage->setTitle(_kt("Статистика"));

        $oDocument = Document::get(
        KTUtil::arrayGet($_REQUEST, 'fDocumentId', 0)
        );

        $stat = LMDocumentTransaction::getStatByDocument($oDocument);

        $stat = LMStatPlugin::generateText($stat);

        $aTemplateData = array(
        'name' => $oDocument->getName(),
        'context' => $this,
        'transactions' => $stat,
        );

        return $oTemplate->render($aTemplateData);
    }


    /*
    function getURL() {
    return generateControllerLink("viewDocumentStatistics", sprintf("fDocumentId=%d", $this->oDocument->getID()));
    }*/
}
// }}}

class LMFolderStatisticsDetailedAction extends KTFolderAction {
    var $sName = 'lm.statistics.folderstatistics.detailed';
    var $_sShowPermission = "ktcore.permissions.read";

    function getDisplayName() {
        if (!Permission::userIsSystemAdministrator()) return '';
        return _kt('Подробная статистика');
    }

    function getInfo() {
        return parent::getInfo();
    }

    function getDetailsGrid($aData, $sPrefix = '', $bShowPath = true) {
        $dg = LMCommon::GetEmptyDataGrid(15, null, DATAGRID_RENDER_SMARTY);

        $dg->setRequestPrefix($sPrefix);

        $dg->bind($aData);

        /* @var $dg Structures_DataGrid */
        // Define columns for the DataGrid
        //
        $column = & new Structures_DataGrid_Column('Name', 'name', 'name');
        $dg->addColumn($column);
        if ($bShowPath) {
            $column = & new Structures_DataGrid_Column('Path', 'full_path', 'full_path');
            $dg->addColumn($column);
        }
        $column = & new Structures_DataGrid_Column('Загрузок', 'count', 'count');
        $dg->addColumn($column);


        // Define attribute for columns
        //
        $aAttribs = array('name' => array('style' => 'width:40%;'),
        'full_path' => array('style' => 'width:50%;'),
        'count' => array('align' => 'center', 'style' => 'width:50px;'));

        // Print the DataGrid using Smarty
        //

        /* @var $oSmarty Smarty */
        $oSmarty = LMCommon::GetSmarty();

        // Load template
        $oTemplate =& $this->oValidator->validateTemplate('libermedia/folder_statistics_datagrid');

        // Tweak renderer
        //
        $renderer =& $dg->getRenderer();
        $renderer -> setContainer($oSmarty);
        $renderer -> setOption('columnAttributes', $aAttribs);
        $renderer -> setOption('selfPath', '');

        if (PEAR::isError($result)) {
            //$res = $res.$result->getMessage();
            return $result;
        } else {
            $dg->fill($renderer->getContainer());
            return $oSmarty->fetch($oTemplate->sPath);
        }
    }

    function do_main() {
    	if (!Permission::userIsSystemAdministrator()) return '';
        $oFolder = Folder::get(
        KTUtil::arrayGet($_REQUEST, 'fFolderId', 0)
        );

        // ******************* Детализация по файлам ****************** //
        //

        $oDocsTemplate =& $this->oValidator->validateTemplate('libermedia/folder_statistics_doc_details');
        $details_recur = LMDocumentTransaction::getDocDetailsByFolder($oFolder);
        $details = LMDocumentTransaction::getDocDetailsByFolder($oFolder, false);

        $details_recursive = LMStatPlugin::generateText($details_recur);
        $details = LMStatPlugin::generateText($details);

        $aDocsTemplateData = array(
        'name' => $oFolder->getName(),
        'context' => $this,
        'transactions_recursive' => $details_recursive,
        'transactions' => $details,
        );


        $aDocsTemplateData['datagrid']  = LMFolderStatisticsDetailedAction::getDetailsGrid($details_recursive, 'rec_');
        $aDocsTemplateData['datagrid2'] = LMFolderStatisticsDetailedAction::getDetailsGrid($details, '', false);

        $res = $oDocsTemplate->render($aDocsTemplateData);


        // Возвращаем результат в виде HTML кода
        //
        return $res;
    }

    function do_exportCSV() {
        $oFolder = Folder::get(
        KTUtil::arrayGet($_REQUEST, 'fFolderId', 0)
        );
        
        $id = $oFolder->getId();
        
        $bShowPath = true;
                
        $aData = LMDocumentTransaction::getDocDetailsByFolder($oFolder);
               
        $dg = LMCommon::GetEmptyDataGrid(null, null, DATAGRID_RENDER_CSV);
        
        $renderer =& $dg->getRenderer();
        
        $renderer->setOptions(array(
                'delimiter' => ';',
                'filename'  => "export-$id.csv",
                'enclosure' => '"',
                'lineBreak' => "\r\n",
                'useQuotes' => true
            ));

        $dg->setRequestPrefix($sPrefix);

        $dg->bind($aData);

        /* @var $dg Structures_DataGrid */
        // Define columns for the DataGrid
        //
        $column = & new Structures_DataGrid_Column(_kt('Name'), 'name', 'name');
        $dg->addColumn($column);
        if ($bShowPath) {
            $column = & new Structures_DataGrid_Column(_kt('Path'), 'full_path', 'full_path');
            $dg->addColumn($column);
        }
        $column = & new Structures_DataGrid_Column('Загрузок', 'count', 'count');
        $dg->addColumn($column);

        // Print the DataGrid using CSV
        //

        // Tweak renderer
        //
        $res = $dg->getOutput();
               
        header('Content-disposition: attachment; filename=' . "export-$id.csv");
        header("Content-Length: ". strlen($res));
        header("Content-type: text/csv; charset=UTF-8");        

        echo $res;

        exit(0);
    }
}

class LMFolderStatisticsAction extends KTFolderAction {
    var $sName = 'lm.statistics.folderstatistics';
    var $_sShowPermission = "ktcore.permissions.read";

    function getDisplayName() {
        if (!Permission::userIsSystemAdministrator()) return '';
        return _kt('Статистика папки');
    }

    function getInfo() {
        return parent::getInfo();
    }

    // display existing links
    function do_main() {
    	if (!Permission::userIsSystemAdministrator()) return '';
        $oTemplate =& $this->oValidator->validateTemplate('libermedia/folder_statistics');
        //$this->oPage->setBreadcrumbDetails(_kt("Statistics"));
        $this->oPage->setBreadcrumbDetails(_kt("Статистика"));
        $this->oPage->setTitle(_kt("Статистика папки"));

        $oFolder = Folder::get(
        KTUtil::arrayGet($_REQUEST, 'fFolderId', 0)
        );

        $stat = LMDocumentTransaction::getStatByFolder($oFolder);
        $stat2 = LMDocumentTransaction::getStatByFolder($oFolder, false);
       
        $stat = LMStatPlugin::generateText($stat);
        $stat2 = LMStatPlugin::generateText($stat2);

        $aTemplateData = array(
        'name' => $oFolder->getName(),
        'context' => $this,
        'transactions' => $stat,
        'transactions2' => $stat2,
        );

        $res =  $oTemplate->render($aTemplateData);

        // Возвращаем результат в виде HTML кода
        //
        return $res;
    }

}
// }}}

?>