<?php


Class Import
{
	
	var $Notice; 	// array converted into absounicode format
	var $Exemplar; 	// array 4 convert exemplares
	var $format;	// USMARC or RUSMARC
	var $Error;		// array 4 error report
	var $encode;	// import document encode 
	var $enreg;		// var 4 work with BD, need class "gest_bdd"
	var $categ;		// код типа описание согласно формату абсотек (1-книга; 4- периодика)
	var $noticeInd; // 4 notice wihtout notice idedtificator id
	var $type;		// type of item
	var $biblLevel;	// уровень иерархии библ. описания
	var $relatedNotices; // для хранения мвязанных записей
	
	// constructor
	function import($disc,$mark,$format="rusmarc"){
		// generate $this->Notice - mod 4 absotheque format
		// формирование массива формата абсотек: $this->Notice
		if(!$format){
			$format = "rusmarc";
		}
		$this->Error = '';
		$this->noticeInd = 0;
		$this->encode = array();
				
		$this->DBConnect();
		
		$this->format =$format;
		
		$this->biblLevel = $mark['hl'];
		
		if($disc){

			// set notice category(book,magazine, periodic etc.)
			// тип издания (книга, периодика и т.п.)
			$this->SetCateg($mark['dt'],$mark['bl']);

			switch ($format){
				case "rusmarc":
					$this->ConvFromRUSMARC($disc);
					break;
				case "usmarc":
					$this->ConvFromUSMARC($disc);
					break;
				case "marc21":
					$this->ConvFromMARC21($disc);
					break;
				default:
					$this->ConvFromRUSMARC($disc);
			}
			//$this->changeCodepageToUtf();
		}
		
		if($this->biblLevel == 2){
			$this->relatedNotices = $this->Conv4Periodic();
		}
	}
	
	function array_shiftByKey($key,&$array){
		if(array_key_exists($key,$array)){
			$out = $array[$key];
			unset($array[$key]);
			return $out;
		}
		return false;
	}
	
	function parseField46x($f46x){
		$out = array();
		foreach ($f46x as $subfield=>$arr){
			foreach ($arr as $nom=>$val){
				if($subfield == '1'){
					$temp[$nom] = substr($val,0,3);
				}else{
					$newfield = $temp[$nom];
					$out[$newfield][$subfield][] = $val;
				}
			}
		}
		return $out;
	}
	
	function Conv4Periodic(){
		if($this->categ==4){
			// периодика
			
		}
		
		// для статьи ,если описание в одном файле! 
		if($this->categ==6){
			
			$period = array();
			$number = array();
			$article = array();
			
			// 
			$f461 = $this->parseField46x($this->array_shiftByKey('461',$this->Notice));
			$f463 = $this->parseField46x($this->array_shiftByKey('463',$this->Notice));
			$f225 = $this->array_shiftByKey('225',$this->Notice);
			$fR600 = $this->array_shiftByKey('R600',$this->Notice);
			
			//статья
			
			$article = $this->Notice;
			$rubrics = $this->array_shiftByKey('606',$article);
			$pages = $f463['200']['v'][0];
			if($rubrics){
				$article['R600'] = $rubrics;
			}
			if($pages){
				$article['215']['a'][] = $pages;
			}
			// 600-е поля 
			
			// периодика
			$period = $f461;
			$year = $f463['210']['d'][0];
			if($year){
				$period['210']['d'][] = $year;
			}
			
			// номер
			$nom = $f463['200']['a'][0];
			if($fR600){
				$number['R600'] = $fR600;
			}
			if($f225){
				$number['225'] = $f225;
			}	
			if($f461['200']){
				$number['200'] = $f461['200'];
			}
			if($nom){
				$number['207']['a'][] = $nom;
			}
		}
		
		return array('period'=>$period, 'number'=>$number, 'article'=>$article);
	}
	
	function ConvFromUSMARC($disc){
		/**
		 * связь полей между RusMARC и USMARC
		 */
		$ConnectionNotice = array(
			"001"=>array("a"=>"001:a"),// id книги
			"020"=>array("a"=>"010:a",
						 "c"=>"010:d", 
						 "z"=>"010:z"), // a- ISBN, c- цена, z - ошибочный ISBN
			"041"=>array("a"=>"101:a"),// язык
			"091"=>array("a"=>"675:a"),// УДК
//			"091"=>array("a"=>"686:a"),// ББК (специально для МГПУ)
			"100"=>array("a"=>"200:f",//a-основной автор
						 "e"=>"200:6",//e-ответственность
						 "t"=>"503:a"),// t- унифициорванное заглавие
			// следующее для МПГУ:
			"110"=>array("a"=>"200:f"),// унифициорванное заглавие
			"245"=>array("a"=>"200:a",//a-заголовок
						 "b"=>"200:e",//b-сведенья
						 "c"=>"209:g",//c-Последующие сведения об ответственности,
						 "n"=>"200:h",//n- Номер части,
						 "p"=>"200:i"),//  p- Наименование части							
			"250"=>array("a"=>"205:a"),//сведенья об издании
			"260"=>array("a"=>"210:a",
						 "b"=>"210:c",
						 "c"=>"210:d"),//a-место изд.,b-Издатель,с-год
			"300"=>array("a"=>"215:a",
						 "b"=>"215:c",
						 "e"=>"215:e"),//a-кол-во страниц,b-другие физ. хар-ки, e- сопроводительный материал
			"490"=>array("a"=>"225:a",
						 "v"=>"225:v",
						 "x"=>"225:x"),//a-заглавие серии, v-номер в серии, x- ISSN серии 
			"500"=>array("a"=>"300:a"),//a- примечание
			"504"=>array("a"=>"327:a"),//a- примечаине о содержании
			"520"=>array("a"=>"330:a"),//a- аннотация\реферат
			"653"=>array("a"=>"R600:a"),//a- рубрики
			"700"=>array("a"=>"200:g",
						 "e"=>"200:8"),//a-другие авторы,e-ответственность
			// 4 МПГУ
			"952"=>array("a"=>"941:c")// вноситель // оказалось - фонд
		);
		
		/**
		 * экземпляры 4 МПГУ
		 */
		$ConnectoinExeplar = array(
			"852"=>array("b"=>"facul","i"=>"autsign","p"=>"invent","h"=>"index")//,//"t"=>"001:a"),// b- факультет, i- авторский знак,p- инвентарный номер, t-кол-во экземпляров
			//"952"=>array("p"=>"corresp")//p- № кореспондент счёта(МГПУ не нужен)
		);
		
		if($this->categ == 4){// для сериальных изданий
			$ConnectionNotice["020"]["a"]="010:d";
		}
		
		// count exemplars 4 МПГУ
		$countExempl = array();
		$arr = $disc["852"]["t"];
		for($i=0;$i<count($arr);$i++){
			$countExempl[$i]=$arr[$i];
		}
				
		// create $this->notice according Absotheque format
		foreach ($disc as $fild => $arr){
			foreach ($arr as $subfild => $value){
				
				// аналитическое описание
				$str = $ConnectionNotice[$fild][$subfild];
				if($str){
					$str = explode(":",$str);
					$fild_new = $str[0];
					$subfild_new = $str[1];
					
					for($i=0;$i<count($value);$i++){
							$this->Notice[$fild_new][$subfild_new][] = $this->deleteLastSymb($value[$i]);
					}
				}
				
				// описаине экземпляров
				$str = $ConnectoinExeplar[$fild][$subfild];
				if($str){
					$count=0;
					for($i=0;$i<count($value);$i++){
						for($j=0;$j<$countExempl[$i];$j++){
							if($str!="invent"){
								$this->Exemplar[$count][$str] = $value[$i];
							}else{
								if($value[$count]){
									$this->Exemplar[$count][$str] = $this->deleteLastSymb($value[$count]);
								}else{
									$this->Exemplar[$count][$str] = $this->deleteLastSymb($value[0]);
								}
							}
							$count++;
						}					
					}
				}
				
			}
		}// foreach
		
		// if several series and editors
		if(count($this->Notice['210']['c'])< count($this->Notice['225']['a'])){
			$countEditor = count($this->Notice['225']['a']);
			$dif = $countEditor - count($this->Notice['210']['c']);
			$countEditor++;
			for($i=0;$i<$dif;$i++){
				$this->Notice['210']['c'][] = $this->Notice['210']['c'][0];
			}
		}
		
		/** Для МПГУ
		$catal = $disc["952"]["a"][0];
		for($i=0;$i<count($this->Exemplar);$i++){
			$this->Exemplar[$i]["catal"]=$catal;
		}
		*/
		
		//add language
		if($this->Notice["101"]['a']){
			$lang = $this->Notice["101"]['a'][0];
			unset($this->Notice["101"]['a']);
			$this->SetLanguage($lang);
		}
	}
	
	function ConvFromRUSMARC($disc){	
		foreach ($disc as $fild => $arr){
			// remane filds if need according Absotheque format
			switch($fild){
				case "100":
					$this->separete100($arr);
					break;
				case "101":
					if(!$this->Notice["101"]["a"]){
						$this->SetLanguage($arr["a"][0]);
					}
				case "200":
					$this->separete200($arr);
					break;
				case "300":
					//$this->separete300($arr);
					$this->Notice[$fild] = $arr;
					break;
				//case "327":
				case "600":
					$this->separete600($arr);
					break;
				case "601":
					$this->separete601($arr);
					break;
				case "605":
					$this->separete605($arr);
					break;
				case "610":
					$this->separete610($arr); 
					break;
				case "700":
				case "702":
				case "710":
					$this->separete700($arr); 
					break;
				case "801":
					break;
				default:
					$this->Notice[$fild] = $arr;
					break;
			}
		}
		if ($this->encode[0] != "UTF-8"){
			$this->changeCodepageToUtf();
		}
	}
	
	function ConvFromMARC21($disc){
		$ConnectionNotice = array(
			"001"=>array("a"=>"001:a"),	// id книги
			"020"=>array("a"=>"010:a", 	// a- ISBN
						 "c"=>"010:d", 	// c- цена
						 "z"=>"010:z"),	//z - ошибочный ISBN
			//"035"=>array("9"=>"xxx:b"),// ???? 
			"040"=>array("a"=>"801:b"),	// a -cоздатель записи, 
			"041"=>array("a"=>"101:a"),	// язык
			//"050"=>array("a"=>"xxx:a","b"=>"xxx:a"),// ????
			"080"=>array("a"=>"675:a"),	// УДК
			"081"=>array("a"=>"675:a"),	// УДК
			"082"=>array(//"2"=>"xxx:a",
						 "a"=>"675:a"),// ???? УДК?
			"084"=>array("a"=>"686:a"),	// ББК
			//"091"=>array("a"=>"686:a"),// ББК (специально для МГПУ)
			"100"=>array("a"=>"200:f", 	// a-основной автор
						 "e"=>"200:6"),	// e-ответственность 
			"110"=>array("a"=>"200:f"),	// наимнование коллектива
			"130"=>array("a"=>"503:a"),	// унифицированное заглавие
			"245"=>array("a"=>"200:a",	//a-заголовок
						 "b"=>"200:e",	//b-сведенья
						 "c"=>"209:g",	//c-Последующие сведения об ответственности
						 "n"=>"200:h",	//n- Номер части 
						 "p"=>"200:i"), //p- Наименование части							
			"246"=>array("a"=>"200:d"),	// вариант заглавия (параллельное)
			"250"=>array("a"=>"205:a"),	//сведенья об издании
			"260"=>array("a"=>"210:a",	//a-место изд.
						 "b"=>"210:c",	//b-Издатель
						 "c"=>"210:d"),	//с-год
			"300"=>array("a"=>"215:a",	//a-кол-во страниц
						 "b"=>"215:c",	//b-другие физ. хар-ки
						 "c"=>"215:a",	//c- размеры -> в кол-во страниц
						 "e"=>"215:e"),	//e- сопроводительный материал
			//"310"=>array("a"=>"xxx:a"),//a- периодичность (пр.: Ежедневно)
			"362"=>array("a"=>"303:a"),	//a- даты публикации\ обознач. и нормер тома -> в примечание
			// поля 440 и 490 в разных выгрузках идентичны
			"440"=>array("a"=>"225:a",	//a-заглавие серии
						 "v"=>"225:v",	// v-номер в серии
						 "x"=>"225:x"),	// x- ISSN серии
			"490"=>array("a"=>"225:a",	//a-заглавие серии
						 "v"=>"225:v",	//v-номер в серии
						 "x"=>"225:x"),	//x- ISSN серии
			"500"=>array("a"=>"300:a"),	//a- примечание
			"504"=>array("a"=>"327:a"),	//a- примечаине о содержании
			"515"=>array("a"=>"300:a"),	//a- примечание о нумерации -> в общие примечания
			"520"=>array("a"=>"330:a"),	//a- аннотация\реферат
			// примечание об оригинале
			"534"=>array("a"=>"330:a",	//a- поисковый признак записи
						 "p"=>"330:a",	//p- вводные слова
						 "t"=>"330:a"),	//t- область заглавия
			"590"=>array("a"=>"303:a"),	//a- какие-то примечания -> в примеч по биб. описанию
			"650"=>array("a"=>"R600:a",	//a- рубрики
						 "v"=>"R600:a",	//v- типовое деление  -> в рубрики
						 "x"=>"R600:a"),//х- основное деление -> в рубрики
			"700"=>array("a"=>"200:g",	//a- другие авторы
						 "e"=>"200:8"),	//e- ответственность других авторов
			"710"=>array("a"=>"200:g",	//a- другие коллект. авторы
						 "e"=>"200:8"),	//e- коллект. ответственность
			//"740"=>array("a"=>"200:у"),//a-связанное заглавие???
			
		);
		
		//create $this->notice according Absotheque format 
		foreach ($disc as $fild => $arr){
			foreach ($arr as $subfild => $value){

				// аналитическое описание
				$str = $ConnectionNotice[$fild][$subfild];
				if($str){
					$str = explode(":",$str);
					$fild_new = $str[0];
					$subfild_new = $str[1];

					for($i=0;$i<count($value);$i++){
						$this->Notice[$fild_new][$subfild_new][] = $this->deleteLastSymb($value[$i]);
					}
				}
			}
		}
		
		//add language
		$lang = substr($disc['008']['a'][0],35,3);
		$this->SetLanguage($lang);

	}
	
	function SetLanguage($lang){
			$this->Notice['101']['a'][] = $lang;
	}
	
	function separete100($arr){
		$str 	= $arr['a'][0];
		
		if(strlen($str) != 36){
			$this->Error[] = 'incorrect length of 100 fild';
		}
		$str = str_replace('#',' ',$str);
		
		// separete 100 fild
		$date	  = substr($str,0,8);
		$dateType = substr($str,8,1);
		$datePub1 = substr($str,9,4);
		$datePub2 = substr($str,13,4);
		$codGov   = substr($str,20,1);
		$codMod   = substr($str,21,1);
		$lang 	  = substr($str,22,3);
		$codTrans = substr($str,25,1);
		$symb 	  = substr($str,26,4);
		$symb2 	  = substr($str,30,4);
		$langHead = substr($str,34,2);
		
		// add language into 101 fild
		if(trim($lang) == ''){
			$this->Error[] = 'language don\'t set (fild 100)'; 
		}
		
		$this->SetLanguage($lang);
			
		// set encode
		if( strlen(trim($symb)) == 2){
			$encode[] = trim($symb);
		}elseif(strlen(trim($symb)) == 4){
			$encode[] = substr($symb,0,2);
			$encode[] = substr($symb,2,4);
		}else{
			$this->Error[] = 'incorrect encode format (fild 100)';
		}
		
		if( strlen(trim($symb2)) == 2){
			$encode[] = $symb2;
		}elseif(strlen(trim($symb2)) == 4){
			$encode[] = substr($symb2,0,2);
			$encode[] = substr($symb2,2,4);
		}
		
		foreach ($encode as $cod){
			// при несоответствии стандарту: если заполнено нулями, а не пробелами!
			if( trim($cod) == '' || $cod == '00' ){
				continue;
			}
			
			switch($cod){
				case '50':
					$this->encode[] = "UC";//Unicode, UTF-8
					break;
				case '79':
					$this->encode[] = "DOS";//Code Page 866
					break;
				case '89':
				case '04':
					$this->encode[] = "WIN";//WIN 1251
					break;
				case '99':
					$this->encode[] = "KOI";// KOI-8
					break;
				default:
					$this->encode[] = "UN";// unknoun
					break;
			}
		}
	
		
		// add date into 201 fild
		if(trim($dateType) == ''){
			$this->Error[] = 'type of date don\'t set (fild 100)'; 
		}
		switch ($dateType){
			
			case "d"://book
				if(trim($datePub1) != ''){
					$this->Notice['210']['d'][] = $datePub1;
				}
				if(trim($datePub2) != ''){
					$this->Notice['210']['h'][] = $datePub2;
				}
				break;
		}
		
		 /**
			switch ($dateType){
			case "a":
				break;
			case "b":
				break;
			case "c":
				break;
			case "e":
				break;
			case "f":
				break;
			case "h":
				break;
			case "i":
				break;
			case "j":
				break;
			case "k":
				break;
			case "u":
				break;	
			}	
			*/

		
	} // function separete100($arr)
	
	function separete200($arr){
		
		foreach ($arr as $subfild => $arrVal){
			// подполя f и g
			if($subfild == 'f' || $subfild == 'g'){
				
				// разбить авторов и их ответственность
				if($subfild == 'f'){
					$respFild = '6';
				}else{
					$respFild = '8';
				}
				
				//for($i =0;$i<count($arrVal);$i++){
				foreach ($arrVal as $i=>$val){	
					$str  = $arrVal[$i];
					$count =  substr_count($str,' ');
					
					if($count>1){
							$sep = 0;
							$str = explode(" ",$str);
							foreach ($str as $nom=>$text){
								if(substr($text,-1) == ','){
									$sep = $nom;
								}
							}
							$resp = '';
							$auter = '';
							for($j = 0; $j<$sep;$j++){
								$resp .= $str[$j]." ";
							}
							for($j = $sep; $j<count($str);$j++){
								$auter .= $str[$j]." ";
							}
							
							if($resp == ' '){
								$this->Notice['200'][$subfild][] = $arrVal[$i];	
							}else{
								$this->Notice['200'][$subfild][]  = substr($auter,0,-1);
								$this->Notice['200'][$respFild][] = substr($resp,0,-1);
							}
					}else{
							$this->Notice['200'][$subfild][] = $arrVal[$i];
						
					}
				}//for
			}else{
				$this->Notice['200'][$subfild] = $arrVal;
			}
 		}//foreach
	}
	
	function separete300($arr){
		return;
	}
	
	function separete600($arr){
//		foreach ($arr['a'] as $nom=>$val){
//			$this->Notice['200']['g'][] = trim($arr['a'][$nom].' '.$arr['g'][$nom]);
//			$this->Notice['200']['8'][] = $arr['c'][$nom];
//		}
	}
	
	function separete601($arr){
//		foreach ($arr['a'] as $nom=>$val){
//			$this->Notice['200']['g'][] = trim($arr['a'][$nom].' '.$arr['g'][$nom]);
//			$this->Notice['200']['8'][] = $arr['c'][$nom];
//		}
	}
	
	function separete605($arr){
			$this->Notice['503']['a'][] = implode('; ',$arr['a']);
	}
	
	function separete610($arr){
		$this->Notice['R600'] = array_merge($this->Notice['R600'],$arr);
	}
	
	function separete700($arr){
//		foreach ($arr as $subfield=>$val){
//			foreach ($val as $nom=>$value){
//				$nom = count($this->Notice['200']['g']);
//				if($subfield == 'a'){
//					$this->Notice['200']['g'][$nom] = $value;
//				}
//				if($subfield == 'g'){
//					$nom--;
//					$this->Notice['200']['g'][$nom] .= ', '.$value;
//				}
//			}
//		}
	}
	
	// Database functions
	
	function DBConnect(){
//		if($this->enreg){
//			return true;
//		}
//		// coonect with DB using global var.
//		$Session = $GLOBALS['Session'];
//		$Site	 = $GLOBALS['Site'];
//		$test = serialize($Site->TblRepert);
//		$this->enreg=new gest_bdd($Session->FicLog,$Site->TblRepert);
//		if(!$this->enreg->connexion($Session->ReqMajAcc)){
//			$this->Error[] = 'connection with DB falled. Import->DBConnect';
//			return false;
//		}
		return true;
	}
	
	function executeDB($request){
//		if(!$this->enreg){
//			$this->DBConnect();
//		}
//		return $this->enreg->TblEnreg($request);
		return '';
	}
	
	/**-----------------------------------------------------------------
		Group of IS functions
		check if: author(isAuter), author responsibility (isAuterResp),
				  Editor(isEditor),seria(isCollection),
				  heading(isMatiere) and notice(isNotice), ...
		exist. 
		Return true if exist or false
		if param $isresult == true this functions return ID of the element
	------------------------------------------------------------------*/
	
	function isAuter($name,$isresult=false){
		
		if(is_array($name)){
			$nom = $name[0];// фамилия
			$pre = $name[1];// имя
		}else{
			$name = $this->InsertAuterName($name);
			$nom = $name[0];// фамилия 
			$pre = $name[1];// имя
		}
		
		$req = "SELECT IdAuteur FROM AUTEUR WHERE nom like N'".addslashes($nom)."'";
		if($pre != ''){
			$req .= " AND Prenom like N'".addslashes($pre)."'";
		}
		
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res;
		}
		
		if(count($res)){
			return true;
		}
			
		return false;
	}
	
	function isEditor($EditName,$isresult=false){
		
		$req = "SELECT IdEditeur FROM EDITEUR WHERE nom like N'".addslashes($EditName)."'";
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res;
		}
		
		if(count($res)){
			return true;
		}
		
		return false;
	}
	
	function isUDC($val,$isresult=false){
		
		$req = "SELECT indice FROM DEWEY WHERE idDewey like N'".addslashes($val)."'";
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res;
		}
		
		if(count($res)){
			return true;
		}
		
		return false;
	}
	
	function isNotice($Titre,$categ,$isresult=false){
		
		$req = "SELECT NOTICE.IdNotice FROM NOTICE_Z, NOTICE WHERE notice_z.idZone = '200' and notice_z.sZone = 'a' 
				and notice_z.Valeur = N'".addslashes($Titre)."' and  NOTICE.categ = ".$categ."
				and notice_z.IdNotice = notice.IdNotice";
	
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res[0][1];
		}
		
		if(count($res)){
			return true;
		}
		
		return false;
	}
	
	function isNomber($idSource, $nom, $isresult=false){
		$req = "SELECT top 1  NOTICE_Z.IdNotice 
				FROM NOTICE_Z, LIEN_NOTICE
				WHERE notice_z.Valeur =  N'$nom' and LIEN_NOTICE.IdNoticeSource = $idSource
				and LIEN_NOTICE.IdNoticeCible = notice_z.idnotice";
	
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res[0][1];
		}
		
		if(count($res)){
			return true;
		}
		
		return false;
	}
	
	function isAuterResp($resp,$isresult=false){
		
		$req = "SELECT IdFonction FROM FONCTION WHERE Libelle = N'".addslashes($resp)."'";
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res;
		}
		
		if(count($res)){
			return true;
		}
		
		return false;
		
	}
	
	function isCollection($collectionName,$isresult=false){
		
		$req = "SELECT IdCollection FROM COLLECTION WHERE Libelle = N'".addslashes($collectionName)."'";
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res;
		}
		
		if(count($res)){
			return true;
		}
		
		return false;	
	}
	
	function isSousCollection($souscollectionName,$isresult=false){
		
		$req = "SELECT IdSousCollection FROM SOUSCOLLECTION WHERE Libelle = N'".addslashes($souscollectionName)."'";
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res;
		}
		
		if(count($res)){
			return true;
		}
		
		return false;	
	}
	
	function isLanguage($lang,$isresult=false){
		$req = "SELECT IdLangue FROM _LANGUE  WHERE IdLangueSoft=4 and code = '".addslashes($lang)."'";
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res;
		}
		
		if(count($res)){
			return true;
		}
		
		return false;
	}
	
	function isMatiere($matiere,$isresult=false){
		
		$req = "SELECT IdMatiere FROM MATIERE WHERE Sujet = N'".addslashes($matiere)."'";
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res;
		}
		
		if(count($res)){
			return true;
		}
		
		return false;	
	}
	
	function isPlace($var,$isresult=false){
		
		$req = "SELECT IdVille FROM VILLE WHERE Libelle = N'".addslashes($var)."'";
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res;
		}
		
		if(count($res)){
			return true;
		}
		
		return false;	
	}
	// 4 exemplar
	function isFilial($var,$isresult=false){
			
		$req = "SELECT IdANNEXE FROM ANNEXE WHERE Libelle = N'".addslashes($var)."'";
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res;
		}
		
		if(count($res)){
			return true;
		}
		
		return false;	
	}
	
	function isFond($var,$isresult=false){
		
		$req = "SELECT IdFonds FROM fonds WHERE Libelle = N'".addslashes($var)."'";
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res;
		}
		
		if(count($res)){
			return true;
		}
		
		return false;
	}
	
	function isCodbar($var,$isresult=false){
		
		$req = "SELECT Codbare FROM exemplaire WHERE Codbare like N'".addslashes($var)."'";
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res;
		}
		
		if(count($res)){
			return true;
		}
		
		return false;
	}
	
	function isType ($var,$isresult=false){
		
		$req = "SELECT IdType FROM TYPE WHERE Libelle = N'".addslashes($var)."'";
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res;
		}
		
		if(count($res)){
			return true;
		}
		
		return false;
	}
	
	function isLocalisation($var,$isresult=false){
		
		$req = "SELECT IdLocalisation FROM LOCALISATION WHERE Libelle = N'".addslashes($var)."'";
		$res = $this->executeDB($req);
		
		if($isresult){
			return $res;
		}
		
		if(count($res)){
			return true;
		}
		
		return false;
	}
		
	/**---------------------------------------------------------------
		Group of ADD functions
		add: author(addAuter), author responsibility (addAuterResp),
			 Editor(addEditor),seria(addCollection), 
			 heading(addMatiere) and notice(addNotice), ...
		into DB
	----------------------------------------------------------------*/
	
	function addAuter($name){
		
		$table = 'AUTEUR';
		$idname = 'IdAuteur';
		
		if(is_array($name)){
			$nom = $name[0];
			$pre = $name[1];
		}else{
			$name = $this->InsertAuterName($name);
			$nom = $name[0];
			$pre = $name[1];
		}
			
		$id = $this->enreg->sequence($table,$idname);
		$req = "INSERT INTO $table ($idname,nom,prenom) VALUES ($id,N'".addslashes($nom)."',N'".addslashes($pre)."')";
		$this->executeDB($req);
		
		$this->UpdateCompteur(++$id,$idname);
	}
	
	function addAuterResp($resp){
		$table = 'FONCTION';
		$idname = 'IdFonction';
		
		$id = $this->enreg->sequence($table,$idname);
		$req = "INSERT INTO $table ($idname,IdLangueSoft,code,Libelle) VALUES ($id,4,$id,N'".addslashes($resp)."')";
		$this->executeDB($req);
		
		$this->UpdateCompteur(++$id,$idname);
	}
	
	function addCollection($val,$num=0){
		$table = 'COLLECTION';
		$idname = 'IdCollection';
		
		$id = $this->enreg->sequence($table,$idname);
		$IdEditeur = $this->isEditor($this->Notice['210']['c'][$num],true);
		if(!$IdEditeur){
			$IdEditeur = 0;
		}else{
			$IdEditeur = $IdEditeur[0][1];
		}

		if($this->format == "USMARC"){
			$valU = mb_strtoupper($val);
		}else{
			$valU = strtoupper($val);
		}

		$req = "INSERT INTO $table ($idname,IdEditeur,Libelle,LibelleU)
							VALUES ($id,$IdEditeur,N'".addslashes($val)."',N'".addslashes($valU)."')";
		$this->executeDB($req);
		
		$this->UpdateCompteur(++$id,$idname);
	}
	
	function addSousCollection($val,$num=0){
		$table = 'SOUSCOLLECTION';
		$idname = 'IdSousCollection';
		
		$id = $this->enreg->sequence($table,$idname);
		$IdCollection = $this->isCollection($this->Notice['225']['a'][$num],true);
		if(!$IdCollection){
			$IdCollection = 0;
		}else{
			$IdCollection = $IdCollection[0][1];
		}

		if($this->format == "USMARC"){
			$valU = mb_strtoupper($val);
		}else{
			$valU = strtoupper($val);
		}

		$req = "INSERT INTO $table ($idname,IdCollection,Libelle,LibelleU)
							VALUES ($id,$IdCollection,N'".addslashes($val)."',N'".addslashes($valU)."')";
		$this->executeDB($req);
		
		$this->UpdateCompteur(++$id,$idname);
	}
	
	function addMatiere($val){
		$table = 'MATIERE';
		$idname = 'IdMatiere';
		
		$id = $this->enreg->sequence($table,$idname);
		$req = "INSERT INTO $table ($idname,Sujet) VALUES ($id,N'".addslashes($val)."')";
		$this->executeDB($req);
		
		$this->UpdateCompteur(++$id,$idname);
	}
	
	function addEditor($Name,$Addr='',$place=''){
		
		$table = 'EDITEUR';
		$idname = 'IdEditeur';
		
		$id = $this->enreg->sequence($table,$idname);
		$req = "INSERT INTO $table ($idname,Nom,Adresse1,Ville) VALUES ($id,N'".addslashes($Name)."',N'".addslashes($Addr)."',N'".addslashes($place)."')";
		$this->executeDB($req);
		
		$this->UpdateCompteur(++$id,$idname);
	}
	
	function addUDC($val){
		$table = 'DEWEY';
		$idname = 'INDICE';
		
		$id = $this->enreg->sequence($table,$idname);
		$req = "INSERT INTO $table ($idname,IdDewey) VALUES ($id,N'".addslashes($val)."')";
		$this->executeDB($req);
		
		$this->UpdateCompteur(++$id,$idname);
	}
	
	function addPlace($val){
		$table = 'VILLE';
		$idname = 'IdVille';

		if($this->format == "USMARC"){
			$valU = mb_strtoupper($val);
		}else{
			$valU = strtoupper($val);
		}

		if(substr($valU,-1)=="."){
			$valU = substr($valU,0,-1);
		}

		$id = $this->enreg->sequence($table,$idname);
		$req = "INSERT INTO $table ($idname,Libelle,LibelleU) VALUES ($id,N'".addslashes($val)."',N'".addslashes($valU)."')";
		$this->executeDB($req);
		
		//!!изменение последнего ID в Compteur!!!
		$this->UpdateCompteur(++$id,$idname);
	}
	
	function addNotice(){
		if(!is_array($this->relatedNotices)){
			$this->__addNotice($this->categ);
		}else{
			//todo сверка на повторение!!!
			if(is_array($this->relatedNotices['period'])){
				$period = $this->relatedNotices['period'];
				$this->Notice = $period;
				$idNoticePeriod = $this->isNotice($period['200']['a'][0],4,true);
				if(!$idNoticePeriod){
					$idNoticePeriod = $this->__addNotice(4);
					$idNoticePeriod--;
				}
			}
			if(is_array($this->relatedNotices['number'])){
				$number = $this->relatedNotices['number'];
				$this->Notice = $number;
				$idNoticeNumber = $this->isNomber($idNoticePeriod,$number['207']['a'][0],true);
				if(!$idNoticeNumber){
					$idNoticeNumber = $this->__addNotice(5);
					$idNoticeNumber--;
				}
			}
			if(is_array($this->relatedNotices['article'])){
				$article = $this->relatedNotices['article'];
				$this->Notice = $article;
				$idNoticeArticle = $this->isNotice($article['200']['a'][0],6,true);
				if(!$idNoticeArticle){
					$idNoticeArticle = $this->__addNotice(6);
					$idNoticeArticle--;
				}
			}
			$this->relateNotices($idNoticePeriod,$idNoticeNumber,4);
			$this->relateNotices($idNoticeNumber,$idNoticeArticle,5);
		}
	}
	
	function relateNotices($idSource,$id,$categSource){
		$order = $this->reletedMaxNom($idSource);
		$order = $order[0][1];
		if(!$order){
			$order = 0;
		}else{
			$order++;
		}
		$req = "insert into LIEN_NOTICE (IdNoticeSource,IdNoticeCible,IdDet,NumOrdre) 
				values ($idSource,$id,$categSource,$order)";
		$this->executeDB($req);
	}
	
	function reletedMaxNom($idSource){
		$req = "select max(NumOrdre) from LIEN_NOTICE where idNoticeSource  = $idSource";
		return $this->executeDB($req);
	}
	
	function __addNotice($categ){
		
		$table 	= 'NOTICE';
		$idname = 'IDNOTICE';
		$date 	= date("d.m.Y H:i:s");
		$Session = $GLOBALS['Session'];
		$userNum = $Session->User;
		
		$id = $this->enreg->sequence($table,$idname);
		$req = "INSERT INTO $table ($idname,Categ,UserCreation,DateCreation) 
				VALUES ($id,".addslashes($categ).",".addslashes($userNum).",'$date')";
		$this->executeDB($req);
		
		$this->InsertNoticeZ($id);

		
		/*
		// добавить экземпляры
		// для МПГУ
		for($i=0;$i<count($this->Exemplar);$i++){
			$this->addExemplar($id,$i);
		}*/

		$this->UpdateCompteur(++$id,$idname);
		return $id;
	}
	// 4 exemplar
	function addFilial($val){
		
		$table = 'ANNEXE';
		$idname = 'IdANNEXE';
			
		$id = $this->enreg->sequence($table,$idname);
		$req = "INSERT INTO $table ($idname,Libelle,IdBibliotheque) VALUES ($id,N'".addslashes($val)."',1)";
		$this->executeDB($req);
		
		$this->UpdateCompteur(++$id,$idname);
	}
	
	function addFond($val){
		$table = 'Fonds';
		$idname = 'IdFonds';
			
		$id = $this->enreg->sequence($table,$idname);
		$req = "INSERT INTO $table ($idname,Libelle) VALUES ($id,N'".addslashes($val)."')";
		$this->executeDB($req);
		
		$this->UpdateCompteur(++$id,$idname);
	}
	
	function addLocalisation($val){
		
		$table = 'Localisation';
		$idname = 'IdLocalisation';
			
		$id = $this->enreg->sequence($table,$idname);
		$req = "INSERT INTO $table ($idname,Libelle) VALUES ($id,N'".addslashes($val)."')";
		$this->executeDB($req);
		
		$this->UpdateCompteur(++$id,$idname);
		
	}
	
	function addExemplar($idnotice,$num){
		$table = 'Exemplaire';
		$idname = 'IdExemplaire';
		
		
		$id = $this->enreg->sequence($table,$idname);
				
/**		$idsection = $this->isFond($value,true);
		if(!$idsection){
			$this->addFond($value);
			$idsection = $this->isFond($value,true);
		}*/

		$idsection = 1;
			
		$val = $this->Exemplar[$num]['facul'];
		$idannexe = $this->isFilial($val,true);
		if(!$idannexe){
			$this->addFilial($val);
			$idannexe = $this->isFilial($val,true);	
		}
		$idannexe = $idannexe[0][1];
		/** 
		// 4 MGPU
		$idLocalisation = $this->isLocalisation($val,true);
		if(!$idLocalisation){
			$this->addLocalisation($val);
			$idLocalisation = $this->isLocalisation($val,true);	
		}
		$idLocalisation = $idLocalisation[0][1];
		//
		*/
		$val = $this->Exemplar[$num]["invent"];
		if($this->isCodbar($val)){
			$time = microtime();
			$timearr = explode(' ',$time);
			$time = $timearr[1].substr($timearr[0],2,6);
			$invent = $this->Exemplar[$num]["invent"]."_$time";
		}else{
			$invent = $this->Exemplar[$num]["invent"];
		}
		
		$idsupport = $this->type;
		
		// полочный индекс
		$index = trim($this->Exemplar[$num]['index'].' '.$this->Exemplar[$num]['autsign']);
		//
		$req = "INSERT INTO $table ($idname,Codbare,IdNotice,inventaire,IdBibliotheque,IdAnnexe,idSupport,IdType,idLocalisation,
									IdStatut,IdOrigine,idFournisseur,idFonds,Idsection,cote) 
							VALUES ($id,N'".addslashes($invent)."',$idnotice,N'".addslashes($invent)."',1,$idannexe,$idsupport,$idsupport,$idLocalisation,
									4,1,0,$idsection,$idsection,N'".addslashes($index)."')";
		$test = $this->executeDB($req);
		
		//!!изменение последнего ID в Compteur!!!
		$this->UpdateCompteur(++$id,$idname);
	}
	
	/**----------------------------------------------------
	insert functions (must be privat) use in ADD functions
	------------------------------------------------------*/	
	function InsertAuterName($str){
		// take string and return array [0]-autor second name,[1]-autor name
		$pos = strpos($str,' ');
		$name = $str;
		$sname = '';
		
		if($pos){
			$name = substr($str,0,$pos);
			if(substr($name,-1) == ','){
				$name = substr($name,0,-1);
			}
			$sname = substr($str,$pos+1);
		}
		$res[]=$name;// фамилия
		$res[]=$sname;// имя
		
		return $res;
	}
	
	function InsertNoticeTitre($str){
		// return string where any word into "|"
		$str = trim($str);
		$str = str_replace(' ','| |',$str);
		$str = '|'.$str.'|';
		
		return $str;
	}
	
	function InsertNoticeZ($NotVal){
		
		$table 	= 'NOTICE_Z';
		$idname = 'IDNOTICEZ';
		
		// add "_imp" to the end of book index (fild "001")
 		if($this->Notice['001']['a']){
			for($i=0;$i<count($this->Notice['001']['a']);$i++){
				$this->Notice['001']['a'][$i] .="_imp";
			}
		}else{
			$val = date("d.m.Y").$this->noticeInd."_imp";
			$this->Notice['001']['a'][] = $val;
		}
		
		foreach ($this->Notice as $fild=>$array){
			foreach ($array as $subfild=>$value){
				foreach($value as $NumOrder=>$val){
					// найти Valeurn
					// if 5-th parametr in findValeurn() == true
					//   will be added autors,editors etc. if not exist
					$Valeutn = $this->findValeurn($fild,$subfild,$val,$NumOrder,true);
						
					if($fild == '009'){
						$Valeutn = $val;
						$val = '';
					}
					
					// занести значения
					$id = $this->enreg->sequence($table,$idname);
					$req = "INSERT INTO $table 
							($idname,IdNotice,IdZone,sZone,NumOrdre,Valeur,Valeurn) VALUES 
					 		($id,$NotVal,'$fild','$subfild',$NumOrder,N'".addslashes($val)."',$Valeutn)";
					$this->executeDB($req);
					
					//!!изменение последнего ID в Compteur!!!
					$this->UpdateCompteur(++$id,$idname);
				}
			}
		}
	}
	
	function findValeurn($fild,$subfild,$value,$NumOrder,$update = false){
		
		switch($fild){
			case "101":
				// поиск по языку
				if($subfild=="a"){
					$value = substr($value,0,3);
					$Valeutn = $this->isLanguage($value,true);
				}
				break;
				
			case "200":
				// поиск по авторам
				if($subfild=="g" || $subfild=="f"){
					$Valeutn = $this->isAuter($value,true);
					
					if(!$Valeutn && $update){
						$this->addAuter($value);
						$Valeutn = $this->isAuter($value,true);
					}
					
				}
				// поиск по ответственности авторов
				if($subfild=="8" || $subfild=="6"){
					$Valeutn = $this->isAuterResp($value,true);
					
					if(!$Valeutn && $update){
						$this->addAuterResp($value);
						$Valeutn = $this->isAuterResp($value,true);
					}
				}
				break;
				
			case "210":
				// поиск по издателю
				if($subfild=="c"){
					$Valeutn = $this->isEditor($value,true);
					
					if(!$Valeutn && $update){
						
						$place = '';
						$addr  = '';
						if($this->Notice['210']['b'][$NumOrder]){
							$addr = $this->Notice['210']['b'][$NumOrder];
						}
						if($this->Notice['210']['a'][$NumOrder]){
							$place = $this->Notice['210']['a'][$NumOrder];
						}
						
						$this->addEditor($value,$addr,$place);
						$Valeutn = $this->isAuterResp($value,true);
					}
				}
				// поиск по месту издаиня
				if($subfild=="a"){
					
					$Valeutn = $this->isPlace($value,true);
					
					if(!$Valeutn && $update){
						$this->addPlace($value);
						$Valeutn = $this->isPlace($value,true);
					}
				}
				
				break;
				
			case "225":
				// поиск по серии
				if($subfild=="a"){
					$Valeutn = $this->isCollection($value,true);
					
					if(!$Valeutn && $update){
						
						$this->addCollection($value,$NumOrder);
						$Valeutn = $this->isCollection($value,true);
						
					}
				}
				if($subfild=="i"){
					$Valeutn = $this->isSousCollection($value,true);
					
					if(!$Valeutn && $update){
						
						$this->addSousCollection($value,$NumOrder);
						$Valeutn = $this->isSousCollection($value,true);
						
					}
				}
				break;
				
			case"676":
				// поиск по УДК
				if($subfild=="a"){
					$Valeutn = $this->isUDC($value,true);
					
					if(!$Valeutn && $update){
						
						$this->addUDC($value);
						$Valeutn = $this->isUDC($value,true);
						
					}
				}
				break;
			case "R600":
				// поиск по рубрике 
				if($subfild=="a"){
					$Valeutn = $this->isMatiere($value,true);
					
					if(!$Valeutn && $update){
						
						$this->addMatiere($value);
						$Valeutn = $this->isMatiere($value,true);
						
					}
				}
				break;
		}
		if(!$Valeutn){
			$Valeutn[0][1] = 0;
		}
		return $Valeutn[0][1];
	}
	
	function SetCateg($dt,$bl){
		
		switch($dt){
			case"a":
			case"b":
				//текстовые материалы
				switch($bl){
					case"m":
						$this->categ = 1;// книга
						$this->type  = 2;
						break;
					case"c":
						$this->categ = 2;// смешанный комплект
						break;
					case"s":
						$this->categ = 4;// сериальное издание
						$this->type  = 1;
						break;
					case"a":
						$this->categ = 6;// статья
						break;
				}
				break;
			case"c":
			case"d":
				// музыкальные партитуры
				$this->categ = 12;
				$this->type  = 14;
				break;
			case"e":
			case"f":
				// картографические материалы
				$this->categ = 14;
				break;
			case"g":
				// видеоматериалы
				$this->categ = 18;
				break;
			case"i":
			case"j":
				// звукозаписи
				$this->categ = 26;
				break;
			case"k":
				// двухмерная графика
				break;
			case"l":
				// электронный ресурс
				$this->categ = 30;
				break;
			case"r":
				// трехмерные искусственные и естественные объекты
				$this->categ = 32;
				break;
			default:
				$this->categ = 1;
				$this->type  = 2;
				break;
			
		}
	}
	
	function UpdateCompteur($val,$idname){
		
		$req = "UPDATE COMPTEUR SET ValCompteur = $val WHERE IdCompteur = '$idname'";
		$res = $this->executeDB($req);
		return $res;
	}
	
	/**
	 * Удаляет последний символ из строки
	 * если он не буква или цифра
	 * @access public
	 * @param str $str
	 * @return str без спецсимволлов на конце
	 */
	function deleteLastSymb($str){
		// конечные символы не буквы(в том числе и русские)
		// и не символы '?', '!', ')' ''', '"', '...'
		$pattern = "[^((а-яА-Я?!\)\'\")|[:alnum:]|(...))]+$";
		return  ereg_replace($pattern,'',$str);
	}
	
	function changeCodepageToUtf(){
		if(!$this->encode[0]){
			return;
		}else{
			switch($this->encode[0]){
				case 'DOS':
					$in_charset = "cp866";
					break;
				case 'WIN':
					$in_charset = "Windows-1251";
					break;
				case 'KOI':
					$in_charset = "KOI8-U";
					break;
				default:
					return;
			}
		}
		
		foreach($this->Notice as $field=>$arField){
			if($field != '101'){
				foreach ($arField as $subfield=>$arSubfield){
					foreach($arSubfield as $nom=>$val){
						$this->Notice[$field][$subfield][$nom] = iconv($in_charset,"UTF-8",$val);
					}
				}
				
			}
		}
		
	}
}

if ( ! defined( 'ISO2709' ) ) {
  define( 'ISO2709', 1 );

define('AUTO_UPDATE', 1);
define('USER_UPDATE', 0);

class iso2709_record {
// ---------------------------------------------------
//		déclaration des propriétés
// ---------------------------------------------------
	// enregistrement UNIMARC complet

	var $full_record;

	// parties de l'enregistrement UNIMARC

	var $guide = '';
	var $directory = '';
	var $data = '';

	// propriétés 'publiques'

	var $errors;

	var $auto_update; // mode de mise à jour;

	// variables 'internes' de la classe
	var $inner_guide;
	var $inner_directory;
	var $inner_data;

	// caractères spéciaux
	var $record_end;
	var $rgx_record_end;
	var $field_end;
	var $rgx_field_end;
	var $subfield_begin;
	var $rgx_subfield_begin;
	var $NSB_begin;
	var $rgx_NSB_begin;
	var $NSB_end;
	var $rgx_NSB_end;

	function iso2709_record($string='', $update=AUTO_UPDATE) {

		// initialisation des caractères spéciaux

		$this->record_end = chr(0x1d);		// fin de notice (IS3 de l'ISO 6630)
		$this->rgx_record_end = "\x1D";
		$this->field_end = chr(0x1e);	// fin de champ (IS2 de l'ISO 6630)
		$this->rgx_field_end ="\x1E";
		$this->subfield_begin = chr(0x1f);	// début de sous-champ (IS1 de l'ISO 6630)
		$this->rgx_subfield_begin = "\x1F";
		$this->NSB_begin = chr(0xC2).chr(0x88);		// début de NSB
		$this->rgx_NSB_begin = "\xC2\x88";
		$this->NSB_end = chr(0xC2).chr(0x89);			// fin de NSB (NSE)
		$this->rgx_NSB_end = "\xC2\x89";

		// initialisation du mode d'update
		$this->auto_update = $update;

		# TRUE : l'update est géré par la classe
		# FALSE : c'est au script appelant de gérer l'update;

		// initialisation du tableau des erreurs

		$this->errors = array();

		// initialisation de la classe

		// récupération de l'enregistrement intégral 

		$this->full_record = $string;

		// mise à jour des variables internes

		// guide de l'enregistrement

		$this->guide = substr($this->full_record, 0, 24);

		// guide interne : valeurs par défaut si création

		$rl = intval(substr($this->guide, 0 , 5));	# record length : pos.1-4
		$rs = substr($this->guide, 5, 1);			# record status : pos.5
		$dt = substr($this->guide, 6, 1);			# document type : pos.6	
		$bl = substr($this->guide, 7, 1);			# bibliographic level : pos.7
		$hl = intval(substr($this->guide, 8, 1));	# hierarchical level : pos.8
		$pos9 = substr($this->guide, 9, 1);			# pos.9 undefined, contains a blank
		$il = intval(substr($this->guide, 10, 1));	# indicator length : pos.10 (2)
		$sl = intval(substr($this->guide, 11, 1));	# subfield identifier length : pos.11 (2)	
		$ba = intval(substr($this->guide, 12, 5));	# base adress : pos.12-16	
		$el = substr($this->guide, 17, 1);			# encoding level : pos.17
		$ru = substr($this->guide, 18, 1);			# record update : pos.18
		$pos19 = substr($this->guide, 19, 1);		# pos.19 : undefined, contains a blank
		$dm1 = intval(substr($this->guide, 20, 1));	# Length of 'Length of field' (pos.20, 4 in UNIMARC) 
		$dm2 = intval(substr($this->guide, 21, 1));	# Length of 'Starting character position' (pos.21, 5 in UNIMARC)
		$dm3 = intval(substr($this->guide, 22, 1));	# Length of implementationdefined portion (pos.22, 0 in UNIMARC)
		$pos23 = substr($this->guide, 23, 1);		# POS.23 : undefined, contains a blank

		$this->inner_guide = array(
			'rl' =>  $rl ? $rl : 0,
			'rs' =>  $rs ? $rs : 'n',
			'dt' => $dt ? $dt : 'a',
			'bl' => $bl ? $bl : 'm',
			'hl' => $hl ? $hl : 0,
			'pos9' => $pos9 ? $pos9 : ' ',
			'il' => $il ? $il : 2,
			'sl' => $sl ? $sl : 2,
			'ba' => $ba ? $ba : 24, 
			'el' => $el ? $el : '1',
			'ru' => $ru ? $ru : 'i',
			'pos19' => $pos19 ? $pos19 : ' ',
			'dm1' => $dm1 ? $dm1 : 4,
			'dm2' => $dm2 ? $dm2 : 5,
			'dm3' =>  $dm3 ? $dm3 : 0,
			'pos23' => $pos23 ? $pos23 : ' '
		);

	// récupération du répertoire

	$m = 3 + $this->inner_guide['dm1'] + $this->inner_guide['dm2'];

	$this->directory = substr(	$this->full_record, 
								24, 
								$this->inner_guide['ba'] - 25);

	$tmp_dir = explode('|', chunk_split($this->directory, $m, '|'));
	for($i = 0; $i < count($tmp_dir); $i++) {
		if($tmp_dir[$i]) {
			$this->inner_directory[$i] = array(
			'label' => substr($tmp_dir[$i], 0, 3),
			'length' => intval(	substr($tmp_dir[$i],
								3,
								$this->inner_guide['dm1'])),
			'adress' => intval(	substr($tmp_dir[$i],
									3 + $this->inner_guide['dm1'],
									$this->inner_guide['dm2']))
			);
		}
	}

	// récupération des champs

	$m = substr(	$this->full_record,
					$this->inner_guide['ba'],
					strlen($this->full_record) - $this->inner_guide['ba']
				);
	// Add by Alex
	/*$len_mb_str=mb_strlen(mb_substr($this->full_record,$this->inner_guide['ba'],$this->inner_guide['rl']-$this->inner_guide['ba']));		
	$len_str=strlen(substr($this->full_record,$this->inner_guide['ba'],$this->inner_guide['rl']-$this->inner_guide['ba']));		
	
	//if(($this->inner_guide['rl']-$this->inner_guide['ba']) == $len_mb_str){
		$mb_str=true;
	//}elseif(($this->inner_guide['rl']-$this->inner_guide['ba']) == $len_str){
	//	$mb_str=false;
	//}*/
	
	$len_mb_str	=mb_strlen(mb_substr($this->full_record,$this->inner_guide['ba'],$this->inner_guide['rl']-$this->inner_guide['ba']))+1;
	$len_str	=strlen(substr($this->full_record,$this->inner_guide['ba'],$this->inner_guide['rl']-$this->inner_guide['ba']))+1;

	if(($this->inner_guide['rl']-$this->inner_guide['ba']) == $len_mb_str){
		$mb_str=true;
	}elseif(($this->inner_guide['rl']-$this->inner_guide['ba']) == $len_str){
		$mb_str=false;
	}else{
		$mb_str=false;
	}
	
	// End of Add
	if($m) {
		while(list($cle, $valeur)=each($this->inner_directory)) {
			// Fix by Alex
			if($mb_str){
				$this->inner_data[$cle] = 
						array('label' => $this->inner_directory[$cle]['label'],
							  'content' => mb_substr($this->full_record, 
											$this->inner_guide['ba'] + $valeur['adress'], 
											$valeur['length'])
								);
			}else{
				$this->inner_data[$cle] = array(
										'label' => $this->inner_directory[$cle]['label'],
										'content' => substr(	$this->full_record, 
												$this->inner_guide['ba'] + $valeur['adress'], 
												$valeur['length']
											)
										);
			}
			
		}
			//End of Fix
	} else {
		$this->inner_data = array();
		$this->inner_directory = array();
	}

	}


	function get_subfield() {

		$result = array();

		// vérification des paramètres
		if(!func_num_args()) {
			return $result;
		}

		for($i = 0; $i < sizeof($this->inner_data); $i++) {
			if(preg_match('/'.func_get_arg(0).'/', $this->inner_data[$i]['label'])) {
				switch(func_num_args()) {
					case 1:		// pas d'indication de sous-champ : on retourne le contenu entier
						$result[] = preg_replace("/$this->rgx_field_end/",
													'',
													$this->inner_data[$i]['content']);
						break;
					case 2 :	// un seul sous-champ demandé
						// récupération de la valeur du champ
						$field = $this->inner_data[$i]['content'];

						// le masque de recherche : subfield_begin cars. subfield_begin ou field_end

						$mask = $this->rgx_subfield_begin.func_get_arg(1);
						$mask .= '(.*)['.$this->rgx_subfield_begin.'|'.$this->rgx_field_end.']';

						//while (preg_match("/$mask/sU", $field)) {
						//	preg_match("/$mask/sU", $field, $regs);
						//	$result[] = $this->ISO_decode($regs[1]);
						//	$field = preg_replace("/$mask/sU", '', $field);
						while (preg_match("/$mask/s", $field)) {
							preg_match("/$mask/s", $field, $regs);
							$result[] = $this->ISO_decode($regs[1]);
							$field = preg_replace("/$mask/s", '', $field);
						}
						break;
					default:	// un ou plusieurs sous-champs
						// récupération de la valeur du champ
						$field = $this->inner_data[$i]['content'];
				
						for($j = 1; $j < func_num_args(); $j++) {
							$subfield = func_get_arg($j);
							$mask = $this->rgx_subfield_begin.$subfield;
							$mask .= '(.*)['.$this->rgx_subfield_begin.'|'.$this->rgx_field_end.']';

							preg_match("/$mask/sU", $field, $regs);
							if(isset($regs[1])) 
								$tmp[$subfield] = $this->ISO_decode($regs[1]); 
						}
						$result[] = $tmp;
						break;
				}
			}
		}
		return $result;
	}

// ---------------------------------------------------
// 		ajout d'un champ
// ---------------------------------------------------

	function add_field($label='000', $ind='') {

		// vérification des paramètres : au moins 2

		if(func_num_args() < 3) {
			$this->errors[] = '[add_field] impossible d\'ajouter un champ vide';
			return FALSE;
		}

		if($label < 1) {
			$this->errors[] = '[add_field] le label \''.$label. '\' n\'est pas valide';
			return FALSE;
		}

		// test des indicateurs
		if(strlen($ind) != 0 && strlen($ind) != $this->inner_guide['il']) {
			$this->errors[] = '[add_field] l\'indicateur \''.$ind. '\' n\'est pas valide';
			return FALSE;
		}

		// mise en form du label
		if(strlen($label) < 3 && $label < 100)
			$label = sprintf('%03d', $label);

		// notre champ doit commencer par un label

		if (!preg_match('/^[0-9]{3}$/', $label)) {
			$this->last_error = '[add_field] le label \''.$label. '\' n\'est pas valide';
			return FALSE;
		}

		$nb_args = func_num_args();

		// suivant le cas, ajout des infos
		switch($nb_args) {
			case 3: // il n'y a qu'un seul param en plus du label et des indicateurs
				if(!is_array(func_get_arg(2)))
					$content = func_get_arg(2);
				else {
					// le param est un tableau
					$field = func_get_arg(2);
					for($i=0;$i < sizeof($field); $i++) {
						if(preg_match('/^[a-z0-9]$/', $field[$i][0]) && $field[$i][1]) {
							$content .= $this->subfield_begin.$field[$i][0].$field[$i][1];
						}
					}
				}
				break;
			default: // plus d'un champ
				// on s'assure que le nombre de param est pair
				if(floor($nb_args/2) < $nb_args/2)
					$nb_args = $nb_args - 1;
				// récupérer les paires champ/valeur
				$i = 2;
				while( $i < $nb_args - 1) {
					$field = func_get_arg($i);
					$fieldbis = func_get_arg($i + 1);
					if(preg_match('/^[a-z0-9]$/', $field))
						$content .= $this->subfield_begin.$field.$fieldbis;
					else
						$this->errors[] = '[add_field] étiquette de sous-champ non valide';
					$i = $i + 2;
				}
				break;
		}



		if(sizeof($content)) {
			$content = $this->ISO_encode($content).$this->field_end; 

			// ajout des éventuels indicateurs

			if(strlen($ind) == $this->inner_guide['il'])
				$content = $ind.$content;

			// mise à jour des inner_data
			$index = sizeof($this->inner_data);
			$this->inner_data[$index]['label'] = $label;
			$this->inner_data[$index]['content'] = $content;		

			// tri des inner_data

			sort($this->inner_data);
		}

		if($this->auto_update) $this->update();

		return TRUE;
	}

// ---------------------------------------------------
// 		suppression d'un champ
// ---------------------------------------------------

	function delete_field($label, $index=-1) {

		if(!func_num_args()) {
			$this->errors[] = '[delete_field] pas de label pour le champ';
			return FALSE;
		}

		if(!$label) {
			$this->errors[] = '[delete_field] le label \''.$label. '\' n\'est pas valide';
			return FALSE;
		}

		// mise en form du label
		if(strlen($label) < 3 && $label < 100)
			$label = sprintf('%03d', $label);

		// vérification du format du label

		if (!preg_match('/^[0-9\.]{3}$/', $label)) {
			$this->last_error = '[delete_field] le label \''.$label. '\' n\'est pas valide';
			return FALSE;
		}

		for($i=0; $i < sizeof($this->inner_data); $i++) {
			if(preg_match('/'.$label.'/', $this->inner_data[$i]['label'])) {
				$this->inner_data[$i]['label'] ='';		
				$this->inner_data[$i]['content'] ='';
			}	
		}		


		if($this->auto_update) $this->update();		
			return TRUE;
	}

// ---------------------------------------------------
// 		update de l'enregistrement
// ---------------------------------------------------

	function update() {

		// supprime les lignes vides d'inner_data

		for($i=0; $i < sizeof($this->inner_data); $i++) 
			if(empty($this->inner_data[$i]['label']) || empty($this->inner_data[$i]['content'])) {
				array_splice($this->inner_data, $i, 1);
				$i--; 
			}

		// reconstitution inner_directory

		$this->inner_directory = array();
		for($i = 0; $i < sizeof($this->inner_data); $i++){
			$this->inner_directory[$i] = array(
				'label' => $this->inner_data[$i]['label'],
				'length' => strlen($this->inner_data[$i]['content']),
				'adress' => 0
			);
		} 

		// mise à jour des offset et du répertoire 'réel'

		for($i = 1; $i < sizeof($this->inner_data); $i++){
			$this->inner_directory[$i]['adress'] = 
				$this->inner_directory[$i - 1]['length']
				+ $this->inner_directory[$i - 1]['adress'];
		}

		// mise à jour du répertoire

		$this->directory = ''; 
		for($i=0; $i < sizeof($this->inner_directory) ; $i++) {
			$this->directory .= sprintf('%03d', $this->inner_directory[$i]['label']);
			$this->directory .= sprintf('%0'.$this->inner_guide['dm1'].'d', $this->inner_directory[$i]['length']);
			$this->directory .= sprintf('%0'.$this->inner_guide['dm2'].'d', $this->inner_directory[$i]['adress']);
		} 

		// mise à jour du contenu

		$this->data = '';
		for($i=0; $i < sizeof($this->inner_data) ; $i++) {
			$this->data .= $this->inner_data[$i]['content'];
		}
		$this->data .= $this->record_end;

		// mise à jour du guide
		## adresse de base.
		$this->inner_guide['ba'] = 24 + strlen($this->directory) + 1;
		## longueur de l'enregistrement iso2709
		$this->inner_guide['rl'] = 24 + strlen($this->directory) + strlen($this->data);


		$this->guide = sprintf('%05d', $this->inner_guide['rl']);
		$this->guide .= $this->inner_guide['rs'];
		$this->guide .= $this->inner_guide['dt'];
		$this->guide .= $this->inner_guide['bl'];
		$this->guide .= $this->inner_guide['hl'];
		$this->guide .= $this->inner_guide['pos9'];
		$this->guide .= $this->inner_guide['il'];
		$this->guide .= $this->inner_guide['sl'];
		$this->guide .= sprintf('%05d', $this->inner_guide['ba']);
		$this->guide .= $this->inner_guide['el'];
		$this->guide .= $this->inner_guide['ru'];
		$this->guide .= $this->inner_guide['pos19'];
		$this->guide .= $this->inner_guide['dm1'];
		$this->guide .= $this->inner_guide['dm2'];
		$this->guide .= $this->inner_guide['dm3'];
		$this->guide .= $this->inner_guide['pos23'];

		// constitution du nouvel enregistrement

		$this->full_record = $this->guide.$this->directory.$this->data;

	}

// ---------------------------------------------------
// 		affichage d'un rapport des erreurs
// ---------------------------------------------------

	function show_errors() {
		if(sizeof($this->errors)) {
			print '<table border=\'1\'>';
			print '<tr><th colspan=\'2\'>iso2709_record : erreurs</th></tr>';
			for($i=0; $i < sizeof($this->errors); $i++) {
				print '<tr><td>';
				print $i+1;
				print '</td><td>'.$this->errors[$i].'</td></tr>';
			}
			print '</table>';
		} else {
			print 'aucune erreur<br>';
		}
	}

// ---------------------------------------------------
// 		fonction de validation d'un enregistrement
// ---------------------------------------------------

	function valid() {

		// $this->errors = array(); // init du tableau des erreurs

		// test de la longueur de l'enregistrement

		if ( 	strlen($this->full_record) != $this->inner_guide['rl']
			|| 	substr($this->full_record, -1, 1) != $this->record_end)
			$this->errors[] = '[format] la longueur de l\'enregistrement ne correspond pas au guide';

		// test des fin de champs
		// on retourne false si un champ ne finit pas par l'IS3

		while(list($cle, $valeur) = each($this->inner_data)) {
			if(!preg_match("/$this->rgx_field_end$/", $valeur['content']))
				$this->errors[] = '[format] le champ '.$cle.' ne finit pas par le caractère de fin de champ';
		}

		// les tableaux internes sont vides
		if(!sizeof($this->inner_data) || !sizeof($this->inner_data))
			$this->errors[] = '[internal] cet enregistrement est vide';

		// les inner_data et le inner_directory ne sont pas synchronisés

		if(sizeof($this->inner_data) != sizeof($this->inner_directory))
			$this->errors[] = '[internal] les tableaux internes ne sont pas synchronisés';

		//if(sizeof($this->errors) != 0)
		//	return FALSE;
		//return sizeof($this->errrors);
		return TRUE;

	}

// ---------------------------------------------------
//		fonctions de mise à jour du guide
// ---------------------------------------------------

	function set_rs($status) {
		if($status) {
			$this->inner_guide['rs'] = $status[0];
			if($this->auto_update) $this->update();
		}			
	}

	function set_dt($dtype) {
		if($dtype){
			$this->inner_guide['dt'] = $dtype[0];
			if($this->auto_update) $this->update();
		}			
	}

	function set_bl($bltype) {
		if($bltype){
			$this->inner_guide['bl'] = $dtype[0];
			if($this->auto_update) $this->update();
		}			
	}

	function set_hl($hltype) {
		if($hltype){
			$this->inner_guide['hl'] = $hltype[0];
			if($this->auto_update) $this->update();
		}			
	}

	function set_el($eltype) {
		if($eltype){
			$this->inner_guide['el'] = $eltype[0];
			if($this->auto_update) $this->update();
		}			
	}

	function set_ru($rutype) {
		if($rutype){
			$this->inner_guide['ru'] = $rutype[0];
			if($this->auto_update) $this->update();
		}			
	}


// ---------------------------------------------------
//		fonctions de conversion ISO (caractères)
// ---------------------------------------------------

# ISO_decode converti de l'ISO 5426

	function ISO_decode($chaine)
	{
		$result = '';
		$chaine = preg_replace('/'.$this->rgx_NSB_begin.'/', '', $chaine);
		$chaine = preg_replace('/'.$this->rgx_NSB_end.'/', '', $chaine);
		if(!preg_match("/[\xC1-\xFF]./misU", $chaine))
			return $chaine;
		else {
			for($i = 0 ; $i < strlen($chaine) ; $i++) {
				if(ord($chaine[$i]) >= 0xC1) {
					//$result .=  $this->isodecode(ord($chaine[$i]), ord($chaine[$i+1]));
					$result .=  $chaine[$i];
					//$i++;
				}
				else
					$result .= $chaine[$i];
			}
		}
	return $result;
	}

	function ISO_encode($chaine) {
		if(!$chaine)
			return $chaine;

		$char_table['À'] = chr(0xc1).chr(0x41);
		$char_table['Á'] = chr(0xc2).chr(0x41);
		$char_table['Â'] = chr(0xc3).chr(0x41);
		$char_table['Ã'] = chr(0xc4).chr(0x41);
		$char_table['Ä'] = chr(0xc9).chr(0x41);
		$char_table['Å'] = chr(0xca).chr(0x41);
		$char_table['Å'] = chr(0xca).chr(0x41);
		$char_table['Ç'] = chr(0xd0).chr(0x43); 

		$char_table['È'] = chr(0xc1).chr(0x45);
		$char_table['É'] = chr(0xc2).chr(0x45);
		$char_table['Ê'] = chr(0xc3).chr(0x45);
		$char_table['Ë'] = chr(0xc8).chr(0x45);
		$char_table['Ì'] = chr(0xc1).chr(0x49);
		$char_table['Í'] = chr(0xc2).chr(0x49);
		$char_table['Î'] = chr(0xc3).chr(0x49);
		$char_table['Ï'] = chr(0xc8).chr(0x49);
		$char_table['Ñ'] = chr(0xc4).chr(0x4e);
		$char_table['Ò'] = chr(0xc1).chr(0x4f);
		$char_table['Ó'] = chr(0xc2).chr(0x4f);
		$char_table['Ô'] = chr(0xc3).chr(0x4f);
		$char_table['Õ'] = chr(0xc4).chr(0x4f);
		$char_table['Ö'] = chr(0xc9).chr(0x4f);
		$char_table['Ù'] = chr(0xc1).chr(0x55);
		$char_table['Ú'] = chr(0xc2).chr(0x55);
		$char_table['Û'] = chr(0xc3).chr(0x55);
		$char_table['Ý'] = chr(0xc2).chr(0x59);
		$char_table['à'] = chr(0xc1).chr(0x61);
		$char_table['á'] = chr(0xc2).chr(0x61);
		$char_table['â'] = chr(0xc3).chr(0x61);
		$char_table['ã'] = chr(0xc4).chr(0x61);
		$char_table['ä'] = chr(0xc9).chr(0x61);
		$char_table['å'] = chr(0xca).chr(0x61);
		$char_table['ç'] = chr(0xd0).chr(0x63);
		$char_table['è'] = chr(0xc1).chr(0x65);
		$char_table['é'] = chr(0xc2).chr(0x65);
		$char_table['ê'] = chr(0xc3).chr(0x65);
		$char_table['ë'] = chr(0xc8).chr(0x65);
		$char_table['ñ'] = chr(0xc4).chr(0x6e);
		$char_table['ì'] = chr(0xc1).chr(0x69);
		$char_table['í'] = chr(0xc2).chr(0x69);
		$char_table['î'] = chr(0xc3).chr(0x69);
		$char_table['ï'] = chr(0xc8).chr(0x69);
		$char_table['ò'] = chr(0xc1).chr(0x6f);
		$char_table['ó'] = chr(0xc2).chr(0x6f);
		$char_table['ô'] = chr(0xc3).chr(0x6f);
		$char_table['õ'] = chr(0xc4).chr(0x6f);
		$char_table['ö'] = chr(0xc9).chr(0x6f);
		$char_table['ù'] = chr(0xc1).chr(0x75);
		$char_table['ú'] = chr(0xc2).chr(0x75);
		$char_table['û'] = chr(0xc3).chr(0x75);
		$char_table['ü'] = chr(0xc9).chr(0x75);
		$char_table['ý'] = chr(0xc2).chr(0x79);
		$char_table['ÿ'] = chr(0xc8).chr(0x79);
		$char_table['Æ'] = chr(0xe1);
//		$char_table['Ð'] = chr(0xe2); # me demandez pas pourquoi j'ai commenté ça. c'est comme ça, c'est tout.
		$char_table['Ø'] = chr(0xe9);
		$char_table['þ'] = chr(0xec);
		$char_table['æ'] = chr(0xf1);
		$char_table['ð'] = chr(0xf3);
		$char_table['ø'] = chr(0xf9);
		$char_table['ß'] = chr(0xfb);

 		while(list($char, $value) = each($char_table))
			$chaine = preg_replace("/$char/", $value, $chaine);

		return $chaine;

	}

	function isodecode($char1, $char2)
	{
		$result = $char1;

		return $result;
	}
}
}
?>