<?php
require_once(KT_LIB_DIR . '/dispatcher.inc.php');

/**
 * Dispatches the the configuration page
 */
class LMImportFieldsAdminDispatcher extends KTAdminDispatcher {

	var $aFields = array(
	array('id', 'id', ''),
	array('Заглавие', 'u200_a', ''), /// : u200_e = u200_d
	array('Авторы', 'u200_f', ''),   /// u200_f , u200_g
	array('УДК', 'u675_a', ''),
	array('Год издания', 'u210_d', ''),
	array('Издательство', 'u210_c', ''),
	array('Количество страниц', 'u215_a', ''),
	// array('Тип издания', '???', ''),
	);
	
	var $default = array('ils_server_url'=>'http://localhost',
		'export_script_url'=>'index.php?url=/integration_server/books/get/#ILS_ID#',
		'export_sctipt_format'=>'json/rusmarc',
		'export_sctipt_encoding'=>'auto',
		'rename_after_import' => 1);
		
	var $settings_key = 'import-fields-plugin-settings';

	/**
	 * Show the configuration page
	 *
	 * @return the template data
	 */
	function do_main(){
		$oTemplate =& $this->oValidator->validateTemplate('importFieldsAdmin');
		//set breadcrumbs
		$this->oPage->setBreadcrumbDetails(_kt('Настройки импорта'));

		if($_POST['saveSettings']){ //form submitted
			$this->form_submit();
		}

		$oJSON = new Services_JSON();

		$aFormatOptions = array('json/rusmarc','binary/rusmarc', 'json/marc21', 'binary/marc21');
		$aEncodingOptions = array('auto', 'UTF-8', 'cp1251');
		$default = $this->default;
		$o = $oJSON->decode(KTUtil::getSystemSetting($this->settings_key));
		$settings = (array)$o;
		
		if(!is_array($settings)) { $settings = array(); };
		$settings = array_merge($default, $settings);

		$name = 'ils_server_url';
		$add_fields[] = new KTStringWidget(_kt('URL сервера АИБС'), _kt('URL по которому доступен сервер АИБС'), $name, $settings[$name], $this->oPage, true, null, null, array('width'=>'50'));
		$name = 'export_script_url';
		$add_fields[] = new KTStringWidget(_kt('URL скрипта экспорта описаний из АИБС'), _kt('URL по которому доступен скрипт экспорта из АИБС.'), $name, $settings[$name], $this->oPage, true, null, null, array('width'=>'70'));
		$name = 'export_sctipt_format';
		$add_fields[] = new KTLookupValuesAsKeyWidget(_kt('Формат ответа АИБС'), '', $name, $settings[$name], $this->oPage, true, null, null, array('width'=>'70', 'vocab'=>$aFormatOptions, 'values_as_keys'=>true));
		$name = 'export_sctipt_encoding';
		$add_fields[] = new KTLookupValuesAsKeyWidget(_kt('Кодировка ответа АИБС'), '', $name, $settings[$name], $this->oPage, true, null, null, array('width'=>'70', 'vocab'=>$aEncodingOptions, 'values_as_keys'=>true));
		//$aTemplateData = $settings;
		$aTemplateData['i18n_domain'] = 'plugins';
		$aTemplateData['aFormatOptions'] = $aFormatOptions;
		$aTemplateData['add_fields'] = $add_fields;
		return $oTemplate->render($aTemplateData);
	}

	/**
	 * Handle the form submit, and update settings
	 *
	 */
	function form_submit(){
		$oJSON = new Services_JSON();
		if (!is_array($_POST)) { $_POST = array(); };
		$settings = array_merge($this->default, $_POST);
		$state = $oJSON->encode($settings);
		KTUtil::setSystemSetting($this->settings_key,$state);
		$this->addInfoMessage(_kt("Settings saved"));
	}

	function do_createFields() {
		$aFields = $this->aFields;

		$oFieldSet = KTFieldset::getByNamespace('lm.fieldsets.absotheque');

		if (get_class($oFieldSet) == 'KTFieldset') {
			$this->errorRedirectToMain(_kt('Поля уже созданы!'));
		}

		if (is_a($oFieldSet, 'ktentitynoobjects')) {
			$oFieldset = KTFieldset::createFromArray(array(
			"name" => 'Поля биб. описания',
			"description" => '',
			"namespace" => 'lm.fieldsets.absotheque',
			"mandatory" => false,       // FIXME deprecated
			"isConditional" => false,   // handle this
			"isGeneric" => true,
			"isComplete" => false,
			"isComplex" => false,
			"isSystem" => false,
			));
		}

		if (Pear::isError($oFieldSet)) {
			/* @var $oFieldSet PEAR_Error  */
			$this->errorRedirectToMain(sprintf(_kt("Failed to create fieldset: %s"), $oFieldSet->getMessage()));
		}

		$oFieldSet = KTFieldset::getByNamespace('lm.fieldsets.absotheque');
		$iFieldSetId = KTUtil::GetId($oFieldSet);

		foreach ($aFields as $aField) {
			$sField = $aField[0];
			$oField = DocumentField::getByFieldsetAndName($oFieldSet, $sField);

			if (is_a($oField, 'ktentitynoobjects')) {
				$oField = new DocumentField($sField, 'STRING', '0', '0', '0', '0');
				//return '<pre>'.print_r($oField, true).'</pre>';
				/* @var $oField DocumentField */
				$oField -> setParentFieldsetId($iFieldSetId);
				$oField -> setDescription($aField[1]);
				if (!($oField -> create())) {
					$this->errorRedirectToMain($_SESSION['errorMessage']);
				};
				//$oField = DocumentField::getByFieldsetAndName($oFieldSet, 'test');

			}
		}

		$this->successRedirectToMain(_kt('Поля были успешно созданы.'));
	}

}

?>