<?php

/**
 * $Id$
 *
 * Copyright (c) 2006 Jam Warehouse http://www.jamwarehouse.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; using version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 *
 * You can contact the copyright owner regarding licensing via the contact
 * details that can be found on the KnowledgeTree web site:
 *
 *         http://www.ktdms.com/
 **/
 
require_once(KT_LIB_DIR . '/browse/browseutil.inc.php');
require_once(KT_DIR. '/plugins/quicklinks/Quicklink.inc.php');
require_once(KT_DIR .'/plugins/quicklinks/QuicklinkPermission.inc.php');

class QuicklinksDashlet extends KTBaseDashlet {
	var $oUser;
	
	function QuicklinksDashlet() {
        $this->sTitle = _kt('Quicklinks');
    }
	
	function is_active($oUser) {
		$this->oUser = $oUser;
		return true;
	}

	function render() {
		$oTemplating =& KTTemplating::getSingleton();
       	$oTemplate = $oTemplating->loadTemplate('Quicklinks/dashlet');
        
       	// In case there's some error.
       	$strError = '';
       	
       	// "We use the cache here as showing the dashboard must be fast." 
       	// I'd love to use the cache but it has turned out that the cache
       	// implementation does not create a different entrie for each query
       	// but only for each class (ie. Quicklink)!! (well, to be fair, for
       	// each class and page, if we were paging...)
        $aQuicklinks =& Quicklink::getList('location = '. QUICKLINK_LOC_DASHLET, 
                                               array('cache' => false));
		
		// Check for errors.
        if (PEAR::isError($aQuicklinks)) { 
        	$strError = _kt('The tables of the database are not working properly.');
        }
        elseif (!count($aQuicklinks)) {
        	$strError = _kt('There are no quicklinks.');
        }
        else if (QUICKLINK_OPT_CHECK_PERMISSION) {
		    // Clear all elements on which the user has not got read permission.
		    QuicklinkPermission::checkQuicklinksPermissions($aQuicklinks, $this->oUser);
		}
        
        // Build the template data.
		$aTemplateData = array(
			'context' => $this,
		    'quicklinks_items' => $aQuicklinks,
		    'error_msg' => $strError,
		);
      
        return $oTemplate->render($aTemplateData);
    }
}

?>
