<?php

/**
 *
 * The contents of this file are subject to the KnowledgeTree Public
 * License Version 1.1.2 ("License"); You may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.knowledgetree.com/KPL
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
 * See the License for the specific language governing rights and
 * limitations under the License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by KnowledgeTree" logo and
 *    (ii) the KnowledgeTree copyright notice
 * in the same form as they appear in the distribution.  See the License for
 * requirements.
 * 
 * The Original Code is: KnowledgeTree Open Source
 * 
 * The Initial Developer of the Original Code is The Jam Warehouse Software
 * (Pty) Ltd, trading as KnowledgeTree.
 * Portions created by The Jam Warehouse Software (Pty) Ltd are Copyright
 * (C) 2007 The Jam Warehouse Software (Pty) Ltd;
 * All Rights Reserved.
 * Contributor( s): David Alfonso
 *
 */
 
 require_once(KT_DIR. '/plugins/quicklinks/Quicklink.inc.php');
 require_once(KT_DIR .'/plugins/quicklinks/QuicklinkPermission.inc.php');
 
 
 class QuicklinksPortlet extends KTPortlet {
    function QuicklinksPortlet() {
        parent::KTPortlet(_kt("Quicklinks"));
    }
    
    function render() {
        
        if ($this->oDispatcher->oDocument) {
            $aQuicklinks =& Quicklink::getList('location = '. QUICKLINK_LOC_DOCUMENT
                                               .' AND location_id = '.
                                               $this->oDispatcher->oDocument->getId(),
                                               array('cache' => false));
        }
        else if ($this->oDispatcher->oFolder) {
            $aQuicklinks =& Quicklink::getList('location = '. QUICKLINK_LOC_FOLDER
                                               .' AND location_id = '.
                                               $this->oDispatcher->oFolder->getId(),
                                               array('cache' => false));
        }
        else if (strstr($this->oDispatcher->classComponent, "search")) {
            $aQuicklinks =& Quicklink::getList('location = '. QUICKLINK_LOC_SEARCH,
                                               array('cache' => false));
            // FIXME: Why oUser is not filled if searching? 
            require_once(KT_LIB_DIR . '/security/Permission.inc');
            $this->oDispatcher->oUser =& User::get($_SESSION['userID']);
        }
        else
            return null;
            
        // Check for errors.
        if (PEAR::isError($aQuicklinks)) { 
        	$strError = _kt('The tables of the database are not working properly.');
        }
        else if (QUICKLINK_OPT_CHECK_PERMISSION) {
		    // Clear all elements on which the user has not got read permission.
		    QuicklinkPermission::checkQuicklinksPermissions($aQuicklinks, $this->oDispatcher->oUser);
		}
		
		// If there are no quicklinks we do not even show the portlet.
		if (!count($aQuicklinks)) {
        	return null;
        }
		
		$oTemplating =& KTTemplating::getSingleton();
        $oTemplate = $oTemplating->loadTemplate("Quicklinks/portlet");
        $aTemplateData = array(
            "context" => $this,
            "quicklink_items" => $aQuicklinks,
        );
        return $oTemplate->render($aTemplateData);
    }
}
 
 ?>