<?php

/**
 * $Id$
 *
 * Copyright (c) 2006 Jam Warehouse http://www.jamwarehouse.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; using version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 *
 * You can contact the copyright owner regarding licensing via the contact
 * details that can be found on the KnowledgeTree web site:
 *
 *         http://www.ktdms.com/
 */

require_once(KT_LIB_DIR . "/templating/templating.inc.php");
require_once(KT_LIB_DIR . "/util/ktutil.inc");
require_once(KT_LIB_DIR . "/dispatcher.inc.php");
require_once(KT_LIB_DIR . "/templating/kt3template.inc.php");
require_once(KT_LIB_DIR . "/widgets/reorderdisplay.inc.php");
require_once(KT_LIB_DIR . "/widgets/forms.inc.php");
require_once(KT_LIB_DIR . '/documentmanagement/Document.inc');
require_once(KT_LIB_DIR . '/foldermanagement/Folder.inc');
require_once(KT_DIR . '/plugins/quicklinks/Quicklink.inc.php');
require_once(KT_DIR . '/plugins/quicklinks/QuicklinkLocation.inc.php');
require_once(KT_DIR . '/plugins/ktcore/KTColumns.inc.php');


class QuicklinkSingleSelectionColumn extends AdvancedSingleSelectionColumn {
    // Constructor
    function QuicklinkSingleSelectionColumn() {
        parent::AdvancedSingleSelectionColumn();
    }
    
    // we can only select an element (whether document or folder).
    function renderData($aDataRow) {       
        $localname = $this->rangename . "data[elem]";

        if ($aDataRow["type"] === "folder") {
            if ($this->aOptions['select_folders'] == false)
                return '&nbsp;';
            $v = "F" . $aDataRow["folderid"];
        }
        else if (($aDataRow["type"] === "document")) {
            if ($this->aOptions['select_documents'] == false)
                return '&nbsp;';
            $v = "D" . $aDataRow["docid"]; 
        } else { 
            return '&nbsp;';
        }

        // FIXME: This doesn't work although it's not vital...
        $sCurrent = KTUtil::arrayGet($_REQUEST, $localname);
        if ($sCurrent === $v)
            return '<input type="radio" name="' . $localname . '" value="' . $v . '" selected="selected" />';
        else
            return '<input type="radio" name="' . $localname . '" value="' . $v . '"/>';
    }
}



class ManageQuicklinksDispatcher extends KTAdminDispatcher {
 
    function form_new() {       
        // Let's build the form.
        $oForm = new KTForm;
        
        $oForm->setOptions(array(
            'label' => _kt("Details"),
            'action' => 'new2',
            'fail_action' => 'new',
            'context' => &$this,
            'identifier' => 'bd.Quicklinks.forms.new',
            'submit_label' => _kt("Create Quicklink"),
        ));
                
        // Don't call getResults() here!! Let the widget->render() function do it...
        //$oCollection->getResults();
   
        $oForm->setWidgets(array(
            // FIXME: I couldn't find a better way to do this... the only other
            // option is subclassing AdvancedCollection and create a customized
            // widget... I've done this to be able to indicate the error if the
            // user doesn't select an element of the collection.
            array('ktcore.widgets.hidden', array(
                'name' => 'elem',
                'required' => false,
                'value' => '')),
            array('ktcore.widgets.collection', array(
                'label' => _kt('Document or folder to link'),
                'description' => _kt('<p>Select the element to which the link will point to:</p>'),
                'required' => true,
                'name' => 'browse',
                'folder_id' => 1,
                'collection' => $this->_get_browsing_collection())),
            array('ktcore.widgets.selection', array(
                'label' => _kt('Location'),
                'description' => _kt('<p>Select the location where the quicklink will be shown.</p>'),
                'name' => 'location',
                'required' => true,
                'value' => 1,
                'vocab' => QuicklinkLocation::getLocations())),
        ));

        // Validators must be used to generate results after validating.
        $oForm->setValidators(array(
            // Selected element in the browse widget
            array('ktcore.validators.required', array('test' => 'elem')),
            array('ktcore.validators.string', array(
                'test' => 'elem',
                'output' => 'elem')),
            
            // Location
            array('ktcore.validators.string', array(
                'test' => 'location',
                'output' => 'location')),         
        ));
        
        return $oForm;
    }
    
    function form_new2($sLinkElem, $iLocation = 0) {       
        // Let's build the form.
        $oForm = new KTForm;
        
        $oForm->setOptions(array(
            'label' => _kt("Details"),
            'action' => 'new3',
            'fail_action' => 'new3',
            'context' => &$this,
            'identifier' => 'bd.Quicklinks.forms.new2',
            'submit_label' => _kt("Create Quicklink"),
        ));
        
        if (!$iLocation)
            $oCol =& $this->_get_browsing_collection(true, true);
        else
            $oCol =& $this->_get_browsing_collection($iLocation == QUICKLINK_LOC_FOLDER, 
                                                    $iLocation == QUICKLINK_LOC_DOCUMENT);
        
        $oForm->setWidgets(array(
            // FIXME: I couldn't find a better way to do this... the only other
            // option is subclassing AdvancedCollection and create a customized
            // widget... I've done this to be able to indicate the error if the
            // user doesn't select an element of the collection.
            array('ktcore.widgets.hidden', array(
                'name' => 'elem',
                'required' => false,
                'value' => '')),
            array('ktcore.widgets.hidden', array(
                'name' => 'link_elem',
                'value' => sanitizeForHTML($sLinkElem))),
            array('ktcore.widgets.hidden', array(
                'name' => 'link_location',
                'value' => sanitizeForHTML($iLocation))),
            array('ktcore.widgets.collection', array(
                'label' => _kt('Location of the link'),
                'description' => _kt('<p>Select the element in which the link will appear:</p>'),
                'required' => true,
                'name' => 'browse',
                'folder_id' => 1,
                'collection' => $oCol)),
        ));

        // Validators must be used to generate results after validating.
        $oForm->setValidators(array(
            // Selected element in the browse widget
            array('ktcore.validators.required', array('test' => 'elem')),
            array('ktcore.validators.string', array(
                'test' => 'elem',
                'output' => 'elem')),
            // Linked element
            array('ktcore.validators.string', array(
                'test' => 'link_elem',
                'output' => 'link_elem')),
            // Link location
            array('ktcore.validators.string', array(
                'test' => 'link_location',
                'output' => 'link_location')),                     
        ));
        
        return $oForm;
    }
 
    // MAIN //
    function do_main() {
        $this->aBreadcrumbs[] = array('url' => $_SERVER['PHP_SELF'], 'name' => _kt('Manage Quicklinks'));	
        $oTemplating =& KTTemplating::getSingleton();
        $oTemplate = $oTemplating->loadTemplate('Quicklinks/managequicklinks');

        // Don't use the cache. We need the current set of links.
        $aQuicklinks =& Quicklink::getList(null, array('cache' => false));
        
        if (PEAR::isError($aQuicklinks)) {
            $this->addErrorMessage(_kt('Problem retrieving quicklinks'));
        }
        else {
            // FIXME: Temporal solution to avoid nonexistent folder problems.
            foreach ($aQuicklinks as $k => $oQuickLink) {
                if (!$oQuickLink->isValid()) {
                    $oQuickLink->delete();
                    unset($aQuicklinks[$k]);
                }
            }
            
            $aTemplateData = array('context' => &$this,
                'quicklink_items' => $aQuicklinks);
        }
        
        //return $this->getData();
        return $oTemplate->render($aTemplateData);
    }

    // DELETE //
    function do_delete(){
       $iQuicklinkId = KTUtil::arrayGet($_REQUEST, 'quicklink_id');
       $oQuicklink = $this->oValidator->validateEntity('Quicklink', $iQuicklinkId);
       $sLinkName = '';
       
       if($oQuicklink->getIsFolder()){
       		//удаление ярлыка папки из папки
       		$Folder = new Folder();
       		$oFolders = $Folder->getByParentId($oQuicklink->getLocationId());
       		foreach ($oFolders as $oFolder){
       			if($oFolder->getLinkedFolderId() == $oQuicklink->getTargetId()){
       				$idShortcut = $oFolder->getID();
       				break;
       			}
       		}

       		KTFolderUtil::deleteSymbolicLink($idShortcut, $user = null);
       		
       		$sLinkName = $Folder->getFolderName($idShortcut)._kt(' => ').$Folder->getFolderName($oFolder->getParentID());
       }else{
       		//удаление ярлыка документа из папки 
			$oDocument = new Document();
			$oShortcut =  $oDocument->getByFolderIDAndLinkedDocumentID($oQuicklink->getLocationId() ,$oQuicklink->getTargetId());
			
			KTDocumentUtil::deleteSymbolicLink($oShortcut->getId(), $user = null);
			
			$Folder = new Folder();
			$sLinkName = $oShortcut->getFileName()._kt(' => ').$Folder->getFolderName($oQuicklink->getLocationId());
       }
       
       $res = $oQuicklink->delete();
       
       if (PEAR::isError($res)) { 
            $this->errorRedirectToMain(sprintf(_kt('Unable to delete item: %s'), $res->getMessage())); 
       }else{
            $this->successRedirectToMain(sprintf(_kt('Quicklink deleted') . ': ' .$sLinkName));
       }
    }
    
    // NEW // страница создание ссылок
    function do_new() {
        $this->aBreadcrumbs[] = array('url' => $_SERVER['PHP_SELF'], 'name' => _kt('Manage Quicklinks'));	
        $this->oPage->setBreadcrumbDetails(_kt("Create new quicklink"));
        $this->oPage->setTitle(_kt("Create a new quicklink"));
        
        $oForm = $this->form_new();
        
        return $oForm->renderPage(_kt('New Quicklink'), 
                                  _kt('By using this form you can create a new quicklink to a folder or document which will appear in a dashlet, a folder, a document or in every search result. Only users allowed to access the linked element will be able to see the quicklink.'));
    }
    
    // NEW2 //после того как выбрали что и с чем связывать
    function do_new2() {
        $oForm = $this->form_new();
        $res = $oForm->validate();
        if (!empty($res['errors'])) {
            $oForm->handleError();
        }
        $res = $res['results'];
        
        // Check if what kind of element has been selected.
        if (!$this->_is_folder($res['elem']) && !$this->_is_document($res['elem']))
            $this->errorRedirectToMain(_kt('The parameters to create the link are incorrect.'));
               
        // Let's validate the element selected.
        $this->_validate_element($res['elem']);
        
        // Get the location.
        $location = intval($res['location']);
        
        switch($location)
        {
        case QUICKLINK_LOC_DASHLET: // Dashlet
        case QUICKLINK_LOC_SEARCH: // Search Results
            $oQuicklink = Quicklink::createFromArray(array(
                'isfolder' => $this->_is_folder($res['elem']),
                'targetid' => $this->_get_id($res['elem']),
                'position' => Quicklink::getNextPosition(),
                'active' => true,
                'location' => $location,
                'locationisfolder' => 0,
                'locationid' => 0,
                ));
        
            if (PEAR::isError($oQuicklink))
                $this->errorRedirectToMain(_kt('Could not create quicklink'));
        
            $this->successRedirectToMain(_kt('Created new quicklink'));
            break;
        case QUICKLINK_LOC_DOCUMENT:
        case QUICKLINK_LOC_FOLDER:
            // TODO: Find a way to avoid generating form_new2 in two places.
            $this->aBreadcrumbs[] = array('url' => $_SERVER['PHP_SELF'], 'name' => _kt('Manage Quicklinks'));	
            $this->oPage->setBreadcrumbDetails(_kt("Create new quicklink - Select Location"));
            $this->oPage->setTitle(_kt("Create a new quicklink"));

            $oForm = $this->form_new2($res['elem'], $location);
        
            return $oForm->renderPage(_kt('New Quicklink - Select location'), 
                                  _kt('After choosing the type of location, you should select the exact place where the link will appear.'));
        default:
            $this->successRedirectToMain(_kt('Location not implemented yet'));               
        }
    }
    
    // NEW3 // непосредственно создаине связи
    function do_new3() {
    	$raw_data = KTUtil::arrayGet($_REQUEST, 'data');

    	$oForm = $this->form_new2($raw_data['link_elem'],
    	$raw_data['link_location']);
    	$res = $oForm->validate();

    	if (!empty($res['errors'])) {
    		$this->aBreadcrumbs[] = array('url' => $_SERVER['PHP_SELF'], 'name' => _kt('Manage Quicklinks'));
    		$this->oPage->setBreadcrumbDetails(_kt("Create new quicklink - Select Location"));
    		$this->oPage->setTitle(_kt("Create a new quicklink"));

    		return $oForm->renderPage(_kt('New Quicklink - Select location'),
    		_kt('After choosing the type of location, you should select the exact place where the link will appear.'));
    	}
    	$res = $res['results'];

    	// Create the link at last!
    	$oQuicklink = Quicklink::createFromArray(array(
    		'isfolder' => $this->_is_folder($res['link_elem']),
    		'targetid' => $this->_get_id($res['link_elem']),
    		'position' => Quicklink::getNextPosition(),
    		'active' => true,
    		'location' => $res['link_location'],
    		'locationisfolder' => $this->_is_folder($res['elem']),
    		'locationid' => $this->_get_id($res['elem']),
    	));

    	// тут создание ссылки из папки в папку 
    	if($this->_is_folder($res['link_elem']) && $this->_is_folder($res['elem'])){
    		$targetFolder = $this->_get_id($res['elem']);
    		$sourceFolder = $this->_get_id($res['link_elem']);
    		KTFolderUtil::createSymbolicLink($sourceFolder, $targetFolder, $user = null);
    	}
    	// тут создание ссылки документов в папку 
    	if($this->_is_document($res['link_elem']) && $this->_is_folder($res['elem'])){
    		$targetFolder = $this->_get_id($res['elem']);
    		$sourceDocument = $this->_get_id($res['link_elem']);
    		KTDocumentUtil::createSymbolicLink($sourceDocument, $targetFolder, $user = null);
    	}

    	if (PEAR::isError($oQuicklink))
    	$this->errorRedirectToMain(_kt('Could not create quicklink'));

    	$this->successRedirectToMain(_kt('Created new quicklink'));
    }
    
    function createLinkedFolders($aOptions){
    	return KTEntityUtil::createFromArray('folders', $aOptions);
    }
    
    
    // REORDER // 
    function do_reorder() {
	    $this->aBreadcrumbs[] = array('url' => $_SERVER['PHP_SELF'], 'name' => _kt('Edit Quicklinks'));	
        $this->oPage->setBreadcrumbDetails(_kt("Re-order Quicklinks"));
        $this->oPage->setTitle(_kt("Re-order Quicklinks"));

        $aQuicklinks = array();
        $aQuickLinksList = Quicklink::getList();
        
        if(PEAR::isError($aQuickLinksList)) {
            $this->redirectToMain();
            exit(0);
        }
        
        foreach($aQuickLinksList as $item) {
        	$aQuicklinks[] = array('title' => $item->getName(), 'id' => $item->getId());
        }

        $reorderDisplay = new ReorderDisplay($aQuicklinks);
        $reorderDisplay->render();

        $oTemplate =& $this->oValidator->validateTemplate('Quicklinks/reorderquicklinks');
        $aTemplateData = array(
            'reorderdisplay' => $reorderDisplay
        );
        return $oTemplate->render($aTemplateData);                  

        exit(0);
    }
    
    // FINALISE_REORDER //
    function do_finalise_reorder() {
        $aIds = KTUtil::arrayGet($_REQUEST, 'id');
        $aPositions = KTUtil::arrayGet($_REQUEST, 'position');		
        $aResults = array();

        $debug = false;
        
        foreach($aIds as $k => $v) {
            $aResults[$v] = $aPositions[$k];
        }
                
        if($debug) {
            print "<pre>";
            print_r($aIds);
            print_r($aPositions);
            print_r($aResults);
            print "</pre>";
        }
                
        $aQuicklinks = Quicklink::getList();
        if(PEAR::isError($aQuicklinks)) {
            $this->errorRedirectToMain(_kt('Problem retrieving quicklinks'));
            exit(0);
        }
        
        $this->startTransaction();
        foreach($aQuicklinks as $oQuicklink) {
            if($debug) print "Setting position on quicklink ID " . $oQuicklink->getId() . " to " . $aResults[$oQuicklink->getId()] . "<br/>";
            $oQuicklink->setPosition($aResults[$oQuicklink->getId()]);
            
            $res = $oQuicklink->update();
            if(PEAR::isError($res)) {
                $this->errorRedirectToMain(_kt('Error re-ordering quicklinks'));
                exit(0);
            }
        }		
        $this->commitTransaction();
        
        if(!$debug) $this->successRedirectToMain(_kt('Re-ordered quicklinks'));
        exit(0);
    }
    
    function &_get_browsing_collection($bSelectFolders = true, $bSelectDocuments = true) {
        // Setup the collection 
        $oCollection =& new AdvancedCollection();
        $oCR =& KTColumnRegistry::getSingleton();
        
        $oCol = $oCR->getColumn('bd.Quicklinks.columns.selection');
        $oCol->setOptions(array('select_folders' => $bSelectFolders,
                                'select_documents' => $bSelectDocuments));
        $oCollection->addColumn($oCol);
        
        $oCol = $oCR->getColumn('ktcore.columns.title');
        $oCol->setOptions(array('link_documents' => false));
        $oCollection->addColumn($oCol);

        // FIXME: show_documents is not working because KTWidgets::do_main() 
        // is deleting every previous option that getEnvironOptions() is not 
        // aware of.
        $oCollection->setOptions(array_merge(array('show_documents' => $bSelectDocuments),
                                             $oCollection->getEnvironOptions()));
        
        $qObj = new BrowseQuery(1);
        $oCollection->setQueryObject($qObj);
        
        return $oCollection;
    }
    
    function _validate_element($sElem) {
        if ($this->_is_folder($sElem)) {
            // FIXME: We could use the collection created for the form...
            $oElem = Folder::get($this->_get_id($sElem));
            if (PEAR::isError($oElem))
                $this->errorRedirectToMain(_kt('The selected folder doesn\'t exist'));
        }
        else {
            // FIXME: We could use the collection created for the form...
            $oElem = Document::get($this->_get_id($sElem));
            if (PEAR::isError($oElem))
                $this->errorRedirectToMain(_kt('The selected document doesn\'t exist'));
        }
    }
    
    function _is_folder($sElem) {
        return $sElem[0] == 'F';
    }
    
    function _is_document($sElem) {
        return $sElem[0] == 'D';
    }
    
    function _get_id($sElem) {
        // Get the id of the element.
        return intval(substr($sElem, 1));
    }
}

?>