<?php

require_once(KT_LIB_DIR . '/dashboard/dashlet.inc.php');
require_once(KT_LIB_DIR . '/security/Permission.inc');

require_once 'include/um_config.php';
require_once 'include/process.php';
require_once 'include/helpers.php';
require_once 'include/message_store.php';  
  
class UpdatesAndMessages extends KTBaseDashlet{
    private $config;    
    private $news;
    
    function UpdatesAndMessages(){ 
        $this->config = UM_Config::singleton();        
        if ($this->config->dashlet_type == 1)
            $this->sTitle = _kt('Application Updates');                
        else
            $this->sTitle = _kt('Update News');                
        
        $main = $GLOBALS['main'];
        $main->requireCSSresource('plugins/updatesandmessages/style/styles.css');
        $main->requireJSresource('plugins/updatesandmessages/js/updatesandmessages.js');
    }

    function is_active($oUser){    
        if ($this->config->allowed_by_session)
           $_SESSION['ns_view_allowed'] = Permission::userIsSystemAdministrator($_SESSION['userID']); // dashlet will be displayed to admin users 
        $visible = false;
        switch($this->config->dashlet_type){
          case 1:
            $visible = ($this->config->allowed_by_session ? $_SESSION['ns_view_allowed'] : true) ;
            break;
          case 0:
            if ($this->config->allowed_by_session == false || $_SESSION['ns_view_allowed']){
                $visible = !($this->config->hide_without_news);
                $ud = MessageStore::singleton();
                if (array_key_exists('archive_news', $_GET) || array_key_exists('archive_news', $_POST))
                    $ud->archiveNews();
                else if ( ($this->news = $ud->getNews()) && $this->news->isActive() && !$this->news->isArchived())             
                    $visible = true;                
            }
        }            
        return $visible;
    }
    
    function render() {     
        $result =  '<div id="UpdatesAndMessagesBody">';
        switch($this->config->dashlet_type){
          case 1:
            $result .= '<div class="notice">'.update_client_process().'</div>';
            if (array_key_exists('update_client_do',$_GET) || !array_key_exists('update_client_id',$_GET)){
                 $result .= showList();
            }else{
                $id = $_GET['update_client_id'];
                $result .= showContent($id);
            }                         
            break;
          case 0:
            if ($this->news && $this->news->isActive() && !$this->news->isArchived())
                $result .= showNews($this->news);
            else
                $result .= "<p>No new messages</p>";
        }
        $result .= '</div><br>';          
        return $result;
    }
}
?>
