<?php

/**
 *
 * process.php,   The BitRock Update Server PHP API
 *
 * Processing requests from the client
 *
 * @author BitRock www.BitRock.com
 *
 */

require_once "message_store.php"; 

/**
 * Performs the appropiate operations to execute the request
 */
function update_client_process(){
    $ud = MessageStore::singleton();

    try{
        if (array_key_exists('update_client_do', $_GET)){
            switch ( $_GET['update_client_do'] ) { 
            case "mark_as_read":
                $m = $ud -> getNotification($_GET['update_client_id']);
                $m -> markAsRead();
                $ud -> saveNotification($m);
                break;
    
            case "mark_all_as_not_read":
                $messages = $ud -> getNotification();
                foreach ( $messages as $m ) {
                    $m  -> markAsNotRead();
                    $ud -> saveNotification($m);
                }
                break;
    
            case "archive":
                $m = $ud -> getNotification($_GET['update_client_id']);
                $m -> markAsArchived();
                $ud -> saveNotification($m);
                break;
    
            case "not_archive":
                $m = $ud -> getNotification($_GET['update_client_id']);
                $m -> markAsNotArchived();
                $ud -> saveNotification($m);   
                break;
                
            case "archive_news":
                $m = $ud -> archiveNews();                
            }
        }else if (array_key_exists('update_client_do_selection', $_POST) && array_key_exists('update_client_selection',$_POST)){    
            $selection = $_POST['update_client_selection'];
            switch($_POST['update_client_do_selection']){
            case "markasread":
                foreach ($selection as $s){
                    $m = $ud -> getNotification($s);
                    $m -> markAsRead();
                    $ud -> saveNotification($m);
                }
                break;
            case "keepnew":
                foreach ($selection as $s){
                    $m = $ud -> getNotification($s);
                    $m -> markAsNotRead();
                    $ud -> saveNotification($m);          
                }
                break;
            case "archive":
                foreach ($selection as $s){
                    $m = $ud -> getNotification($s);
                    $m -> markAsArchived();
                    $ud -> saveNotification($m);
                }
            }
        }
    } catch (Exception $e) {
        return $e -> getMessage();
    }
    return $ud->getNotice();
}
?>
