<?php

/**
 * Configuration, The BitRock Update Server PHP API
 *
 * Implementation of ....
 *
 * @author BitRock www.BitRock.com
 * @version 0.1
 * @package MessageStore
 *
 */
  
require_once 'um_database.php';
require_once 'read_profile.php';

class UM_Config{
    private static $instance;
    
    public static $db_name;
    public static $db_user;
    public static $db_host;
    public static $db_pass;
    public static $db_port;

    public static $notifications_table = "updates_and_messages_notifications";
    public static $config_table        = "updates_and_messages_config";
    public static $news_table          = "updates_and_messages_short_news";

    public static $visible_news_status = 1;    
    public static $removed_status = -1;

    public static $remove_unreceived_notifications  = false;
    public static $hide_dashlet_with_no_news        = false;
    public static $take_last_notification_as_news   = false;

    public $dashlet_type;
    public $profile;
    
    private $profile_to_dashlet = array('basic'=>0, 'pro'=>1, 'monitoring'=>1);    

    private function __construct() {
        $this->read_preferences();
        $this->profile = read_profile($this->preferences);        
        $this->dashlet_type = (array_key_exists($this->profile, $this->profile_to_dashlet) ? $this->profile_to_dashlet[$this->profile] : 0);
    }

    public static function singleton() {
        if (!isset(self::$instance)) {
            $c = __CLASS__;
            self::$instance = new $c;
        }
        return self::$instance;
    }

    public function allowed_by_session(){ $this -> preferences["allowed_by_session"]; }
    public function hide_without_news() { $this -> preferences["hide_without_news"];  }

    /**
    * Reads the stored preferences
    */
    private function read_preferences(){
        $db = UM_Database::singleton();  
        $result = $db->array_query("SELECT * FROM ".UM_Config::$config_table." LIMIT 1");
        if (!empty($result))
            $this->preferences = $result[0];
    }
    
}

require "um_config_setup.php"; // Reads database paramenters for UM_Config class

?>
